####################
# Globals.com
####################
# settings for all layers
#------------------------

&if $SAPDB_VER >= 80
* vers80=true
&endif

*:variant(nothread) -nothread parentlinkoption=-nothread

# all pascal files deppend from "manipulated" ptoc.h
*p dep=:ptoc/ptoc.h

# special for Purify
*.cpp:variant(pfy) -DSAPDBMem_USE_SYSTEM_ALLOC -DUSE_SYSTEM_ALLOC_CO13
*x:variant(pfy)    -DSAPDBMem_USE_SYSTEM_ALLOC -DUSE_SYSTEM_ALLOC_CO13
*.c:variant(pfy)   -DSAPDBMem_USE_SYSTEM_ALLOC -DUSE_SYSTEM_ALLOC_CO13
*c:variant(pfy)    -DSAPDBMem_USE_SYSTEM_ALLOC -DUSE_SYSTEM_ALLOC_CO13
*p:variant(pfy)    -DSAPDBMem_USE_SYSTEM_ALLOC -DUSE_SYSTEM_ALLOC_CO13

# -Zi as default option
&if $OSSPEC in [ WIN32 ]
*.idl -multi_offset -CFLAGS=-Zi -CFLAGS=-DMsg_List=SAPDBErr_MessageList # suppress_uncond
*.cpp -Zi -DMsg_List=SAPDBErr_MessageList
*x    -Zi -DMsg_List=SAPDBErr_MessageList
*.c   -Zi
*c    -Zi
*p    -CFLAGS=-Zi
&elif $OSSPEC == LINUX && $MACH in [ S390X, IA64 ]
# LINUX GCC 3.2 has optimizer problems with C++ compilation.
*.idl -multi_offset -DMsg_List=SAPDBErr_MessageList # suppress_uncond
&if $MACH = IA64 && $__HAS_NPTL == 1
*.cpp -OPT=-O0 -DMsg_List=SAPDBErr_MessageList
*x -OPT=-O0 -DMsg_List=SAPDBErr_MessageList
*c -OPT=-O0 
*.c -OPT=-O0 
*p -OPT=-O0
&else
*.cpp -OPT=-O2 -DMsg_List=SAPDBErr_MessageList
*x    -OPT=-O2 -DMsg_List=SAPDBErr_MessageList
&endif
&else
*.idl -multi_offset -DMsg_List=SAPDBErr_MessageList # suppress_uncond
*.cpp -DMsg_List=SAPDBErr_MessageList
*x    -DMsg_List=SAPDBErr_MessageList
&endif

# until we have no compiler that allows us to detect all broken aliasing rules
# we must switch off strict aliasing optimization for gcc3.3 or higher....
&if $OSSPEC in [ LINUX, FREEBSD ]
*.cpp -fno-strict-aliasing
*x -fno-strict-aliasing
*.c -fno-strict-aliasing
*c -fno-strict-aliasing
*p -CFLAGS=-fno-strict-aliasing
&  if $__HAS_NPTL == 1
*.cpp -DHAS_NPTL
*x    -DHAS_NPTL
*.c   -DHAS_NPTL
*c    -DHAS_NPTL
*p    -CFLAGS=-DHAS_NPTL
&  endif
&endif

&if defined FORCED_SYMBOLDIR
* parentlinkoption=-symbol_dir=$FORCED_SYMBOLDIR
&endif
