#include "ConsistentRead/CnsRead_TransHistoryInfo.hpp"
#include "ConsistentRead/CnsRead_Manager.hpp"

CnsRead_TransHistoryInfo::CnsRead_TransHistoryInfo()
{
    otrBeforeRef_gg00.gg91SetNilRef();
    otrLockTransIndex_gg00 = cgg_nil_transindex;
    otrLockTransId_gg00.gg90SetNil();
    otrUpdTransId_gg00.gg90SetNil();
}

//-----------------------------------------------------------------------------

CnsRead_TransHistoryInfo::CnsRead_TransHistoryInfo(const tgg00_TransContext& currentTrans)
{
    otrBeforeRef_gg00.gg91SetNilRef();
    otrLockTransIndex_gg00 = currentTrans.trIndex_gg00;
    otrLockTransId_gg00    = currentTrans.trTransId_gg00;
    otrUpdTransId_gg00     = currentTrans.trWriteTransId_gg00;
}

//-----------------------------------------------------------------------------

bool CnsRead_TransHistoryInfo::IsRequired() const
{

    if (!CnsRead_Manager::IsConsistentEnabled())
    {
        return false;
    }
    tgg91_TransNo minTrans = CnsRead_Manager::GetMinTrans();
    if (minTrans.gg90IsNil())
    {
        return true; // TODO change behavior of min trans ??
    }
    return (otrUpdTransId_gg00 >= minTrans);
}

//-----------------------------------------------------------------------------

void CnsRead_TransHistoryInfo::SetBeforeRef (const tgg91_PageRef& beforeRef)
{
    otrBeforeRef_gg00 = beforeRef;
}