#include "ggg00.h"
#include "DataAccess/Data_RecordHeaderAccess.h"
#include "ConsistentRead/CnsRead_CachedRow.hpp"

int Data_DeRefKeyLen(tgg00_Rec* pRec)
{
    return reinterpret_cast<CnsRead_CachedRow*>(pRec)->GetKeyLen();
}

int Data_DeRefRecLen(tgg00_Rec* pRec)
{
    return reinterpret_cast<CnsRead_CachedRow*>(pRec)->GetRecLen();
}

inline static bool IsSwizzledPointer(void* pRec)
{
    return (((unsigned char*) pRec)[HI_BYTE] & 0x80) != 0;
}

int Data_GetRecLen(void* pRec)
{
    return (IsSwizzledPointer(pRec)) ? Data_DeRefRecLen((tgg00_Rec*) pRec) : ((tgg00_Rec*) pRec)->recLen_gg00();
}

int Data_GetKeyLen(void* pRec)
{
    return (IsSwizzledPointer(pRec)) ? Data_DeRefKeyLen((tgg00_Rec*) pRec) : ((tgg00_Rec*) pRec)->recKeyLen_gg00();
}

int Data_GetVarcolOffset(void* pRec)
{
    return ((tgg00_Rec*) pRec)->recVarcolOffset_gg00();
}

int Data_GetVarcolCount(void* pRec)
{
    return ((tgg00_Rec*) pRec)->recVarcolCnt_gg00();
}