/*
        ========== licence begin  GPL
        Copyright (C) 2005 SAP AG

        This program is free software; you can redistribute it and/or
        modify it under the terms of the GNU General Public License
        as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
        ========== licence end
 */
#ifndef KERNEL_MESSAGES_HPP
#define KERNEL_MESSAGES_HPP

// Generated Header file Kernel_Messages.hpp.
// Generated by genmsg V2.2 DO NOT EDIT

#include "SAPDBCommon/ErrorsAndMessages/SAPDBErr_MessageList.hpp"

#define KERNEL_ERR_PAGE_BAD_INPUT                   SAPDBErr_MessageList::Error,0,"Page check failed; algorithm: %s, calculated: %s, header: %s, trailer: %s",4
#define KERNEL_ERR_PAGE_BAD_INPUT_ID 0
#define KERNEL_ERR_PAGE_BAD_OUTPUT                  SAPDBErr_MessageList::Error,1,"Page check failed; header: %s, trailer: %s",2
#define KERNEL_ERR_PAGE_BAD_OUTPUT_ID 1
#define KERNEL_ERR_OPEN_FAILED                      SAPDBErr_MessageList::Error,2,"The opening of file %s failed because of %s",2
#define KERNEL_ERR_OPEN_FAILED_ID 2
#define KERNEL_ERR_PAGE_BAD_VERIFY                  SAPDBErr_MessageList::Error,3,"Parity mismatch; header: %s, trailer: %s",2
#define KERNEL_ERR_PAGE_BAD_VERIFY_ID 3
#define KERNEL_ERR_HEADER_TRAILER_MISMATCH          SAPDBErr_MessageList::Error,4,"HEADER/TRAILER mismatch",0
#define KERNEL_ERR_HEADER_TRAILER_MISMATCH_ID 4
#define KERNEL_ERR_HEADER_INFO                      SAPDBErr_MessageList::Error,5,"HEADER : Id %s %s - %s - %s -%s",5
#define KERNEL_ERR_HEADER_INFO_ID 5
#define KERNEL_ERR_TRAILER_INFO                     SAPDBErr_MessageList::Error,6,"TRAILER: Id %s %s - %s - %s -%s",5
#define KERNEL_ERR_TRAILER_INFO_ID 6
#define KERNEL_ERR_ALLOCATE_FAILED                  SAPDBErr_MessageList::Error,7,"Memory allocation failed.",0
#define KERNEL_ERR_ALLOCATE_FAILED_ID 7
#define KERNEL_EMERGENCY_SHUTDOWN                   SAPDBErr_MessageList::Error,8,"%s, %s",2
#define KERNEL_EMERGENCY_SHUTDOWN_ID 8
#define KERNEL_UNTILDATE_TOO_OLD                    SAPDBErr_MessageList::Error,9,"UNTIL DATE is older than last savepoint (%s %s)",2
#define KERNEL_UNTILDATE_TOO_OLD_ID 9
#define KERNEL_ENTER_CRITICAL_STATE_FAILED          SAPDBErr_MessageList::Error,10,"Admin command cannot enter critical state '%s'",1
#define KERNEL_ENTER_CRITICAL_STATE_FAILED_ID 10
#define KERNEL_INIT_STANDBY_NOT_ALLOWED             SAPDBErr_MessageList::Error,11,"'INIT STANDBY' not for own '%s' = master '%s'",2
#define KERNEL_INIT_STANDBY_NOT_ALLOWED_ID 11
#define KERNEL_STANDBY_NODELIST_OP_FAILED           SAPDBErr_MessageList::Error,12,"'%s' internal list operation failed for '%s'",2
#define KERNEL_STANDBY_NODELIST_OP_FAILED_ID 12
#define KERNEL_STANDBY_SEND_TO_NODE_FAILED          SAPDBErr_MessageList::Error,13,"'%s' sending command to node '%s' failed",2
#define KERNEL_STANDBY_SEND_TO_NODE_FAILED_ID 13
#define KERNEL_RESTART_FILESYSTEM_FAILED            SAPDBErr_MessageList::Error,14,"RestartFilesystem failed with '%s'",1
#define KERNEL_RESTART_FILESYSTEM_FAILED_ID 14
#define KERNEL_PREPARE_LOGINFO_PAGE_FOR_READ_FAILED SAPDBErr_MessageList::Error,15,"Could not open log info page for read.",0
#define KERNEL_PREPARE_LOGINFO_PAGE_FOR_READ_FAILED_ID 15
#define KERNEL_RESET_READONLY_FAILED                SAPDBErr_MessageList::Error,16,"Reset data readonly state failed with '%s'",1
#define KERNEL_RESET_READONLY_FAILED_ID 16
#define KERNEL_UNHANDLED_MESSAGES                   SAPDBErr_MessageList::Error,17,"List of unhandled messages above.",0
#define KERNEL_UNHANDLED_MESSAGES_ID 17
#define KERNEL_RESTART_FOR_STANDBY_NOT_ALLOWED      SAPDBErr_MessageList::Error,18,"RESTART for standby not allwowed, because master is active.",0
#define KERNEL_RESTART_FOR_STANDBY_NOT_ALLOWED_ID 18
#define KERNEL_CHECK_HOTSTANDBY_CONFIG              SAPDBErr_MessageList::Error,19,"RTEHSS_KernelInterface::CheckForValidHotStandbyConfiguration() returned 'InvalidConfiguration'",0
#define KERNEL_CHECK_HOTSTANDBY_CONFIG_ID 19
#define KERNEL_UNTILIOSEQ_TOO_OLD                   SAPDBErr_MessageList::Error,20,"UNTIL IOSEQUENCE is older then last savepoint %s",1
#define KERNEL_UNTILIOSEQ_TOO_OLD_ID 20
#define KERNEL_ALREADY_ACTIVATED                    SAPDBErr_MessageList::Warning,21,"is already activated.",0
#define KERNEL_ALREADY_ACTIVATED_ID 21
#define KERNEL_ACTIVATE_IS_MISSING                  SAPDBErr_MessageList::Warning,22,"ACTIVATE is missing",0
#define KERNEL_ACTIVATE_IS_MISSING_ID 22
#define KERNEL_UNKNOWN_ACTIVATION_STATE             SAPDBErr_MessageList::Warning,23,"Unknown activation state '%s' found.",1
#define KERNEL_UNKNOWN_ACTIVATION_STATE_ID 23
#define KERNEL_RESTART_LOCKLIST_FAILED              SAPDBErr_MessageList::Warning,24,"Sql lock manager could not be initialized",0
#define KERNEL_RESTART_LOCKLIST_FAILED_ID 24
#define KERNEL_INIT_LOG_FAILED                      SAPDBErr_MessageList::Warning,25,"Initialization of log for '%s' failed with '%s'",2
#define KERNEL_INIT_LOG_FAILED_ID 25
#define KERNEL_REDO_ERROR                           SAPDBErr_MessageList::Warning,26,"Redo error '%s' occured",1
#define KERNEL_REDO_ERROR_ID 26
#define KERNEL_INIT_TERMSET_FAILED                  SAPDBErr_MessageList::Warning,27,"Termset initialization failed.",0
#define KERNEL_INIT_TERMSET_FAILED_ID 27
#define KERNEL_CREATE_ERROR_FILE_FAILED             SAPDBErr_MessageList::Warning,28,"Create of errorfile failed",0
#define KERNEL_CREATE_ERROR_FILE_FAILED_ID 28
#define KERNEL_SAVE_GOOD_FAILED                     SAPDBErr_MessageList::Warning,29,"Saving last known good config failed with '%s', '%s'.",2
#define KERNEL_SAVE_GOOD_FAILED_ID 29
#define KERNEL_ATTACH_LOGVOLUMES_ERROR              SAPDBErr_MessageList::Warning,30,"Error occured during open log volumes",0
#define KERNEL_ATTACH_LOGVOLUMES_ERROR_ID 30
#define KERNEL_ATTACH_DATAVOLUMES_ERROR             SAPDBErr_MessageList::Warning,31,"Error occured during open data volumes",0
#define KERNEL_ATTACH_DATAVOLUMES_ERROR_ID 31
#define KERNEL_CLEAR_LOG_ERROR                      SAPDBErr_MessageList::Warning,32,"Error '%s' occured during clear log volume",1
#define KERNEL_CLEAR_LOG_ERROR_ID 32
#define KERNEL_RESULT_NOT_OK                        SAPDBErr_MessageList::Warning,33,"Function '%s' failed with result=%s",2
#define KERNEL_RESULT_NOT_OK_ID 33
#define KERNEL_ENABLE_MIGRATION                     SAPDBErr_MessageList::Info,34,"Migration enabled for '%s'",1
#define KERNEL_ENABLE_MIGRATION_ID 34
#define KERNEL_SWITCHED_TO_ACTIVATED                SAPDBErr_MessageList::Info,35,"Database is activated",0
#define KERNEL_SWITCHED_TO_ACTIVATED_ID 35
#define KERNEL_SWITCHED_TO_ACTIVATED2               SAPDBErr_MessageList::Info,36,"Database is activated for log only recovery",0
#define KERNEL_SWITCHED_TO_ACTIVATED2_ID 36
#define KERNEL_REDO_LOG_FINISHED                    SAPDBErr_MessageList::Info,37,"Kernel state: 'REDO LOG' finished",0
#define KERNEL_REDO_LOG_FINISHED_ID 37
#define KERNEL_STATE_IS_ADMIN                       SAPDBErr_MessageList::Info,38,"Kernel state: 'ADMIN' reached",0
#define KERNEL_STATE_IS_ADMIN_ID 38
#define KERNEL_STATE_IS_ONLINE                      SAPDBErr_MessageList::Info,39,"Kernel state: 'ONLINE' reached",0
#define KERNEL_STATE_IS_ONLINE_ID 39
#define KERNEL_STATE_IS_OFFLINE                     SAPDBErr_MessageList::Info,40,"Kernel state: 'OFFLINE' reached",0
#define KERNEL_STATE_IS_OFFLINE_ID 40
#define KERNEL_INIT_STANDBY_START                   SAPDBErr_MessageList::Info,41,"Kernel state: 'INIT STANDBY' for master '%s' started",1
#define KERNEL_INIT_STANDBY_START_ID 41
#define KERNEL_NEW_STANDBY                          SAPDBErr_MessageList::Info,42,"Hotstandby: new standby on %s registered with offset %s",2
#define KERNEL_NEW_STANDBY_ID 42
#define KERNEL_STANDBY_REMOVED                      SAPDBErr_MessageList::Info,43,"Hotstandby: standby (%s) removed",1
#define KERNEL_STANDBY_REMOVED_ID 43
#define KERNEL_LAST_STANDBY_REMOVED                 SAPDBErr_MessageList::Info,44,"Hotstandby: last standby (%s) removed",1
#define KERNEL_LAST_STANDBY_REMOVED_ID 44
#define KERNEL_STANDBY_REGISTER                     SAPDBErr_MessageList::Info,45,"Hotstandby: register succeded; redo until offset %s",1
#define KERNEL_STANDBY_REGISTER_ID 45
#define KERNEL_SYNC_RECEIVED                        SAPDBErr_MessageList::Info,46,"HotStandby: Synchronize: redo until offset %s",1
#define KERNEL_SYNC_RECEIVED_ID 46
#define KERNEL_SYNCREPLY_RECEIVED                   SAPDBErr_MessageList::Info,47,"HotStandby: SynchronizeReply from %s offset %s received",2
#define KERNEL_SYNCREPLY_RECEIVED_ID 47
#define KERNEL_CRITICAL_STATE_NOT_ENTERED           SAPDBErr_MessageList::Info,48,"Could not enter critical state '%s'.",1
#define KERNEL_CRITICAL_STATE_NOT_ENTERED_ID 48
#define KERNEL_BASIS_ERROR_INFO                     SAPDBErr_MessageList::Info,49,"%s, Error occured: %s, '%s' (%s)",4
#define KERNEL_BASIS_ERROR_INFO_ID 49
#define KERNEL_HINT_HOTSTANDBY_CONFIG               SAPDBErr_MessageList::Info,50,"The database parameters are neither correctly configured for 'HotStandby' nor for 'Normal' operation.",0
#define KERNEL_HINT_HOTSTANDBY_CONFIG_ID 50
#define KERNEL_COMMAND_NOT_ALLOWED                  SAPDBErr_MessageList::Info,51,"'%s' is not allowed in mode '%s'.",2
#define KERNEL_COMMAND_NOT_ALLOWED_ID 51
#define DEVTEST_TRY_LOCK_OBJ                        SAPDBErr_MessageList::Info,52,"COLLISION LIST OUTPUT TEST: TR%s TRIES TO LOCK OBJECT %s.%s => %s",4
#define DEVTEST_TRY_LOCK_OBJ_ID 52
#define DEVTEST_LIST_OBJ_COLLS_BEGIN                SAPDBErr_MessageList::Info,53,"COLLISION LIST OUTPUT TEST: Object Collisionlist Begin",0
#define DEVTEST_LIST_OBJ_COLLS_BEGIN_ID 53
#define DEVTEST_LIST_OBJ_COLLS                      SAPDBErr_MessageList::Info,54,"** %s TR%s %s.%s.%s",5
#define DEVTEST_LIST_OBJ_COLLS_ID 54
#define DEVTEST_LIST_OBJ_COLLS_END                  SAPDBErr_MessageList::Info,55,"COLLISION LIST OUTPUT TEST: Object Collisionlist End",0
#define DEVTEST_LIST_OBJ_COLLS_END_ID 55

#endif /* KERNEL_MESSAGES_HPP */
