/*
        ========== licence begin  GPL
        Copyright (C) 2004 SAP AG

        This program is free software; you can redistribute it and/or
        modify it under the terms of the GNU General Public License
        as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
        ========== licence end
 */
#ifndef LOG_MESSAGES_HPP
#define LOG_MESSAGES_HPP

// Generated Header file Log_Messages.hpp.
// Generated by genmsg V2.2 DO NOT EDIT

#include "SAPDBCommon/ErrorsAndMessages/SAPDBErr_MessageList.hpp"

#define LOG_NO_INFOPAGE_UPD                          SAPDBErr_MessageList::Info,0,"no update of LogInfoPage: DeviceState = %s, LogIsEmpty = %s",2
#define LOG_NO_INFOPAGE_UPD_ID 0
#define LOG_IS_FULL                                  SAPDBErr_MessageList::Info,1,"Log is full.",0
#define LOG_IS_FULL_ID 1
#define LOG_SEQUENCE_NOT_FOUND                       SAPDBErr_MessageList::Info,2,"Expected ioseq %s, found %s-%s on off %s",4
#define LOG_SEQUENCE_NOT_FOUND_ID 2
#define LOG_SEQUENCE_NOT_IN_RANGE                    SAPDBErr_MessageList::Info,3,"Ioseq %s not on device. Greatest IOSeq is %s",2
#define LOG_SEQUENCE_NOT_IN_RANGE_ID 3
#define LOG_FORMATTING                               SAPDBErr_MessageList::Info,4,"Formatting from offset %s to %s.",2
#define LOG_FORMATTING_ID 4
#define LOG_RESTART_INFO                             SAPDBErr_MessageList::Info,5,"Restart from ioseq %s @ off %s to ioseq %s @ off %s",4
#define LOG_RESTART_INFO_ID 5
#define LOG_DEVICE_INFO_BASIC                        SAPDBErr_MessageList::Info,6,"%s queues, flushmode is '%s', devstate is '%s'",3
#define LOG_DEVICE_INFO_BASIC_ID 6
#define LOG_DEVICE_INFO_OLDEST_NOT_SAVED             SAPDBErr_MessageList::Info,7,"Oldest not saved is ioseq %s @ off %s",2
#define LOG_DEVICE_INFO_OLDEST_NOT_SAVED_ID 7
#define LOG_DEVICE_INFO_FIRST_KNOWN                  SAPDBErr_MessageList::Info,8,"First known on LogVolume is ioseq %s @ off %s",2
#define LOG_DEVICE_INFO_FIRST_KNOWN_ID 8
#define LOG_DEVICE_INFO_UNCOMPLETE_CYCLE             SAPDBErr_MessageList::Info,9,"LogVolume not completely written until now",0
#define LOG_DEVICE_INFO_UNCOMPLETE_CYCLE_ID 9
#define LOG_CHECK_RESULT                             SAPDBErr_MessageList::Info,10,"Result after checking the log device: '%s'",1
#define LOG_CHECK_RESULT_ID 10
#define LOG_ADD_DEVSPACE_PENDING                     SAPDBErr_MessageList::Info,11,"LogVolume was added: adjust size from %s to %s",2
#define LOG_ADD_DEVSPACE_PENDING_ID 11
#define LOG_ENTRY_INFO                               SAPDBErr_MessageList::Info,12,"%s#%s:TR%s(%s)[%s]@%s.%s'%s':%s:%s",10
#define LOG_ENTRY_INFO_ID 12
#define LOG_PAGE_REPAIRED                            SAPDBErr_MessageList::Info,13,"partly written LogPage repaired off=%s, ioseq=%s",2
#define LOG_PAGE_REPAIRED_ID 13
#define LOG_SAVEPOINT_FOUND                          SAPDBErr_MessageList::Info,14,"savepoint-iosequence %s searched and found on log at offset %s",2
#define LOG_SAVEPOINT_FOUND_ID 14
#define LOG_ABORTED_CLEAR_LOG                        SAPDBErr_MessageList::Warning,15,"Log is cleared again (was aborted).",0
#define LOG_ABORTED_CLEAR_LOG_ID 15
#define LOG_SAVE_FOR_ABORTED_CLEAR_LOG               SAPDBErr_MessageList::Warning,16,"Log is tried to be saved although clear has been aborted.",0
#define LOG_SAVE_FOR_ABORTED_CLEAR_LOG_ID 16
#define LOG_AUTOSAVE_ABORTED_HIST_LOST               SAPDBErr_MessageList::Warning,17,"(AUTO)SAVE LOG has been aborted due to missing backup history",0
#define LOG_AUTOSAVE_ABORTED_HIST_LOST_ID 17
#define LOG_SAVE_DENIED_AUTOOVERWRITE                SAPDBErr_MessageList::Warning,18,"(AUTO)SAVE LOG has been aborted due to log-auto-overwrite",0
#define LOG_SAVE_DENIED_AUTOOVERWRITE_ID 18
#define LOG_SAVE_DENIED_WRITING_OFF                  SAPDBErr_MessageList::Warning,19,"(AUTO)SAVE LOG has been aborted due to switched off logwriting",0
#define LOG_SAVE_DENIED_WRITING_OFF_ID 19
#define LOG_BACKUP_DISABLED                          SAPDBErr_MessageList::Warning,20,"Log backups are disabled",0
#define LOG_BACKUP_DISABLED_ID 20
#define LOG_PAGECHECK_FAILED                         SAPDBErr_MessageList::Warning,21,"LogPage at offset %s ioseq %s-%s should be repaired later on",3
#define LOG_PAGECHECK_FAILED_ID 21
#define LOG_LASTKNOWN_NOT_FOUND                      SAPDBErr_MessageList::Error,22,"LastKnown not found on log",0
#define LOG_LASTKNOWN_NOT_FOUND_ID 22
#define LOG_OLDEST_NOT_SAVED_NOT_FOUND               SAPDBErr_MessageList::Error,23,"OldestNotSaved not found on log",0
#define LOG_OLDEST_NOT_SAVED_NOT_FOUND_ID 23
#define LOG_SAVEPOINT_NOT_FOUND                      SAPDBErr_MessageList::Error,24,"Savepoint not found on log",0
#define LOG_SAVEPOINT_NOT_FOUND_ID 24
#define LOG_SAVEPOINT_IOSEQ_NOT_FOUND                SAPDBErr_MessageList::Error,25,"Savepoint-iosequence %s searched but not found on log",1
#define LOG_SAVEPOINT_IOSEQ_NOT_FOUND_ID 25
#define LOG_INCONSISTENT_SEQUENCE                    SAPDBErr_MessageList::Error,26,"iosequences on log volume are inconsistent.",0
#define LOG_INCONSISTENT_SEQUENCE_ID 26
#define LOG_CYCLE_NOT_FOUND                          SAPDBErr_MessageList::Error,27,"no cycle found on log",0
#define LOG_CYCLE_NOT_FOUND_ID 27
#define LOG_SAVEPOINT_SEQ_NOT_FOUND                  SAPDBErr_MessageList::Error,28,"Savepoint iosequence not found on log",0
#define LOG_SAVEPOINT_SEQ_NOT_FOUND_ID 28
#define LOG_DBIDENT_MISMATCH                         SAPDBErr_MessageList::Error,29,"DBIdentifier of DataVolume (%s) and LogVolume (%s) does not match",2
#define LOG_DBIDENT_MISMATCH_ID 29
#define LOG_HISTORY_LOST_NO_LOGSAVE_ALLOWED          SAPDBErr_MessageList::Error,30,"Backup of Log not allowed. Devicestate is %s.",1
#define LOG_HISTORY_LOST_NO_LOGSAVE_ALLOWED_ID 30
#define LOG_FREE_FAILED_PROT                         SAPDBErr_MessageList::Error,31,"Free LogPages failed: No save to pipe happened before",0
#define LOG_FREE_FAILED_PROT_ID 31
#define LOG_FREE_FAILED_IOSEQ                        SAPDBErr_MessageList::Error,32,"Free LogPages failed: Free IOSeqRange %s...%s but OldstNotSaved=%s",3
#define LOG_FREE_FAILED_IOSEQ_ID 32
#define LOG_FREEPIPE_FAILED_IOSEQ                    SAPDBErr_MessageList::Error,33,"Free LogPages after save to pipe failed: Wrong IOSeq (%s!=%s or %s!=%s)",4
#define LOG_FREEPIPE_FAILED_IOSEQ_ID 33
#define LOG_INVALID_LASTWRITABLE                     SAPDBErr_MessageList::Error,34,"HotStandby: SetLastWritable: Offset not on LogVolume %s",1
#define LOG_INVALID_LASTWRITABLE_ID 34
#define LOG_NOT_ENOUGH_PAGEFRAMES                    SAPDBErr_MessageList::Error,35,"Allocation of pageframe failed",0
#define LOG_NOT_ENOUGH_PAGEFRAMES_ID 35
#define LOG_REPAIR_PAGE_FAILED                       SAPDBErr_MessageList::Error,36,"repair logpage failed at %s (prevIOSeq %s, nextIOSeq %s)",3
#define LOG_REPAIR_PAGE_FAILED_ID 36
#define LOG_END_OF_LOG_EXPECTED                      SAPDBErr_MessageList::Error,37,"repair logpage failed: END_OF_LOG expected from pageCheck",0
#define LOG_END_OF_LOG_EXPECTED_ID 37
#define LOG_CONSISTENT_EXPECTED                      SAPDBErr_MessageList::Error,38,"repair logpage failed: CONSISTENT expected from pageCheck",0
#define LOG_CONSISTENT_EXPECTED_ID 38
#define LOG_AFTERIMAGE_INFO                          SAPDBErr_MessageList::Error,39,"%s: type=%s isdone=%s seq=%s TR%s",5
#define LOG_AFTERIMAGE_INFO_ID 39
#define LOG_BEFOREIMAGE_INFO                         SAPDBErr_MessageList::Error,40,"%s: type=%s state=%s CV%s prevUpdT%s prevstate=%s histref=%s.%s",8
#define LOG_BEFOREIMAGE_INFO_ID 40
#define LOG_ACTIONOBJECT_INFO                        SAPDBErr_MessageList::Error,41,"%s: oid=%s.%s:%s bodysize=%s keysize=%s",6
#define LOG_ACTIONOBJECT_INFO_ID 41
#define LOG_RESTORE_NEEDS_CLEARED_LOG                SAPDBErr_MessageList::Error,42,"Logrecovery is not allowed, because state of log volume is 'HistoryLost' (log must be cleared)",0
#define LOG_RESTORE_NEEDS_CLEARED_LOG_ID 42
#define LOG_SAVE_DISTANCE_TOO_SMALL                  SAPDBErr_MessageList::Error,43,"Parameter LOG_SEGMENT_SIZE is greater then size of log area. %s < %s + %s(seg size)",3
#define LOG_SAVE_DISTANCE_TOO_SMALL_ID 43
#define LOG_VOLUME_TOO_SMALL                         SAPDBErr_MessageList::Error,44,"Parameter LOG_IO_QUEUE may be too large or size of log area too small. %s < %s + %s(reserved), reserved = #queues=%s * qsize=%s",5
#define LOG_VOLUME_TOO_SMALL_ID 44
#define LOG_ACTION_FILE_INFO                         SAPDBErr_MessageList::Error,45,"%s: action=%s filename='%s'",3
#define LOG_ACTION_FILE_INFO_ID 45
#define LOG_NORMAL_END_FOUND                         SAPDBErr_MessageList::Info,46,"normal end of log found at off %s lastseq %s.",2
#define LOG_NORMAL_END_FOUND_ID 46
#define LOG_UNTIL_DATE_REACHED                       SAPDBErr_MessageList::Info,47,"until date reached at %s,%s (off = %s, lastseq = %s)",4
#define LOG_UNTIL_DATE_REACHED_ID 47
#define LOG_UNTIL_IOSEQ_REACHED                      SAPDBErr_MessageList::Info,48,"until IOSeq %s reached (Offset %s, date %s/%s)",4
#define LOG_UNTIL_IOSEQ_REACHED_ID 48
#define LOG_READ_QSEQ_INCONSISTENT                   SAPDBErr_MessageList::Error,49,"read: offset %s expected queue sequence %s found %s",3
#define LOG_READ_QSEQ_INCONSISTENT_ID 49
#define LOG_READ_IOSEQ_INCONSISTENT                  SAPDBErr_MessageList::Error,50,"read: offset %s expected iosequence %s found %s",3
#define LOG_READ_IOSEQ_INCONSISTENT_ID 50
#define LOG_READ_LAST_KNOWN_NOT_FOUND                SAPDBErr_MessageList::Error,51,"read: offset %s expected last known iosequence %s found %s",3
#define LOG_READ_LAST_KNOWN_NOT_FOUND_ID 51
#define LOG_READ_UNEXPECTED_ERROR                    SAPDBErr_MessageList::Error,52,"LogIterator ISeqReader: expected last known iosequence %s found %s",2
#define LOG_READ_UNEXPECTED_ERROR_ID 52
#define LOG_STANDBY_TOO_SLOW                         SAPDBErr_MessageList::Error,53,"Standby reads log slower than master instance writes log or log is corrupted",0
#define LOG_STANDBY_TOO_SLOW_ID 53
#define LOG_SAVEITER_INV_SEG_SIZE                    SAPDBErr_MessageList::Error,54,"Log Segment Size is invalid (0)",0
#define LOG_SAVEITER_INV_SEG_SIZE_ID 54
#define LOG_WRITER_USER_SUSPENDED                    SAPDBErr_MessageList::Info,55,"LogWriter should be supended by user",0
#define LOG_WRITER_USER_SUSPENDED_ID 55
#define LOG_WRITER_USER_RESUMED                      SAPDBErr_MessageList::Info,56,"LogWriter resumed by user",0
#define LOG_WRITER_USER_RESUMED_ID 56
#define LOG_WRITER_SUSPENDED_BY_USER                 SAPDBErr_MessageList::Info,57,"LogWriter suspended by user with ioseq: %s",1
#define LOG_WRITER_SUSPENDED_BY_USER_ID 57
#define LOG_DEVICE_FULL                              SAPDBErr_MessageList::Warning,58,"LOG FULL: task %s suspended",1
#define LOG_DEVICE_FULL_ID 58
#define LOG_QUEUE_SPACE_AVAILABLE                    SAPDBErr_MessageList::Error,59,"Can not reserve %s (%s) bytes. Maximum is %s bytes.",3
#define LOG_QUEUE_SPACE_AVAILABLE_ID 59
#define LOG_OPENTRANS_FILE_INFO                      SAPDBErr_MessageList::Info,60,"%s svpid=%s",2
#define LOG_OPENTRANS_FILE_INFO_ID 60
#define LOG_WAIT_FOR_REMOVE_HISTORY_CANCELLED        SAPDBErr_MessageList::Warning,61,"History: removal of complete history is cancelled",0
#define LOG_WAIT_FOR_REMOVE_HISTORY_CANCELLED_ID 61
#define LOG_DEL_UNDO_FILE                            SAPDBErr_MessageList::Info,62,"%s: histfileroot=%s, trans=%s root=%s, last=%s",5
#define LOG_DEL_UNDO_FILE_ID 62
#define LOG_EXISTING_HISTORY_FILES                   SAPDBErr_MessageList::Info,63,"History: %s (%s) files existing",2
#define LOG_EXISTING_HISTORY_FILES_ID 63
#define LOG_BEGIN_REMOVE_COMPLETE_HISTORY            SAPDBErr_MessageList::Info,64,"History: begin removing complete history",0
#define LOG_BEGIN_REMOVE_COMPLETE_HISTORY_ID 64
#define LOG_END_REMOVE_COMPLETE_HISTORY              SAPDBErr_MessageList::Info,65,"History: end removing complete history",0
#define LOG_END_REMOVE_COMPLETE_HISTORY_ID 65
#define LOG_HISTORY_FILE_REGISTERED                  SAPDBErr_MessageList::Info,66,"History: all history files registered, GC is ready",0
#define LOG_HISTORY_FILE_REGISTERED_ID 66
#define LOG_WAIT_FOR_REMOVE_HISTORY                  SAPDBErr_MessageList::Info,67,"History: waiting for removal of complete history",0
#define LOG_WAIT_FOR_REMOVE_HISTORY_ID 67
#define LOG_HIST_DIR_INFO                            SAPDBErr_MessageList::Info,68,"%s: registered files %s, max used are %s",3
#define LOG_HIST_DIR_INFO_ID 68
#define LOG_HISTDIR_RESIZE_FAILED                    SAPDBErr_MessageList::Info,69,"Resize of HistoryDirectory failed fileno=%s, cap=%s",2
#define LOG_HISTDIR_RESIZE_FAILED_ID 69
#define LOG_HISTORY_INVALID_FILENO                   SAPDBErr_MessageList::Info,70,"invalid fileno %s (%s) was given",2
#define LOG_HISTORY_INVALID_FILENO_ID 70
#define LOG_CONSISTENT_VIEW_INFO                     SAPDBErr_MessageList::Info,71,"consistent view=%s",1
#define LOG_CONSISTENT_VIEW_INFO_ID 71
#define LOG_PAGEREF_INFO                             SAPDBErr_MessageList::Info,72,"%s %s.%s",3
#define LOG_PAGEREF_INFO_ID 72
#define LOG_ACTION_RENAME_FILE_INFO                  SAPDBErr_MessageList::Info,73,"%s: rename file old.'%s' -> new.'%s'(%s)",4
#define LOG_ACTION_RENAME_FILE_INFO_ID 73
#define LOG_ILLEGAL_PAGEREF                          SAPDBErr_MessageList::Error,74,"The given pageref is illegal. Either nil or unaligned.",0
#define LOG_ILLEGAL_PAGEREF_ID 74
#define LOG_UNKNOWN_RESULT                           SAPDBErr_MessageList::Error,75,"%s returned unknown result code %s",2
#define LOG_UNKNOWN_RESULT_ID 75
#define LOG_WRONG_HISTORY                            SAPDBErr_MessageList::Error,76,"The history entry found does not belong to given oid.",0
#define LOG_WRONG_HISTORY_ID 76
#define LOG_REMOVE_FILE_FAILED                       SAPDBErr_MessageList::Error,77,"Parts of a table could not be removed.",0
#define LOG_REMOVE_FILE_FAILED_ID 77
#define LOG_INFO_VERIFY                              SAPDBErr_MessageList::Info,78,"Verify of %s with root %s was successfull",2
#define LOG_INFO_VERIFY_ID 78
#define LOG_INFO_VERIFY_OPENTRANS                    SAPDBErr_MessageList::Info,79,"Verify: transaction %s found as open",1
#define LOG_INFO_VERIFY_OPENTRANS_ID 79
#define LOG_TRANS_CONTEXT_HEAD                       SAPDBErr_MessageList::Info,80,"Trans: #%s %s %s [%s] %s",5
#define LOG_TRANS_CONTEXT_HEAD_ID 80
#define LOG_TRANS_CONTEXT_FILES                      SAPDBErr_MessageList::Info,81,"Trans: %s, root:%s last:%s lastseq:%s (%s)",5
#define LOG_TRANS_CONTEXT_FILES_ID 81
#define LOG_TRANS_CONTEXT_NO_REDOLOG                 SAPDBErr_MessageList::Info,82,"Trans: Redo log writing is DISABLED.",0
#define LOG_TRANS_CONTEXT_NO_REDOLOG_ID 82
#define LOG_TRANS_CONTEXT_SESSION                    SAPDBErr_MessageList::Info,83,"Trans: Session: %s.%s.%s",3
#define LOG_TRANS_CONTEXT_SESSION_ID 83
#define LOG_TRANS_CONTEXT_TASK_ENTRY                 SAPDBErr_MessageList::Info,84,"Trans: T%s TRIDX:%s",2
#define LOG_TRANS_CONTEXT_TASK_ENTRY_ID 84
#define LOG_LOCAL_REDO_BUFFER_SIZE_SET               SAPDBErr_MessageList::Info,85,"Size of LocalRedoEntryBuffer/transactions: %s",1
#define LOG_LOCAL_REDO_BUFFER_SIZE_SET_ID 85
#define LOG_ERROR_VERIFY                             SAPDBErr_MessageList::Error,86,"Verify of %s with root %s gots error %s",3
#define LOG_ERROR_VERIFY_ID 86
#define LOG_TRANS_ERROR_OCCURRED                     SAPDBErr_MessageList::Error,87,"Trans %s: TrError = %s",2
#define LOG_TRANS_ERROR_OCCURRED_ID 87
#define LOG_ACTION_NO_MIN_COPY_LENGTH                SAPDBErr_MessageList::Error,88,"Action '%s' has no MinCopyLength",1
#define LOG_ACTION_NO_MIN_COPY_LENGTH_ID 88
#define LOG_ALLOCATION_FAILED                        SAPDBErr_MessageList::Error,89,"Allocation of '%s' failed.",1
#define LOG_ALLOCATION_FAILED_ID 89
#define LOG_REDO_PARTIAL_ROLLBACK_FAILED             SAPDBErr_MessageList::Error,90,"Partial rollback during redo failed with '%s'.",1
#define LOG_REDO_PARTIAL_ROLLBACK_FAILED_ID 90
#define LOG_TRANS_INIT_NOT_CORRECT                   SAPDBErr_MessageList::Error,91,"The Log_Trans context is not correctly initialzed for %s mode.",1
#define LOG_TRANS_INIT_NOT_CORRECT_ID 91
#define LOG_TEMP_ROLLBACK_FAILED                     SAPDBErr_MessageList::Error,92,"TempRollback (%s) failed with '%s', %s, '%s'.",4
#define LOG_TEMP_ROLLBACK_FAILED_ID 92
#define LOG_INVALID_LOG_UNDO_SEQUENCE                SAPDBErr_MessageList::Error,93,"PrevUndoSequence - 1 (%s) should be equal to CurrentUndoSeqence (%s)",2
#define LOG_INVALID_LOG_UNDO_SEQUENCE_ID 93
#define LOG_REDO_WRITE_INVALID_ACTION                SAPDBErr_MessageList::Error,94,"writing redo entry, types invalid: AfterImageType='%s', ActionType='%s'",2
#define LOG_REDO_WRITE_INVALID_ACTION_ID 94
#define LOG_REDO_WRONG_TRANSNO                       SAPDBErr_MessageList::Error,95,"T%s must not find entries to redo for T%s",2
#define LOG_REDO_WRONG_TRANSNO_ID 95
#define LOG_UNDOPAGE_VERIFY                          SAPDBErr_MessageList::Error,96,"PageNo: %s bottom: %s.",2
#define LOG_UNDOPAGE_VERIFY_ID 96
#define LOG_GET_UNDO_ENTRY_MAXSIZE_MISMATCH          SAPDBErr_MessageList::Error,97,"GetUndoEntry: maxsize %s is smaller then entrysize %s",2
#define LOG_GET_UNDO_ENTRY_MAXSIZE_MISMATCH_ID 97
#define LOG_PAGE_VERIFY                              SAPDBErr_MessageList::Error,98,"Verify of logpage failed: ioseq: %s",1
#define LOG_PAGE_VERIFY_ID 98
#define LOG_NEW_DBIDENT                              SAPDBErr_MessageList::Info,99,"New DBIdentifier set (%s)",1
#define LOG_NEW_DBIDENT_ID 99
#define LOG_FREE                                     SAPDBErr_MessageList::Error,100,"FreeLog after backup of log failed: ioseq: %s->%s, off: %s->%s",4
#define LOG_FREE_ID 100
#define LOG_NON_CONTINUOUS_IOSEQ                     SAPDBErr_MessageList::Error,101,"IOSequences are not continuous: %s is not predecessor of %s",2
#define LOG_NON_CONTINUOUS_IOSEQ_ID 101
#define LOG_READ_REDO_ENTRY_FAILED                   SAPDBErr_MessageList::Error,102,"GetRedoEntry from Redo file failed.",0
#define LOG_READ_REDO_ENTRY_FAILED_ID 102
#define LOG_UNEXPECTED_REDO_ENTRY_SEQUENCE           SAPDBErr_MessageList::Error,103,"After Continue() found redo entry sequence %s expected %s",2
#define LOG_UNEXPECTED_REDO_ENTRY_SEQUENCE_ID 103
#define LOG_READ_IMAGE_AFTER_CONTINUE_FAILED         SAPDBErr_MessageList::Error,104,"After Continue() the image could not be read",0
#define LOG_READ_IMAGE_AFTER_CONTINUE_FAILED_ID 104
#define LOG_ACTION_COULD_NOT_BE_READ                 SAPDBErr_MessageList::Error,105,"Log action could not be read",0
#define LOG_ACTION_COULD_NOT_BE_READ_ID 105
#define LOG_ACTION_FROM_WRONG_TRANSACTION            SAPDBErr_MessageList::Error,106,"Action to process is from T%s but should from T%s",2
#define LOG_ACTION_FROM_WRONG_TRANSACTION_ID 106
#define LOG_ACTION_IN_REDO_NOT_ALLOWED               SAPDBErr_MessageList::Error,107,"Action '%s' for redo not allowed.",1
#define LOG_ACTION_IN_REDO_NOT_ALLOWED_ID 107
#define LOG_ACTION_IN_UNDO_NOT_ALLOWED               SAPDBErr_MessageList::Error,108,"Action '%s' for undo not allowed.",1
#define LOG_ACTION_IN_UNDO_NOT_ALLOWED_ID 108
#define LOG_ACTION_UNKNOWN_FOR_REDO                  SAPDBErr_MessageList::Error,109,"Action '%s' not known for redo.",1
#define LOG_ACTION_UNKNOWN_FOR_REDO_ID 109
#define LOG_NOT_ALL_REDO_ENTRIES_REDONE              SAPDBErr_MessageList::Error,110,"Trans::Redo Only %s entries of %s entries re-done.",2
#define LOG_NOT_ALL_REDO_ENTRIES_REDONE_ID 110
#define LOG_ACTION_GET_FILE_FAILED                   SAPDBErr_MessageList::Error,111,"FileDirectory GetFile results in error %s.",1
#define LOG_ACTION_GET_FILE_FAILED_ID 111
#define LOG_ACTION_FILE_NOT_MARKED_DELETED           SAPDBErr_MessageList::Error,112,"File '%s' must be marked as deleted, state is %s.",2
#define LOG_ACTION_FILE_NOT_MARKED_DELETED_ID 112
#define LOG_ACTION_DESTROY_FILE_FAILED               SAPDBErr_MessageList::Error,113,"Destroy file failed.",0
#define LOG_ACTION_DESTROY_FILE_FAILED_ID 113
#define LOG_ACTION_UNQUALIFIED_DELETE_WRONG_FILETYPE SAPDBErr_MessageList::Error,114,"File must be of type Table, is: %s.",1
#define LOG_ACTION_UNQUALIFIED_DELETE_WRONG_FILETYPE_ID 114

#endif /* LOG_MESSAGES_HPP */
