/*!*********************************************************************

    @file         RTEIO_DirectoryIterator.hpp

    @author       DanielD

    @brief

\if EMIT_LICENCE
    ========== licence begin  GPL
    Copyright (c) 2004 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif
***********************************************************************/

#ifndef RTEIO_DIRECTORYITERATOR_HPP
#define RTEIO_DIRECTORYITERATOR_HPP


/*!

  @class RTEIO_DirectoryIterator

 */
class RTEIO_DirectoryIterator
{
public:
    enum {withDots};
    RTEIO_DirectoryIterator (const char * path, int options = 0);
    ~RTEIO_DirectoryIterator ();
    bool next ();
    const char * currentFullpath () const;
    const char * currentName () const;
    bool         currentIsDir ();
    bool         isValid () const;
    void         close ();

private:
    bool basicNext ();
    bool currentOK () const;

private:
    char         fullbuf [1024];
    char       * namestart;
    int          isdir;
    int          options;
    int          state;
    void       * dirHandle;
};

#endif
