/*!*********************************************************************

    @file         RTE_Random.cpp

    @author       DanielD

    @brief        pseudo random numbers

\if EMIT_LICENCE
    ========== licence begin  GPL
    Copyright (c) 2004 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif
***********************************************************************/

#include "RunTime/RTE_Random.hpp"

#include <string.h>

/*----------------------------------------*/

RTE_Random::
RTE_Random ()
{
    this->seed = 0;
}

/*----------------------------------------*/

RTE_Random::
RTE_Random (
    unsigned int seed_init)
{
    this->seed = seed_init;
}

/*----------------------------------------*/

unsigned int RTE_Random::
nextInt ()
{
    ++this->seed;
    return this->seed;
}

/*----------------------------------------*/

void RTE_Random::
fillBuf (
    void * buf,
    int buflen)
{
    char * target = (char *) buf;
    unsigned int next;
    int numbersRequired = buflen / sizeof (unsigned int);

    for (int i = 0; i < numbersRequired; ++i) {
        next = this->nextInt ();
        memcpy (target, &next, sizeof (unsigned int));
        target += sizeof (unsigned int);
    }
    int bytesRemaining = buflen % sizeof (unsigned int);
    if (bytesRemaining > 0) {
        next = this->nextInt ();
        memcpy (target, &next, bytesRemaining);
    }
}

/*----------------------------------------*/

RTE_Random RTE_Random::Generator;

/*----------------------------------------*/

