/*!*********************************************************************

    @file         RTE_Random.hpp

    @author       DanielD

    @brief        pseudo random mnumbers

\if EMIT_LICENCE
    ========== licence begin  GPL
    Copyright (c) 2004 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif
***********************************************************************/

#ifndef RTE_RANDOM_HPP
#define RTE_RANDOM_HPP


/*!

  @class RTE_Random
  @brief pseudo random numbers

  This is a dummy implementation.

 */
class RTE_Random
{
public:
    /*!
        @brief Create a new RTE_Random with a 'random' seed based
               on the time of the day
     */
    RTE_Random ();

    /*!
        @brief Create a new RTE_Random with a deterministic seed
     */
    RTE_Random (unsigned int seed);

    /*!
        @brief returns the next random number in the range 0..UINT_MAX
     */
    unsigned int nextInt ();

    /*!
        @brief fills buf with random bytes
     */
    void fillBuf (void * buf, int buflen);

    static RTE_Random Generator;

private:
    unsigned int seed;
};

#endif

