/*
        ========== licence begin  GPL
        Copyright (C) 2005 SAP AG

        This program is free software; you can redistribute it and/or
        modify it under the terms of the GNU General Public License
        as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
        ========== licence end

*/

#ifndef SDBMSG_DBMSCD_H
#define SDBMSG_DBMSCD_H

/*
 This headerfile was generated by buildmsg.pl
--- Do not edit....
*/

#ifdef __cplusplus
#ifndef MSG_LIST_HPP
#include "SAPDB/Messages/Msg_List.hpp"
#endif
#ifndef MSG_ARG_HPP
#include "SAPDB/Messages/Msg_Arg.hpp"
#endif
#endif

#define SDBMSG_DBMSCD_COMPONENT "DBMScd"

/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ACTION_TERMINATION 1, "DBMScd", __FILE__, __LINE__, "terminate"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ACTION_INSERTJOB 2, "DBMScd", __FILE__, __LINE__, "insert new scheduler job"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ACTION_RETURNJOBLIST 3, "DBMScd", __FILE__, __LINE__, "list of scheduler jobs requested"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ACTION_ACTIVATEJOB 4, "DBMScd", __FILE__, __LINE__, "activate scheduler job"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ACTION_DEACTIVATEJOB 5, "DBMScd", __FILE__, __LINE__, "deactivate scheduler job"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ACTION_DELETEJOB 6, "DBMScd", __FILE__, __LINE__, "delete scheduler job"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_JOBSERVEDBYPID 7, "DBMScd", __FILE__, __LINE__, "scheduler job $SCDJOBID$: served by PID $PID$ ($PIDASHEX$)"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_JOBEXECUTEDAT 8, "DBMScd", __FILE__, __LINE__, "scheduler job $SCDJOBID$: planned execution time $DATE$, $TIME$ (dbm_command: $DBMCMD$)"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_JOBEXECUTEDAFTER 9, "DBMScd", __FILE__, __LINE__, "scheduler job $SCDJOBID$: planned execution after scheduler job $SCDJOBIDPRED$ (dbm_command: $DBMCMD$)"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ERRLOGPLANNEDEXECUTION 10, "DBMScd", __FILE__, __LINE__, "scheduler job $SCDJOBID$: cannot log planned execution time"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_JOBREPLY 11, "DBMScd", __FILE__, __LINE__, "reply of scheduler job $SCDJOBID$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ERRNOJOBREPLY 12, "DBMScd", __FILE__, __LINE__, "scheduler job $SCDJOBID$: no reply available"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_JOBFINISHEDAFTER 13, "DBMScd", __FILE__, __LINE__, "scheduler job $SCDJOBID$: finished (planned execution after scheduler job $SCDJOBIDPRED$)."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_JOBFINISHEDAT 14, "DBMScd", __FILE__, __LINE__, "scheduler job $SCDJOBID$: finished (planned execution time $DATE$, $TIME$)"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ACTION_START 15, "DBMScd", __FILE__, __LINE__, "start"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_DBMSCD_ERRUNKNOWNCOMMAND 16, "DBMScd", __FILE__, __LINE__, "unknown scheduler command"

/* other macro definitions (created by buildmsg.pl)*/
#define SDBMSG_DBMSCD_ENUMERATION\
                    DBMScd_ACTION_TERMINATION=1,\
                    DBMScd_ACTION_INSERTJOB=2,\
                    DBMScd_ACTION_RETURNJOBLIST=3,\
                    DBMScd_ACTION_ACTIVATEJOB=4,\
                    DBMScd_ACTION_DEACTIVATEJOB=5,\
                    DBMScd_ACTION_DELETEJOB=6,\
                    DBMScd_JOBSERVEDBYPID=7,\
                    DBMScd_JOBEXECUTEDAT=8,\
                    DBMScd_JOBEXECUTEDAFTER=9,\
                    DBMScd_ERRLOGPLANNEDEXECUTION=10,\
                    DBMScd_JOBREPLY=11,\
                    DBMScd_ERRNOJOBREPLY=12,\
                    DBMScd_JOBFINISHEDAFTER=13,\
                    DBMScd_JOBFINISHEDAT=14,\
                    DBMScd_ACTION_START=15,\
                    DBMScd_ERRUNKNOWNCOMMAND=16

#define SDBMSG_DBMSCD_INITIALIZATIONLIST(x) \
                    x(SDBMSG_DBMSCD_ACTION_TERMINATION, "ACTION_TERMINATION"),\
                    x(SDBMSG_DBMSCD_ACTION_INSERTJOB, "ACTION_INSERTJOB"),\
                    x(SDBMSG_DBMSCD_ACTION_RETURNJOBLIST, "ACTION_RETURNJOBLIST"),\
                    x(SDBMSG_DBMSCD_ACTION_ACTIVATEJOB, "ACTION_ACTIVATEJOB"),\
                    x(SDBMSG_DBMSCD_ACTION_DEACTIVATEJOB, "ACTION_DEACTIVATEJOB"),\
                    x(SDBMSG_DBMSCD_ACTION_DELETEJOB, "ACTION_DELETEJOB"),\
                    x(SDBMSG_DBMSCD_JOBSERVEDBYPID, "JOBSERVEDBYPID"),\
                    x(SDBMSG_DBMSCD_JOBEXECUTEDAT, "JOBEXECUTEDAT"),\
                    x(SDBMSG_DBMSCD_JOBEXECUTEDAFTER, "JOBEXECUTEDAFTER"),\
                    x(SDBMSG_DBMSCD_ERRLOGPLANNEDEXECUTION, "ERRLOGPLANNEDEXECUTION"),\
                    x(SDBMSG_DBMSCD_JOBREPLY, "JOBREPLY"),\
                    x(SDBMSG_DBMSCD_ERRNOJOBREPLY, "ERRNOJOBREPLY"),\
                    x(SDBMSG_DBMSCD_JOBFINISHEDAFTER, "JOBFINISHEDAFTER"),\
                    x(SDBMSG_DBMSCD_JOBFINISHEDAT, "JOBFINISHEDAT"),\
                    x(SDBMSG_DBMSCD_ACTION_START, "ACTION_START"),\
                    x(SDBMSG_DBMSCD_ERRUNKNOWNCOMMAND, "ERRUNKNOWNCOMMAND")


#endif /* SDBMSG_DBMSCD_H */
