/*
        ========== licence begin  GPL
        Copyright (C) 2004 SAP AG

        This program is free software; you can redistribute it and/or
        modify it under the terms of the GNU General Public License
        as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
        ========== licence end

*/

#ifndef SDBMSG_FILEDIR_H
#define SDBMSG_FILEDIR_H

/*
 This headerfile was generated by buildmsg.pl
--- Do not edit....
*/

#ifdef __cplusplus
#ifndef MSG_LIST_HPP
#include "SAPDB/Messages/Msg_List.hpp"
#endif
#ifndef MSG_ARG_HPP
#include "SAPDB/Messages/Msg_Arg.hpp"
#endif
#endif

/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_FILENO_NOT_FOUND 1, "FileDir", __FILE__, __LINE__, "FileNo $FILENO$ not found"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_FILENO_MARKED_DELETED 2, "FileDir", __FILE__, __LINE__, "FileNo $FILENO$ marked for deletion"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_FILETYPE_MISMATCH 3, "FileDir", __FILE__, __LINE__, "File type mismatch for fileNo $FILENO$; expected: $NO$, retrieved: $TYPE$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_MIGRATION_STARTED 4, "FileDir", __FILE__, __LINE__, "File directory migration started"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_MIGRATION_OK 5, "FileDir", __FILE__, __LINE__, "File directory migration finished successfully"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_MIGRATION_FAILED 6, "FileDir", __FILE__, __LINE__, "File directory migration failed; error code $NO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_RESTART 7, "FileDir", __FILE__, __LINE__, "File directory restarting"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_RESTART_OK 8, "FileDir", __FILE__, __LINE__, "File directory restart completed"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_RESTART_FAILED 9, "FileDir", __FILE__, __LINE__, "File directory restart failed; error code $NO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_DUPLICATE_FILENO 10, "FileDir", __FILE__, __LINE__, "duplicate fileNo $FILENO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_ROLLBACK_ADD_FILE_FAILED 11, "FileDir", __FILE__, __LINE__, "rollback of add file to file directory failed; fileNo =  $FILENO$ , file type = $FILETYPE$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_CREATE_FAILED 12, "FileDir", __FILE__, __LINE__, "Initial file directory creation failed"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_MIGRATE_INDEX_TABLE_NOT_FOUND 13, "FileDir", __FILE__, __LINE__, "fdir migration: error table file not found during index entry creation; indexNo $INDEX$, table fileNo $FILENO$, fileTypeSet $FILETYPESET$, root page $PAGENO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_MIGRATE_INDEX_ERROR 14, "FileDir", __FILE__, __LINE__, "fdir migration: error during index entry creation; indexNo $INDEX$, table fileNo $FILENO$, fileTypeSet $FILETYPESET$, root page $PAGENO$, error no $NO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_MIGRATE_SHORT_COLUMN_TABLE_NOT_FOUND 15, "FileDir", __FILE__, __LINE__, "fdir migration: error table file not found during short column entry creation; table fileNo $FILENO$, fileTypeSet $FILETYPESET$, root page $PAGENO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_MIGRATE_SHORT_COLUMN_ERROR 16, "FileDir", __FILE__, __LINE__, "fdir migration: error during short column entry creation; table fileNo $FILENO$, fileTypeSet $FILETYPESET$, root page $PAGENO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_FILE_MUST_BE_DELETED 17, "FileDir", __FILE__, __LINE__, "File $FILENO$ must be marked deleted"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_FILEDIR_SECONDARY_FILES_EXIST 18, "FileDir", __FILE__, __LINE__, "Deleted file $FILENO$ has secondary files attached"

/* other macro definitions (created by buildmsg.pl)*/
#define SDBMSG_FILEDIR_ENUMERATION\
                    FILENO_NOT_FOUND=1,\
                    FILENO_MARKED_DELETED=2,\
                    FILETYPE_MISMATCH=3,\
                    MIGRATION_STARTED=4,\
                    MIGRATION_OK=5,\
                    MIGRATION_FAILED=6,\
                    RESTART=7,\
                    RESTART_OK=8,\
                    RESTART_FAILED=9,\
                    DUPLICATE_FILENO=10,\
                    ROLLBACK_ADD_FILE_FAILED=11,\
                    CREATE_FAILED=12,\
                    MIGRATE_INDEX_TABLE_NOT_FOUND=13,\
                    MIGRATE_INDEX_ERROR=14,\
                    MIGRATE_SHORT_COLUMN_TABLE_NOT_FOUND=15,\
                    MIGRATE_SHORT_COLUMN_ERROR=16,\
                    FILE_MUST_BE_DELETED=17,\
                    SECONDARY_FILES_EXIST=18

#define SDBMSG_FILEDIR_INITIALIZATIONLIST(x) \
                    x(SDBMSG_FILEDIR_FILENO_NOT_FOUND, "FILENO_NOT_FOUND"),\
                    x(SDBMSG_FILEDIR_FILENO_MARKED_DELETED, "FILENO_MARKED_DELETED"),\
                    x(SDBMSG_FILEDIR_FILETYPE_MISMATCH, "FILETYPE_MISMATCH"),\
                    x(SDBMSG_FILEDIR_MIGRATION_STARTED, "MIGRATION_STARTED"),\
                    x(SDBMSG_FILEDIR_MIGRATION_OK, "MIGRATION_OK"),\
                    x(SDBMSG_FILEDIR_MIGRATION_FAILED, "MIGRATION_FAILED"),\
                    x(SDBMSG_FILEDIR_RESTART, "RESTART"),\
                    x(SDBMSG_FILEDIR_RESTART_OK, "RESTART_OK"),\
                    x(SDBMSG_FILEDIR_RESTART_FAILED, "RESTART_FAILED"),\
                    x(SDBMSG_FILEDIR_DUPLICATE_FILENO, "DUPLICATE_FILENO"),\
                    x(SDBMSG_FILEDIR_ROLLBACK_ADD_FILE_FAILED, "ROLLBACK_ADD_FILE_FAILED"),\
                    x(SDBMSG_FILEDIR_CREATE_FAILED, "CREATE_FAILED"),\
                    x(SDBMSG_FILEDIR_MIGRATE_INDEX_TABLE_NOT_FOUND, "MIGRATE_INDEX_TABLE_NOT_FOUND"),\
                    x(SDBMSG_FILEDIR_MIGRATE_INDEX_ERROR, "MIGRATE_INDEX_ERROR"),\
                    x(SDBMSG_FILEDIR_MIGRATE_SHORT_COLUMN_TABLE_NOT_FOUND, "MIGRATE_SHORT_COLUMN_TABLE_NOT_FOUND"),\
                    x(SDBMSG_FILEDIR_MIGRATE_SHORT_COLUMN_ERROR, "MIGRATE_SHORT_COLUMN_ERROR"),\
                    x(SDBMSG_FILEDIR_FILE_MUST_BE_DELETED, "FILE_MUST_BE_DELETED"),\
                    x(SDBMSG_FILEDIR_SECONDARY_FILES_EXIST, "SECONDARY_FILES_EXIST")


#endif /* SDBMSG_FILEDIR_H */
