/*
        ========== licence begin  GPL
        Copyright (C) 2004 SAP AG

        This program is free software; you can redistribute it and/or
        modify it under the terms of the GNU General Public License
        as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
        ========== licence end

*/

#ifndef SDBMSG_RTECOMM_H
#define SDBMSG_RTECOMM_H

/*
 This headerfile was generated by buildmsg.pl
--- Do not edit....
*/

#ifdef __cplusplus
#ifndef MSG_LIST_HPP
#include "SAPDB/Messages/Msg_List.hpp"
#endif
#ifndef MSG_ARG_HPP
#include "SAPDB/Messages/Msg_Arg.hpp"
#endif
#endif

/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_UNKNOWN_PROTOCOL_FROM_HOST 1, "RTEComm", __FILE__, __LINE__, "No communication protocol could be determined from host=$HOSTNAME$ and encryption=$BOOL$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_MISSING_SERVERDB 2, "RTEComm", __FILE__, __LINE__, "No database name was provided"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_ESCAPE_DATABASE 3, "RTEComm", __FILE__, __LINE__, "The given database name '$DATABASE_NAME$' could not be escaped"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_PORT_NOT_SUPPORTED 4, "RTEComm", __FILE__, __LINE__, "A port is not needed for the local communication protocol"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_ENCRYPTION_NOT_SUPPORTED 5, "RTEComm", __FILE__, __LINE__, "Encryption is not supported for the local communication protocol"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_MEMORY_ALLOCATION 6, "RTEComm", __FILE__, __LINE__, "Memory allocation of $ALLOC_SIZE$ bytes failed"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_BUFFER_TO_SMALL 7, "RTEComm", __FILE__, __LINE__, "Given URI buffer is to small: wanted=$BUFFERSIZE_NEEDED$ bytes, is=$BUFFERSIZE$ bytes"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_HOSTNAME_LENGTH 8, "RTEComm", __FILE__, __LINE__, "The hostname length is to long: allowed=$STRING_LENGTH_MAX$, given=$STRING_LENGTH$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_ESCAPE_OPTION 9, "RTEComm", __FILE__, __LINE__, "The given URI option name '$URI_OPTION_NAME$' could not be escaped"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_ESCAPE_VALUE 10, "RTEComm", __FILE__, __LINE__, "The given URI option value '$URI_OPTION_VALUE$' could not be escaped"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_MISSING_OPTION 11, "RTEComm", __FILE__, __LINE__, "No option was provided"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_RTECOMM_URI_ILLEGAL_PROTOCOL 12, "RTEComm", __FILE__, __LINE__, "The protocol $URI_PROTOCOL$ is not allowed for the $URI_PATH$ URI"

/* other macro definitions (created by buildmsg.pl)*/
#define SDBMSG_RTECOMM_ENUMERATION\
                    URI_UNKNOWN_PROTOCOL_FROM_HOST=1,\
                    URI_MISSING_SERVERDB=2,\
                    URI_ESCAPE_DATABASE=3,\
                    URI_PORT_NOT_SUPPORTED=4,\
                    URI_ENCRYPTION_NOT_SUPPORTED=5,\
                    URI_MEMORY_ALLOCATION=6,\
                    URI_BUFFER_TO_SMALL=7,\
                    URI_HOSTNAME_LENGTH=8,\
                    URI_ESCAPE_OPTION=9,\
                    URI_ESCAPE_VALUE=10,\
                    URI_MISSING_OPTION=11,\
                    URI_ILLEGAL_PROTOCOL=12

#define SDBMSG_RTECOMM_INITIALIZATIONLIST(x) \
                    x(SDBMSG_RTECOMM_URI_UNKNOWN_PROTOCOL_FROM_HOST, "URI_UNKNOWN_PROTOCOL_FROM_HOST"),\
                    x(SDBMSG_RTECOMM_URI_MISSING_SERVERDB, "URI_MISSING_SERVERDB"),\
                    x(SDBMSG_RTECOMM_URI_ESCAPE_DATABASE, "URI_ESCAPE_DATABASE"),\
                    x(SDBMSG_RTECOMM_URI_PORT_NOT_SUPPORTED, "URI_PORT_NOT_SUPPORTED"),\
                    x(SDBMSG_RTECOMM_URI_ENCRYPTION_NOT_SUPPORTED, "URI_ENCRYPTION_NOT_SUPPORTED"),\
                    x(SDBMSG_RTECOMM_URI_MEMORY_ALLOCATION, "URI_MEMORY_ALLOCATION"),\
                    x(SDBMSG_RTECOMM_URI_BUFFER_TO_SMALL, "URI_BUFFER_TO_SMALL"),\
                    x(SDBMSG_RTECOMM_URI_HOSTNAME_LENGTH, "URI_HOSTNAME_LENGTH"),\
                    x(SDBMSG_RTECOMM_URI_ESCAPE_OPTION, "URI_ESCAPE_OPTION"),\
                    x(SDBMSG_RTECOMM_URI_ESCAPE_VALUE, "URI_ESCAPE_VALUE"),\
                    x(SDBMSG_RTECOMM_URI_MISSING_OPTION, "URI_MISSING_OPTION"),\
                    x(SDBMSG_RTECOMM_URI_ILLEGAL_PROTOCOL, "URI_ILLEGAL_PROTOCOL")


#endif /* SDBMSG_RTECOMM_H */
