/*
        ========== licence begin  GPL
        Copyright (C) 2005 SAP AG

        This program is free software; you can redistribute it and/or
        modify it under the terms of the GNU General Public License
        as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
        ========== licence end

*/

#ifndef SDBMSG_SRVTASKS_H
#define SDBMSG_SRVTASKS_H

/*
 This headerfile was generated by buildmsg.pl
--- Do not edit....
*/

#ifdef __cplusplus
#ifndef MSG_LIST_HPP
#include "SAPDB/Messages/Msg_List.hpp"
#endif
#ifndef MSG_ARG_HPP
#include "SAPDB/Messages/Msg_Arg.hpp"
#endif
#endif

#define SDBMSG_SRVTASKS_COMPONENT "SrvTasks"

/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_WRONG_TASK_TYPE 2, "SrvTasks", __FILE__, __LINE__, "The expected task type is &quoteServerTask&quote but it is &quote$TYPE$&quote"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TASK_STARTED_WITHOUT_JOB 3, "SrvTasks", __FILE__, __LINE__, "The server task $TASK$ was started but there is no job for it."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_JOB_ALREADY_EXISTS 4, "SrvTasks", __FILE__, __LINE__, "A Servertask should execute a job but is alread executing another job."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_NO_MORE_MEMORY_FOR_COORDINATOR 5, "SrvTasks", __FILE__, __LINE__, "The Servertask Coordinator cannot be allocated. No more heap memory available."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_NO_MORE_MEMORY_TO_REGISTER_TASK 7, "SrvTasks", __FILE__, __LINE__, "There is not enough heap memory to register a new servertask."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_AVAILABLE_SERVERTASKS 9, "SrvTasks", __FILE__, __LINE__, "Available Servertasks: $UINT4$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_JOB_INFO 10, "SrvTasks", __FILE__, __LINE__, "Job $JOB_ID$ ($DESCRIPTION$) [$JOB_STATE$] WaitingT$JOB_WAITING_TASKID$ Result=$JOB_RESULT$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_JOB_COLLECTION_INFO 11, "SrvTasks", __FILE__, __LINE__, "Job Type: '$DESCRIPTION$'"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_ALLOCATION_FAILED 13, "SrvTasks", __FILE__, __LINE__, "Not enough heap memory"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_NOT_ENOUGH_SERVERTASKS_AVAILABLE 14, "SrvTasks", __FILE__, __LINE__, "Only $TASKS_AVAILABLE$ servertasks available but $TASKS_WANTED$ were requested."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_JOB_INFO_TITLE 17, "SrvTasks", __FILE__, __LINE__, "Servertask Info: because $DESCRIPTION$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_RELEASE_TASK_FAILED 19, "SrvTasks", __FILE__, __LINE__, "The servertask T$JOB_TASKID$ with index #$INDEX$ could not be released."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TASK_NOT_PROPERLY_REGISTERED 20, "SrvTasks", __FILE__, __LINE__, "The servertask T$JOB_TASKID$ is not registered properly."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_ERRLIST_NOT_EMPTY 21, "SrvTasks", __FILE__, __LINE__, "The errorlist is not empty but result is OK after executing the job."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_INTERNAL_ERROR 23, "SrvTasks", __FILE__, __LINE__, "INTERNAL PROGRAMMING ERROR: $DESCRIPTION$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_WRONG_JOB_STATE 24, "SrvTasks", __FILE__, __LINE__, "The job has state $STATE$ but this is not expected."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_WRONG_WAITING_CONTEXT 25, "SrvTasks", __FILE__, __LINE__, "The waiting task is different between job and caller."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_DROP_AUX_FILE_EXECUTED_DIRECTLY 27, "SrvTasks", __FILE__, __LINE__, "Auxiliary Files can not be dropped asynchronously."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_JOB_HAS_UNEXPECTED_STATE 29, "SrvTasks", __FILE__, __LINE__, "A job in the joblist has an unexpected state: $JOB_STATE$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_WAIT_BUT_ALL_JOBS_ARE_CONFIRMED 30, "SrvTasks", __FILE__, __LINE__, "A caller should wait for a job but all jobs are confirmed."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_SERVERTASKS_PERMANENTLY_RESERVED 31, "SrvTasks", __FILE__, __LINE__, "Permanently reserved $TASKS_WANTED$ servertasks for '$DESCRIPTION$'."
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_SERVER_TASK_INFO 32, "SrvTasks", __FILE__, __LINE__, "Server T$SERVER_TASK_ID$ Id$SERVER_TASK_INDEX$ $SERVER_TASK_KIND$: '$DESCRIPTION$'"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_SERVERTASKS_COORDINATOR_INFO 33, "SrvTasks", __FILE__, __LINE__, "ServerTask Coordinator: Max=$MAX_SERVER_TASKS$, Used=$SERVER_TASKS_USED$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_SERVERTASK_CONTROL_INFO 34, "SrvTasks", __FILE__, __LINE__, "ServertaskControl #$SERVER_TASK_INDEX$, $SRVTASK_ASSIGNED$, $SRVTASKS_RESERVED$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_REQUESTFILE_NOT_FOUND 35, "SrvTasks", __FILE__, __LINE__, "Request file $FILENO$ could not be found"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_TABLEKEY_NOT_FOUND 36, "SrvTasks", __FILE__, __LINE__, "Table key $KEYASHEX$ not found in request file $FILENO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_TEMPFILE_NOT_FOUND 37, "SrvTasks", __FILE__, __LINE__, "Temporary file $FILENO$ could not be found"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_GETTREE_FAILED 38, "SrvTasks", __FILE__, __LINE__, "Locking of table $FILENO$ failed; error $RETURNCODE$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_GETTEMP_FAILED 39, "SrvTasks", __FILE__, __LINE__, "Locking of temporary file $FILENO$ failed; error $RETURNCODE$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_OUT_OF_MEMORY 40, "SrvTasks", __FILE__, __LINE__, "Out of memory: $ALLOC_SIZE$ bytes requested"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_INITSAMPLINGITERATOR_FAILED 41, "SrvTasks", __FILE__, __LINE__, "Initialization of sampling iterator failed for table $FILENO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_COLLECT_FAILED 42, "SrvTasks", __FILE__, __LINE__, "Error while collecting statistics for table $FILENO$;  error $RETURNCODE$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_TABLESTATISTICS_UPDATE_REQUESTFILE_FAILED 43, "SrvTasks", __FILE__, __LINE__, "Could not update entry for table $FILENO$ in request file $FILENO1$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_BACKUP_JOB_INFO 44, "SrvTasks", __FILE__, __LINE__, "BackupJob: autosave=$IS_AUTOSAVE$ taskNo=$BACKUP_TASK_NO$ mediaNo=$BACKUP_MEDIA_NO$ volumeNo=$BACKUP_VOLUME_NO$"
/* The next line was generated by buildmsg.pl ... Do not edit....*/
#define SDBMSG_SRVTASKS_SELF_TEST_ERROR 45, "SrvTasks", __FILE__, __LINE__, "SelfTest of Servertasks generated error '$ERRORTEXT$' $NO$"

/* other macro definitions (created by buildmsg.pl)*/
#define SDBMSG_SRVTASKS_ENUMERATION\
                    SrvTasks_WRONG_TASK_TYPE=2,\
                    SrvTasks_TASK_STARTED_WITHOUT_JOB=3,\
                    SrvTasks_JOB_ALREADY_EXISTS=4,\
                    SrvTasks_NO_MORE_MEMORY_FOR_COORDINATOR=5,\
                    SrvTasks_NO_MORE_MEMORY_TO_REGISTER_TASK=7,\
                    SrvTasks_AVAILABLE_SERVERTASKS=9,\
                    SrvTasks_JOB_INFO=10,\
                    SrvTasks_JOB_COLLECTION_INFO=11,\
                    SrvTasks_ALLOCATION_FAILED=13,\
                    SrvTasks_NOT_ENOUGH_SERVERTASKS_AVAILABLE=14,\
                    SrvTasks_JOB_INFO_TITLE=17,\
                    SrvTasks_RELEASE_TASK_FAILED=19,\
                    SrvTasks_TASK_NOT_PROPERLY_REGISTERED=20,\
                    SrvTasks_ERRLIST_NOT_EMPTY=21,\
                    SrvTasks_INTERNAL_ERROR=23,\
                    SrvTasks_WRONG_JOB_STATE=24,\
                    SrvTasks_WRONG_WAITING_CONTEXT=25,\
                    SrvTasks_DROP_AUX_FILE_EXECUTED_DIRECTLY=27,\
                    SrvTasks_JOB_HAS_UNEXPECTED_STATE=29,\
                    SrvTasks_WAIT_BUT_ALL_JOBS_ARE_CONFIRMED=30,\
                    SrvTasks_SERVERTASKS_PERMANENTLY_RESERVED=31,\
                    SrvTasks_SERVER_TASK_INFO=32,\
                    SrvTasks_SERVERTASKS_COORDINATOR_INFO=33,\
                    SrvTasks_SERVERTASK_CONTROL_INFO=34,\
                    SrvTasks_TABLESTATISTICS_REQUESTFILE_NOT_FOUND=35,\
                    SrvTasks_TABLESTATISTICS_TABLEKEY_NOT_FOUND=36,\
                    SrvTasks_TABLESTATISTICS_TEMPFILE_NOT_FOUND=37,\
                    SrvTasks_TABLESTATISTICS_GETTREE_FAILED=38,\
                    SrvTasks_TABLESTATISTICS_GETTEMP_FAILED=39,\
                    SrvTasks_TABLESTATISTICS_OUT_OF_MEMORY=40,\
                    SrvTasks_TABLESTATISTICS_INITSAMPLINGITERATOR_FAILED=41,\
                    SrvTasks_TABLESTATISTICS_COLLECT_FAILED=42,\
                    SrvTasks_TABLESTATISTICS_UPDATE_REQUESTFILE_FAILED=43,\
                    SrvTasks_BACKUP_JOB_INFO=44,\
                    SrvTasks_SELF_TEST_ERROR=45

#define SDBMSG_SRVTASKS_INITIALIZATIONLIST(x) \
                    x(SDBMSG_SRVTASKS_WRONG_TASK_TYPE, "WRONG_TASK_TYPE"),\
                    x(SDBMSG_SRVTASKS_TASK_STARTED_WITHOUT_JOB, "TASK_STARTED_WITHOUT_JOB"),\
                    x(SDBMSG_SRVTASKS_JOB_ALREADY_EXISTS, "JOB_ALREADY_EXISTS"),\
                    x(SDBMSG_SRVTASKS_NO_MORE_MEMORY_FOR_COORDINATOR, "NO_MORE_MEMORY_FOR_COORDINATOR"),\
                    x(SDBMSG_SRVTASKS_NO_MORE_MEMORY_TO_REGISTER_TASK, "NO_MORE_MEMORY_TO_REGISTER_TASK"),\
                    x(SDBMSG_SRVTASKS_AVAILABLE_SERVERTASKS, "AVAILABLE_SERVERTASKS"),\
                    x(SDBMSG_SRVTASKS_JOB_INFO, "JOB_INFO"),\
                    x(SDBMSG_SRVTASKS_JOB_COLLECTION_INFO, "JOB_COLLECTION_INFO"),\
                    x(SDBMSG_SRVTASKS_ALLOCATION_FAILED, "ALLOCATION_FAILED"),\
                    x(SDBMSG_SRVTASKS_NOT_ENOUGH_SERVERTASKS_AVAILABLE, "NOT_ENOUGH_SERVERTASKS_AVAILABLE"),\
                    x(SDBMSG_SRVTASKS_JOB_INFO_TITLE, "JOB_INFO_TITLE"),\
                    x(SDBMSG_SRVTASKS_RELEASE_TASK_FAILED, "RELEASE_TASK_FAILED"),\
                    x(SDBMSG_SRVTASKS_TASK_NOT_PROPERLY_REGISTERED, "TASK_NOT_PROPERLY_REGISTERED"),\
                    x(SDBMSG_SRVTASKS_ERRLIST_NOT_EMPTY, "ERRLIST_NOT_EMPTY"),\
                    x(SDBMSG_SRVTASKS_INTERNAL_ERROR, "INTERNAL_ERROR"),\
                    x(SDBMSG_SRVTASKS_WRONG_JOB_STATE, "WRONG_JOB_STATE"),\
                    x(SDBMSG_SRVTASKS_WRONG_WAITING_CONTEXT, "WRONG_WAITING_CONTEXT"),\
                    x(SDBMSG_SRVTASKS_DROP_AUX_FILE_EXECUTED_DIRECTLY, "DROP_AUX_FILE_EXECUTED_DIRECTLY"),\
                    x(SDBMSG_SRVTASKS_JOB_HAS_UNEXPECTED_STATE, "JOB_HAS_UNEXPECTED_STATE"),\
                    x(SDBMSG_SRVTASKS_WAIT_BUT_ALL_JOBS_ARE_CONFIRMED, "WAIT_BUT_ALL_JOBS_ARE_CONFIRMED"),\
                    x(SDBMSG_SRVTASKS_SERVERTASKS_PERMANENTLY_RESERVED, "SERVERTASKS_PERMANENTLY_RESERVED"),\
                    x(SDBMSG_SRVTASKS_SERVER_TASK_INFO, "SERVER_TASK_INFO"),\
                    x(SDBMSG_SRVTASKS_SERVERTASKS_COORDINATOR_INFO, "SERVERTASKS_COORDINATOR_INFO"),\
                    x(SDBMSG_SRVTASKS_SERVERTASK_CONTROL_INFO, "SERVERTASK_CONTROL_INFO"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_REQUESTFILE_NOT_FOUND, "TABLESTATISTICS_REQUESTFILE_NOT_FOUND"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_TABLEKEY_NOT_FOUND, "TABLESTATISTICS_TABLEKEY_NOT_FOUND"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_TEMPFILE_NOT_FOUND, "TABLESTATISTICS_TEMPFILE_NOT_FOUND"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_GETTREE_FAILED, "TABLESTATISTICS_GETTREE_FAILED"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_GETTEMP_FAILED, "TABLESTATISTICS_GETTEMP_FAILED"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_OUT_OF_MEMORY, "TABLESTATISTICS_OUT_OF_MEMORY"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_INITSAMPLINGITERATOR_FAILED, "TABLESTATISTICS_INITSAMPLINGITERATOR_FAILED"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_COLLECT_FAILED, "TABLESTATISTICS_COLLECT_FAILED"),\
                    x(SDBMSG_SRVTASKS_TABLESTATISTICS_UPDATE_REQUESTFILE_FAILED, "TABLESTATISTICS_UPDATE_REQUESTFILE_FAILED"),\
                    x(SDBMSG_SRVTASKS_BACKUP_JOB_INFO, "BACKUP_JOB_INFO"),\
                    x(SDBMSG_SRVTASKS_SELF_TEST_ERROR, "SELF_TEST_ERROR")


#endif /* SDBMSG_SRVTASKS_H */
