/*!***************************************************************************

  module      : Query_Column.cpp

  -------------------------------------------------------------------------

  responsible : DirkT

  special area: SQL Manager / Query
  description : 

  last changed: 2004-11-23  16:00
  first created:2004-04-29  10:00

  -------------------------------------------------------------------------

  copyright:    Copyright (c) 2000-2004 SAP AG




    ========== licence begin  GPL
    Copyright (c) 2000-2004 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end



*****************************************************************************/

#include "SAPDB/SQLManager/Query/Query_Column.hpp"

// ------------------------------------------------------------------------------------------------

Query_Column::Query_Column( void )
    : mQuantifierNode(cak_qrewrite_ref_init)
    , mNodeID(cak_qrewrite_ref_init)
    , mColumnCount(0)
    , mColumnIndex(0)
    , mColName()
    , mRefName()
    , mSyntaxNode(cak_qrewrite_ref_init)
    , mOutputColumn(false)
    , mAsterix(false)
	, mStatus(Unidentified)
{
}

Query_Column::Query_Column( SyntaxTreeNodeNo Node, bool SelCol )
    : mQuantifierNode(cak_qrewrite_ref_init)
    , mNodeID(cak_qrewrite_ref_init)
    , mColumnCount(0)
    , mColumnIndex(0)
    , mColName()
    , mRefName()
    , mSyntaxNode(Node)
    , mOutputColumn(SelCol)
    , mAsterix(false)
	, mStatus(Unidentified)
{
}

Query_Column::Query_Column( const Query_Column& C )
	: mNodeID(C.mNodeID)
	, mQuantifierNode(C.mQuantifierNode)
	, mColumnIndex(C.mColumnIndex)       
	, mColumnCount(C.mColumnCount)
	, mColName(C.mColName)
	, mRefName(C.mRefName)
	, mSyntaxNode(C.mSyntaxNode)
	, mOutputColumn(C.mOutputColumn)
	, mAsterix(C.mAsterix) 
	, mStatus(C.mStatus) // DDT
{
}

Query_Column::Query_Column( const Query_Column& C, Query_SyntaxTree& SyntaxTree, Query_NodeMapper* mpMap )
    : mQuantifierNode(C.mQuantifierNode)
    , mNodeID(C.mNodeID)
    , mColumnCount(C.mColumnCount)
    , mColName(C.mColName)
    , mRefName(C.mRefName)
    , mSyntaxNode(C.mSyntaxNode)
    , mOutputColumn(C.mOutputColumn)
    , mAsterix(C.mAsterix)
	, mStatus(C.mStatus) // DDT
{
    SyntaxTree.MapNode(mSyntaxNode, mpMap);
}

// ------------------------------------------------------------------------------------------------
