/*!***************************************************************************

  module      : Query_NodeSet.hpp

  -------------------------------------------------------------------------

  responsible : DirkT

  special area: SQL Manager / Query
  description : 

  last changed: 2004-11-23  16:00
  first created:2004-04-29  10:00

  -------------------------------------------------------------------------

  copyright:    Copyright (c) 2000-2004 SAP AG




    ========== licence begin  GPL
    Copyright (c) 2000-2004 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end



*****************************************************************************/

#ifndef Query_NodeSet_H
#define Query_NodeSet_H

// ------------------------------------------------------------------------------------------------

#include "SAPDB/SQLManager/Query/Query_Node.hpp"

// ------------------------------------------------------------------------------------------------

class Query_SetNode : public Query_Node
{
protected:    // private copyconstuctor used by CreateDuplicate
    Query_SetNode( const Query_SetNode& N, Query_Node* Father, Query_Quantifier* Q, Query_NodeMapper* mpMap );
public:
    Query_SetNode( Query_ManipulationContext& Context, Query_QueryGraph& QueryGraph, Query_Position Position, SyntaxTreeNodeNo APNode, bool All );

    virtual bool Semantics ( bool UniqueOutputColumnNames, bool ComplexViewReplacement, bool& UnidentifiedColumns );
    virtual bool PullDownFQuantifierBegin( Query_Quantifier* Q, SyntaxTreeNodeNo FromQuantifier );
    virtual bool PullDownFQuantifierEnd( Query_Quantifier* Q, SyntaxTreeNodeNo FromQuantifier );
    virtual bool PullDownSearchCond( Container_Vector<Query_Column>*& Columns, SyntaxTreeNodeNo SearchCond );

	virtual bool CreateColRefNamesAndResolveAsterix( SyntaxTreeNodeNo& RefNameNodes ) ;

	virtual bool IsColumnOfTypeLong( SAPDB_Int2 ColumnIndex );

    virtual SAPDB_Int2 OutputColumns( void );
    virtual bool GetOutputColumn( SAPDB_Int2 i, SQLMan_Identifier& ColName );
    virtual bool GetOutputColumnIndex( SAPDB_Int2 i, SAPDB_Int2& ColumnIndex );
    virtual bool CheckForColumn( SQLMan_Identifier Column, SAPDB_Int2& QuantifierSyntaxNode, SAPDB_Int2& ColumnIndex );
    virtual bool CheckForColumn( SQLMan_Identifier Schema, SQLMan_Identifier Table, SQLMan_Identifier Column, SAPDB_Int2& QuantifierSyntaxNode, SAPDB_Int2& ColumnIndex );
    virtual bool CheckQuantifierName( SQLMan_Identifier Schema, SQLMan_Identifier Table );
    virtual void GetIdentificationNames(SQLMan_Identifier& Schema, SQLMan_Identifier& Table);
	virtual bool HasReferenceName( void );

    virtual bool OuterJoin( void );
    virtual bool Aggregates( void );

    bool& All( void )     { return mAllFlg; }

protected:

    SQLMan_Identifier   mReferenceName;
    bool				mAllFlg;
};

// ------------------------------------------------------------------------------------------------

#endif