/*!
 * \file    LVCMem_GlobalAnchorItem.hpp
 * \author  ChristophR
 * \brief   LiveCache global anchor item.
 */
/*

    ========== licence begin  GPL
    Copyright (c) 2002-2004 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end


*/

#ifndef __LVCMEM_GLOBALANCHORITEM_HPP
#define __LVCMEM_GLOBALANCHORITEM_HPP

#include "liveCache/MemoryManagement/LVCMem_UserAllocator.hpp"

class LVCMem_GlobalAnchorItem {
public:
  LVCMem_GlobalAnchorItem(LVCMem_UserAllocatorBase* alloc, SAPDB_Int4 lockId) 
    : m_pAlloc(alloc),m_lockId(lockId),m_pAnchor(NULL),m_isValid(true),m_anchorClassId(0),m_anchorClassSize(0)
  {}
  const SAPDB_Int4 m_lockId;          // Id of corresponding R/W lock
  LVCMem_UserAllocatorBase* m_pAlloc; // Pointer to global shared memory allocator
  void *m_pAnchor;                    // Pointer to entry anchor object
  SAPDB_Int4 m_anchorClassId;         // Class id of entry anchor object
  size_t m_anchorClassSize;           // Size of entry anchor object
  bool m_isValid;                     // Is global shared memory area valid?
};

#endif  // __LVCMEM_GLOBALANCHORITEM_HPP