#!/usr/bin/perl
#
# $Header: //sapdb/V74/develop/sys/src/install/perl/SAPDB/Install/BuildInfo.pm#3 $
# $DateTime: 2002/04/12 13:41:44 $
# $Change: 19381 $
#
# Desc: 

package SAPDB::Install::BuildInfo;

require SDB::Common::Exporter;

our @ISA = qw (SDB::Common::Exporter);
our @EXPORT = qw (GetBuild GetBuildInfo);

bootstrap SAPDB::Install::BuildInfo;

sub AUTOLOAD {
	die unless ($AUTOLOAD =~ /bootstrap$/);

	require XSLoader;
	XSLoader::load (__PACKAGE__);
}

sub GetBuild {
	my  $BUILDINFO = GetBuildInfo (shift);
	return () unless defined ($BUILDINFO->{'Build'});
	return @{$BUILDINFO->{'Build'}};
}

#
# main
#
sub main {
	return (SAPDB::Install::BuildInfo::Test::main (@_));
}

package SAPDB::Install::BuildInfo::Test;

$DEBUG = 0;

use SDB::Common::Getopt::Long;

sub main {
	my ($filename) = @_;

	unless (defined $filename) {
		print "BuildInfo <filename>\n";
		return 0;
	}

	my $buildinfo = SAPDB::Install::BuildInfo::GetBuildInfo ($filename);

	print $filename.":\n";
	while (my ($key, $val) = each (%$buildinfo)) {
		if (ref ($val) eq 'ARRAY') {
			print "  ".$key.": ".join ('.', @$val)."\n";
		} elsif (ref ($val) eq 'HASH') {
			while (my ($subkey, $subval) = each %$val) {
				print "  ".$key.".".$subkey.": ".$subval."\n";
			}
		} else {
			print "  ".$key.": ".$val."\n";
		}
	}

	return 0;
}

1;

