#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/SAPDB/Install/Dialog/DBStop.pm#1 $
# $DateTime: 2005/03/21 16:21:00 $
# $Change: 93297 $
#
# Desc: 


package SAPDB::Install::Dialog::DBStop;

use Wx::Event qw (EVT_CLOSE EVT_BUTTON);
use Wx qw ( wxVERTICAL wxBOTTOM
	wxEXPAND wxALL wxICON_ERROR wxCENTRE
	wxRIGHT wxALIGN_RIGHT wxHORIZONTAL);

use base Wx::Dialog;
use SAPDB::Install::Instance::Base;
use SAPDB::Install::Window::DBLogin;

push @ISA, 'SAPDB::Install::Instance::Base';


#
#	$my_args = {
#				'dbname' => <database name>,
#				'log' => <a object of type SAPDB::Install::Log or with similar interface>,
#			};
#


sub new{
	my ($class,$my_args,@args) = @_;
	my($this ) = $class->SUPER::new(@args);
	$this->{'dbname'} = $my_args->{'dbname'};
	$this->SetTitle('Stop Database '.$my_args->{'dbname'});
	my $sizer = Wx::BoxSizer->new(wxVERTICAL);
	$this->{'login'} = SAPDB::Install::Window::DBLogin->new($my_args,$this,-1);
	$sizer->Add($this->{'login'},1,wxEXPAND | ((wxALL) & (~wxBOTTOM)),10);
	
	my $stop_button = Wx::Button->new($this,-1,'&Stop Database');
	my $cancel_button = Wx::Button->new($this,-1,'&Ignore');
	
	EVT_BUTTON($this,$stop_button->GetId,\&OnStop);
	EVT_BUTTON($this,$cancel_button->GetId,\&OnCancel);
	
	my $button_sizer = Wx::BoxSizer->new(wxHORIZONTAL);
	
	$button_sizer->Add($stop_button,0,wxRIGHT,10);
	$button_sizer->Add($cancel_button,0);
	$sizer->Add($button_sizer,0 , wxALL | wxALIGN_RIGHT  ,10);
	EVT_CLOSE($this,\&OnClose);
	$this->SetSizerAndFit($sizer);
	$this->SetAutoLayout(1);
	$this->Show(1);
	return $this;
}


sub OnStop{
	my ($self,$evt) = @_;
	
	my $user = $self->{'login'}->GetUserName();
	my $pw = $self->{'login'}->GetPassword();
	
	if($user !~ /\S/){
		my $msgbox = Wx::MessageDialog->new($self,'Empty user name!','Missing Parameter',wxICON_ERROR | wxCENTRE);
		$msgbox->ShowModal;
		$msgbox->Destroy;
		return undef;
	}
	
	if($pw !~ /\S/){
		my $msgbox = Wx::MessageDialog->new($self,'Empty password!','Missing Parameter',wxICON_ERROR | wxCENTRE);
		$msgbox->ShowModal;
		$msgbox->Destroy;
		return undef;
	}	
	
	$self->session('dbname' => $self->{'dbname'},
					'userpwd' => $user.','.$pw );
	
	
	if($self->get_errorstate ne 'OK'){
		my $msgbox = Wx::MessageDialog->new($self,$self->{msgtxt},'Cannot Connect to Database '.$self->{'dbname'},wxICON_ERROR | wxCENTRE);
		$msgbox->ShowModal;
		$msgbox->Destroy;
		return undef;
	}
	$self->switchto('offline'); 

	if($self->get_errorstate ne 'OK'){
		my $msgbox = Wx::MessageDialog->new($self,$self->{msgtxt},'Database Shutdown Failed!',wxICON_ERROR | wxCENTRE);
		$msgbox->ShowModal;
		$msgbox->Destroy;
		$self->disconnect();
		return undef;
	}
	$self->disconnect();
	$self->EndModal(1);
}


sub OnCancel{
	my ($self,$evt) = @_;
	$self->EndModal(0);
}

sub OnClose{
	my ($self,$evt) = @_;
	$self->EndModal(0);
}

sub Destroy{
	my ($self) = @_;
	$self->disconnect();
	while($self->GetSizer->Remove(0)) {}
	$self->{'login'}->Destroy;
	delete $self->{'login'};
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) =  @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

1;
