#!/usr/bin/perl
#
# $Header: //sapdb/V76/develop/sys/src/install/perl/SAPDB/Install/Grid/CellPasswdEditor.pm#2 $
# $DateTime: 2004/06/17 07:26:10 $
# $Change: 74592 $
#
# Desc: 


package SAPDB::Install::Grid::CellSizeEditor;

use base Wx::PlGridCellEditor;
use Wx qw(wxSP_ARROW_KEYS wxTheApp);
use Wx::Event qw(EVT_TEXT EVT_KILL_FOCUS);

sub Create {
  my ( $self, $parent, $id, $evthandler ) = @_;
  $self->{'spinner'} = Wx::SpinCtrl->new( $parent, $id, 0,[0,0],[-1,-1],wxSP_ARROW_KEYS,1,32000);
  EVT_KILL_FOCUS($self->{'spinner'},
		sub{
			my ($btn,$evt) = @_;
			if(wxTheApp->Pending){
				$evt->Skip(1);	
			}
			else{
				my $grid = $parent->GetParent;
				bless ($grid,'SAPDB::Install::Grid::Base');
				if($grid->FindNextEditable){
					$grid->EnableCellEditControl(1);
				}
	
			}
		}
  );	
  if($evthandler){
		bless $evthandler,'Wx::EvtHandler';
		$self->{'spinner'}->PushEventHandler($evthandler);
  }
  return 1;	
}


sub SetSize {
  my( $self, $size ) = @_;
  $self->{'spinner'}->SetSize( $size );
}

sub Show {
  my( $self, $show, $attr ) = @_;
  $self->{'spinner'}->Show( $show );
}


sub EndEdit {
	my( $self, $row, $col, $grid ) = @_;
	my $changed = ($self->{'spinner'}->GetValue ne
			 $grid->GetCellValue( $row, $col )); 
	
	$grid->SetCellValue( $row, $col, $self->{'spinner'}->GetValue )
		 if $changed;
	
	return $changed;
}

sub BeginEdit {
	my( $self, $row, $col, $grid ) = @_;
	$self->{'spinner'}->SetValue($grid->GetCellValue( $row, $col));
	$self->{'spinner'}->SetFocus;
	return 1;
}


sub Destroy{
	my ($self) = @_;
	$self->{'spinner'}->Destroy if $self->{'spinner'};
	self->SUPER::Destroy;
}

1;
