#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/SAPDB/Install/Grid/CellStateIconRenderer.pm#1 $
# $DateTime: 2005/03/21 16:21:00 $
# $Change: 93297 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD


package SAPDB::Install::Grid::CellStateIconRenderer;

use base Wx::PlGridCellRenderer;
use Wx qw(wxBLACK_PEN wxWHITE_BRUSH);
use SAPDB::Install::Resources;



our $images = (SAPDB::Install::Resources->
				new('RESOURCES.TGZ'))->getImages('icon/ready.png',
												'icon/process.png',
												'icon/error.png');

our $is_wxGTK = Wx::wxGTK;

if(defined $images){
	foreach my $key (keys(%$images)){
		$images->{$key}->Rescale(16,16);
	}
}

sub Draw {
  my( $self, $grid, $attr, $dc,
		 $rect, $row, $col, $sel ) = ( shift, @_ );
  $self->SUPER::Draw( @_ );
  my $value = $grid->GetCellValue( $row, $col );
  my $y = $rect->y;
  $y += 5 if $is_wxGTK;  
  if($value eq 'FINISHED_SUCCESS'){
	$dc->DrawBitmap(Wx::Bitmap->new($images->{'icon/ready.png'})
					,$rect->x + 20,$y,1);
  }
  elsif($value eq 'RUNNING'){
	$dc->DrawBitmap(Wx::Bitmap->new($images->{'icon/process.png'}),
		$rect->x + 20,$y,1);
  }
  elsif($value eq 'FINISHED_ERROR'){
	$dc->DrawBitmap(Wx::Bitmap->new($images->{'icon/error.png'}),
		$rect->x + 20,$y,1);
  }
  	
}

#sub GetBestSize{
#	my ($grid, $attr, $dc, $row,$col) = @_;
#	print ">>> starting bestsize\n";
#	my $size = Wx::Size->new(24,24); 
#	#print ">>>>> size = $size\n";
#	#return \$size;
#}

sub Clone {
  my $self = shift;
  return $self->new;
}



sub Destroy{
	my ($self) = @_;
	self->SUPER::Destroy;
}

1;
