#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/SAPDB/Install/ObjMngr.pm#1 $
# $DateTime: 2005/03/21 16:21:00 $
# $Change: 93297 $
#
# Desc: 


package SAPDB::Install::ObjMngr;

sub new{
	my ($class) = @_;
	my %member = (
		'Log' => [undef,0],
		'InstReg' => [undef,0],
		'PackageList' => [undef,0],
		'Resource' => [undef,0],
		'Template' => [undef,0],
		'Cleaner' => [undef,0],

		'seq' => 1	# seq is private
	);
	return bless(\%member,$class);
}

sub DESTROY{
	my ($self) = @_;
	$self->KillObjects;	
	1;
}

sub KillObjects{
	my ($self) = @_;
	local *member = $self;
	foreach my $key (sort {$member{$b}->[1] <=> $member{$a}->[1]} keys(%member)){
		if($key eq 'seq'){
			$member{$key} = 1;	
		}
		else{
			if(defined $member{$key}->[0]){
				#print ">>>> killing $key ".$member{$key}->[0]."[id=".$member{$key}->[1]."]\n";
				foreach my $index (2.. $#{@{$member{$key}}}){
					if(defined $member{$key}->[$index]){
							local *deref = $member{$key}->[$index] if defined $member{$key}->[$index];
							#print ">>>> killing ref $index $deref\n";
							$deref = undef;
					}  
				}
				$member{$key} = [undef,0];
			}
		}
	}
	1;
}

sub AUTOLOAD{
	my $self = shift;
	local *member = $self;
	my $sym = $AUTOLOAD;
	$sym =~ s/.*://;
	return if ($sym eq 'seq'); 
	
	if(exists $member{$sym}){
		if(@_){
			my $value = shift;
			$member{$sym} = [$value,defined $value ? $member{'seq'}++ : 0]; 
		}
		else{
			return $member{$sym}->[0];
		}
	}
	else{
		my ($setref_sym) = ($sym =~ /^SetRef(\S+)$/);
		if(exists $member{$setref_sym}){
			local *obj = $member{$setref_sym};
			push @obj,shift;
			return 1; 
		}
		die ("$sym is no member of class ".ref($self)."\n");
	}
	1;
}



1;