package SAPDB::Install::Window::State;

use Wx qw(wxALIGN_CENTRE_VERTICAL
		wxALIGN_CENTER wxALIGN_LEFT
		 wxSOLID wxBLACK);

use SAPDB::Install::Control::StaticImage;
use SAPDB::Install::Resources;


our @ISA = qw(Wx::Panel);

sub new{
	 my($this ) = shift->SUPER::new(@_);
	return $this;
	$this->{'index'} = 0;
	$this->{'states'} = [];
	$this->{'brush'} = Wx::Brush->new($this->GetParent()->GetBackgroundColour(),wxSOLID);
    $this->{'pen'} = Wx::Pen->new(wxBLACK,1,wxSOLID);
	$this->{'mdcs'} = {};
	my $rc = SAPDB::Install::Resources->new('RESOURCES.TGZ');
	#my $img_data = $rc->getData('icon/ready.png','icon/edit.png','icon/process.png','icon/todo.png','icon/error.png');
	#$this->createMDCs($img_data);
	return $this;
}

sub createMDCs{
	my ($self,$img_data) = @_;
	foreach my $id (keys(%$img_data)){
		$self->{'mdcs'}->{$id} = Wx::MemoryDC->new();
		$self->{'mdcs'}->{$id}->SelectObject(Wx::Bitmap->new($img_data->{$id}->[1],$img_data->{$id}->[2]));
		$self->{'mdcs'}->{$id}->BeginDrawing() if $^O =~ /mswin/i;
		$self->{'mdcs'}->{$id}->SetBackground($self->{'brush'});
  		$self->{'mdcs'}->{$id}->Clear;
		my $data = $img_data->{$id}->[0];
		my $row_length = $img_data->{$id}->[1] * 3;;
		my $complete_size =  $row_length * $img_data->{$id}->[2];
		my ($y,$x) = (0,0);
		my $index = 0;
		my $row = 0;
		while(1){
			last if $index >= $complete_size;
			#print ">>> $index\n";
			if($index != 0 && $index % $row_length == 0){
				$row++;	
			}
			#my ($r,$g,$b) = ($data[$index++],$data[$index++],$data[$index++]);
			(my $bcolour,$data) = (($data =~ /^(.{3})(.*$)/)); 
			my ($r,$g,$b) = unpack ('CCC',$bcolour);
			#print ">>>>> RGB: $r|$g|$b\n";
			$index += 3;
			if (($r == 165 && $g == 134 && $b == 179)){ # transparent pixel
				next;
			}
			my @point = (($index % $row_length) / 3,$row);
			#print "\$r,\$g,\$b = $r,$g,$b\n";
			$self->{'pen'}->SetColour($r,$g,$b);
			$self->{'mdcs'}->{$id}->SetPen($self->{'pen'});
			$self->{'mdcs'}->{$id}->DrawPoint(@point);
		}
		$self->{'mdcs'}->{$id}->EndDrawing() if $^O =~ /mswin/i;
	}
}


sub init{
	my ($self,$steps) = @_;
	return 1;
	$self->{'steps'} = $steps;
	my @steps = @$steps;

	my $index = 0;

	my $sizer = Wx::GridSizer->new($#steps + 1 ,2,0,20);
	
	$id = 0;
	local *states = $self->{'states'};
	
	foreach my $step (@steps){
		my $pic = SAPDB::Install::Control::StaticImage->new($self,-1);
		my $static_text = Wx::StaticText->new($self,-1,$step->{'name'},[45,$dy * $index + 30],[150,20], wxALIGN_LEFT);
		$pic->SetMDC($index == 0 ? $self->{'mdcs'}->{'icon/process.png'} : $self->{'mdcs'}->{'icon/todo.png'});
		$pic->Show(1);
		$static_text->Show(1);
		$sizer->Add($pic,0,wxALIGN_CENTRE_VERTICAL | wxALIGN_CENTER);
		$sizer->Add($static_text,0,wxALIGN_CENTRE_VERTICAL|wxALIGN_CENTER);
		push @states, {'text' => $static_text,'pic' => $pic};
		$index++;
	}
	$self->SetSizer($sizer);
	$self->SetAutoLayout(1);
	$self->Layout();
}


sub SetProcess{
	my ($self) = @_;
	return 1;
	$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'icon/process.png'});
}

sub SetEdit{
	my ($self) = @_;
	return 1;
	$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'icon/edit.png'});
}

sub SetReady{
	my ($self) = @_;
	return 1;
	$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'icon/ready.png'});	
}


sub SetError{
	my ($self) = @_;
	return 1;
	$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'icon/error.png'});
	$self->{'error_state'} = 1;	
}



sub Next{
	my ($self,$no_change) = @_; 
	return 1;
	my @steps = @{$self->{'steps'}};
	if($self->{'index'} < $#steps){
		if($self->{'error_state'}){
			$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'error.bmp'}) unless $no_change;
		}
		else{
			$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'ready.bmp'}) unless $no_change;
		}
		$self->{'index'}++;
		$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'process.bmp'});	
	}
}

sub Prev{
	my ($self) = @_; 
	return 1;
	if($self->{'index'} > 0){
		$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'todo.bmp'});
		$self->{'index'}--;
		$self->{'states'}->[$self->{'index'}]->{'pic'}->SetMDC($self->{'mdcs'}->{'process.bmp'});
	}
}

sub Destroy{
	my ($self) = @_;
	#if (defined $self->GetSizer){
	#	while($self->GetSizer->Remove(0)){}
#
#	}
#	foreach my $state (@{$self->{'states'}}){
#		$state->{'text'}->Destroy;
#		$state->{'pic'}->Destroy;
#	}
#	delete $self->{'states'};
#	delete $self->{'states'};
#	delete $self->{'brush'};
 #   delete $self->{'pen'};
#	delete $self->{'mdcs'};
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>>> destroying $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}


1;