/*
 * SDBInst.c
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/SDBPack.c#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 *
 */

static char szWhatHeader[] =
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/SDBPack.c#1 $";

/*
 * general perl preprocessor code
 */
#ifndef WIN32
#define UNIX
#endif
 
#include "helpers.h"
#include <string.h>

#ifdef UNIX
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#endif

#ifdef WIN32 
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <direct.h>
#endif

#define MAINSYM_KEY  "--main"
#define MAINSYM_VAL  "SAPDB::Install::BuildPackage::main"

#define PROGRAMNAME_KEY "--programname"
#define PROGRAMNAME_VAL "sdbpack"

int
main (int argc, char **argv, char **env) {
	char *ProgName;
	char *RelPath;
	int num_of_args;
	int exec_argc;
	char **exec_argv;

	char *MainsymKey   = MAINSYM_KEY;
	char *MainsymVal   = MAINSYM_VAL;
	char *PrognameKey  = PROGRAMNAME_KEY;
	char *PrognameVal  = PROGRAMNAME_VAL;
	char *Separator    = PATH_SEPARATOR;
	char *RuntimeName  = RUNTIME_NAME;
	char *RuntimePath  = RUNTIME_PATH;
	char *RunInstalled = USE_INSTALLED_RUNTIME;

	int needMainsym;
	int useFullname;
	int isInstalled;
	char *binname;

	ProgName = getProgName (argv[0]);

	RelPath = getRelPath (argv[0]);
	useFullname = (RelPath && strlen (RelPath) > 0) ? 1 : 0;

	binname = 0;
	if (useFullname) {
		binname = 
		alloca (strlen (RelPath) + strlen (Separator) + 
		        strlen (RuntimeName) + 1);
		strcpy (binname, RelPath); 
		strcat (binname, Separator); 
		strcat (binname, RuntimeName); 
	}

	/*
	 * may be it was called using $PATH
	 */
	isInstalled = 0;
	if (binname == 0 || access (binname, R_OK | X_OK) != 0) {
		char *AbsPath;

		AbsPath = getAbsPath (argv[0]);
		if (AbsPath == 0) {
			printf ("cannot find path for arg0: %s\n", argv[0]);
			return -1;	
		}

		/* is it in the same dir */
		binname =
		alloca (strlen (AbsPath) + 1 + strlen (RuntimeName) + 1);
		strcpy (binname, AbsPath);
		strcat (binname, PATH_SEPARATOR);
		strcat (binname, RuntimeName);

		if (access (binname, R_OK | X_OK) != 0) {
			/* is it in the ../install dir */
			binname =
			alloca (strlen (AbsPath) + 1 + 
			strlen (RuntimePath) + strlen (RuntimeName) + 1);
			strcpy (binname, AbsPath);
			strcat (binname, PATH_SEPARATOR);
			strcat (binname, RuntimePath);
			strcat (binname, RuntimeName);
			isInstalled = 1;
		}
		
		free (AbsPath);
	}

	num_of_args = argc + 3;
	
	needMainsym = hasMainSymbolInArgv (argc, argv) == 0 ? 1 : 0;
	if (needMainsym)
		num_of_args += 2;

	if (isInstalled)
		num_of_args++;

	exec_argv = alloca ((num_of_args) * sizeof (char *));

	for (exec_argc = 0; exec_argc < argc; exec_argc++) {
		exec_argv[exec_argc] = argv[exec_argc];
	}

	exec_argv[exec_argc++] = PrognameKey;
	exec_argv[exec_argc++] = PrognameVal;

	if (needMainsym) {
		exec_argv[exec_argc++] = MainsymKey;
		exec_argv[exec_argc++] = MainsymVal;
	}

	if (isInstalled)
		exec_argv[exec_argc++] = RunInstalled;

	exec_argv[exec_argc] = 0;

	free (RelPath);
	free (ProgName);
	return (LoadAndExec (binname, exec_argc, exec_argv, env));
}
