/*
 * SDBInst.c
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/SDBSetup.c#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 *
 */

static char szWhatHeader[] =
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/SDBSetup.c#1 $";

/*
 * general perl preprocessor code
 */
#ifndef WIN32
#define UNIX
#endif
 
#include "helpers.h"
#include <string.h>

#ifdef UNIX
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <pwd.h> 
#endif

#ifdef WIN32 
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <direct.h>
#endif

#define MAINSYM_KEY  "--main"
#define MAINSYM_VAL  "SAPDB::Install::App::StartSetup::main"

#define PROGRAMNAME_KEY "--programname"
#define PROGRAMNAME_VAL "SDBSETUP"



#ifdef UNIX

int findsu(char ** szsu,char ** szcmdopt,char ** sztermopt){
	char * szenvpath;
	char * szsearchpath;
	char * szextrapath = ":/opt/kde3/bin:/usr/local/kde3/bin:/opt/kde2/bin:/usr/local/kde2/bin:/usr/bin:/bin:/usr/sbin:/sbin";
	char * prog[2];
	char * cmdopt[2];
	char * termopt[2];
	int i;
	prog[0] = "kdesu";
	cmdopt[0] = "-c";
	termopt[0] = "-t";
	prog[1] = "userhelper";
	cmdopt[1] = "-w";
	termopt[1] = 0;
	szenvpath = getenv("PATH");
	if(szenvpath == 0){
		szsearchpath = (char *) malloc(1);
		if(szenvpath == 0)
			return -1;
		*szsearchpath = 0;
	}
	szsearchpath = (char *) malloc(strlen(szenvpath) + strlen(szextrapath) + 1);
	if(szsearchpath == 0)
		return -1;
	memset(szsearchpath,0,strlen(szenvpath) + strlen(szextrapath) + 1);
	strcpy(szsearchpath,szenvpath);
	strcpy(szsearchpath + strlen(szsearchpath),szextrapath);
		
	if(szenvpath == 0)
		return 1;
	
	for(i=0;i<1;i++){
		char * szcursearch = szsearchpath;
		for(;;){
			char * sztestaccess;
			char * pos;
			
			if(strlen(szcursearch) == 0)
				break;
								   
			pos = strchr(szcursearch,':');
		
			if(pos == 0){
				sztestaccess = (char *) malloc(strlen(szcursearch) + strlen(prog[i]) + 2);
				if(sztestaccess == 0){
					free(szsearchpath);
					return -1;
				}
				memset(sztestaccess,0,strlen(szcursearch) + strlen(prog[i]) + 2);	
				strcpy(sztestaccess,szcursearch);
			}
			else{
				int len = pos - szcursearch;
				if(len > 0){
					sztestaccess = (char *) malloc(len + strlen(prog[i]) + 2); 
					if(sztestaccess == 0){
						free(szsearchpath);
						return -1;
					}
					memset(sztestaccess,0,len + strlen(prog[i]) + 2);
					sztestaccess = strncpy(sztestaccess,szcursearch,len);
			
				
				}
			}
		
			strcpy(sztestaccess + strlen(sztestaccess),"/");
			strcpy(sztestaccess + strlen(sztestaccess),prog[i]);
			if(access(sztestaccess,X_OK) == 0){
				if (termopt[i] != 0){
					*sztermopt = (char *) malloc(strlen(termopt[i]) + 1);
					 memset(*sztermopt,0,strlen(termopt[i]) + 1);
				 	strcpy(*sztermopt,termopt[i]);
				}
				*szcmdopt = (char *) malloc(strlen(cmdopt[i]) + 1);
				 memset(*szcmdopt,0,strlen(cmdopt[i]) + 1);
				 strcpy(*szcmdopt,cmdopt[i]);
				*szsu = sztestaccess;
				free(szsearchpath);
				return 0;	
			}
			free(sztestaccess);
			if(pos == 0)
				break;
			szcursearch = pos  + 1;
		}
	}
	free(szsearchpath);
	return 1;	
} 

#endif /*UNIX*/

int
main (int argc, char **argv, char **env) {
	char *ProgName;
	int num_of_args;
	int exec_argc;
	char **exec_argv;

	char *MainsymKey   = MAINSYM_KEY;
	char *MainsymVal   = MAINSYM_VAL;
	char *PrognameKey  = PROGRAMNAME_KEY;
	char *PrognameVal  = PROGRAMNAME_VAL;
	char *Separator    = PATH_SEPARATOR;
	char *RuntimeName  = RUNTIME_NAME;
	char *RuntimePath  = RUNTIME_PATH;
	char *RunInstalled = USE_INSTALLED_RUNTIME;

	int needMainsym;
	int useFullname;
	int isInstalled;
	char *binname;
#ifdef UNIX
	char * szsu;
	char * szsutermopt = 0;
	char * szsucmdopt;
		
	
	/*
	*	try to find kdesu
	*	to switch to root user
	*
	*/
	
	uid_t uid = geteuid();
	
	if(uid != 0 && findsu(&szsu,&szsucmdopt,&szsutermopt) == 0){
		char * arg;
		char * user = "";
		char * switch_user = "-upuser";
		char * separator = " ";
		char * szabspath;
		char * szprogname;
		int ignore_pressed = 0; 
		int arglen = 0;
		int i;
		struct passwd * pwent = getpwuid(uid);
		if(pwent != 0){
			user = pwent->pw_name;
		}
		
		szabspath = getAbsPath(argv[0]);
		szprogname = getProgName(argv[0]);
		
		arglen += strlen(szabspath) + strlen(szprogname) + strlen(separator) + 1;
		
		for(i = 1; i< argc;i++){
			if(argv[i] != 0 && strcmp(argv[i],switch_user) == 0)
				ignore_pressed = 1;
			arglen += strlen(argv[i]) + strlen(separator); 	
		}
		
		if(!ignore_pressed){
			arglen += strlen(user) + strlen(switch_user) + strlen(separator); 
		
			arg = (char *) malloc(arglen + 1);
			memset(arg,0,arglen + 1);
		
			strcpy(arg,szabspath);
			strcpy(arg + strlen(arg),"/");
			strcpy(arg + strlen(arg),szprogname);
			strcpy(arg + strlen(arg),separator);
		
			for(i = 1; i< argc;i++){
				strcpy(arg + strlen(arg),argv[i]);
				strcpy(arg + strlen(arg),separator);
			}
				
			if(strlen(user) > 0){
				strcpy(arg + strlen(arg),switch_user);
				strcpy(arg + strlen(arg),separator);
				strcpy(arg + strlen(arg),user);	
			}
			if(szsutermopt == 0){
				return execle(szsu,szsucmdopt,arg,0,env);
			}
			else{
				return execle(szsu,szsucmdopt,arg,szsutermopt,0,env);
			}
		}
	}
#endif	

	
	ProgName = getProgName (argv[0]);
	

	binname = 0;

	/*
	 * may be it was called using $PATH
	 */
	isInstalled = 0;
	if (binname == 0 || access (binname, R_OK | X_OK) != 0) {
		char *AbsPath;

		AbsPath = getAbsPath (argv[0]);
		if (AbsPath == 0) {
			printf ("cannot find path for arg0: %s\n", argv[0]);
			return -1;	
		}

		/* is it in the same dir */
		binname =
		alloca (strlen (AbsPath) + 1 + strlen (RuntimeName) + 1);
		strcpy (binname, AbsPath);
		strcat (binname, PATH_SEPARATOR);
		strcat (binname, RuntimeName);

		if (access (binname, R_OK | X_OK) != 0) {
			/* is it in the ../install dir */
			binname =
			alloca (strlen (AbsPath) + 1 + 
			strlen (RuntimePath) + strlen (RuntimeName) + 1);
			strcpy (binname, AbsPath);
			strcat (binname, PATH_SEPARATOR);
			strcat (binname, RuntimePath);
			strcat (binname, RuntimeName);
			isInstalled = 1;
		}
		
		free (AbsPath);
	}

	num_of_args = argc + 3;
	
	needMainsym = hasMainSymbolInArgv (argc, argv) == 0 ? 1 : 0;
	if (needMainsym)
		num_of_args += 2;

	if (isInstalled)
		num_of_args++;

	exec_argv = alloca ((num_of_args) * sizeof (char *));

	for (exec_argc = 0; exec_argc < argc; exec_argc++) {
		exec_argv[exec_argc] = argv[exec_argc];
	}

	exec_argv[exec_argc++] = PrognameKey;
	exec_argv[exec_argc++] = PrognameVal;

	if (needMainsym) {
		exec_argv[exec_argc++] = MainsymKey;
		exec_argv[exec_argc++] = MainsymVal;
	}

	if (isInstalled)
		exec_argv[exec_argc++] = RunInstalled;

	exec_argv[exec_argc] = 0;
	free (ProgName);
	return (LoadAndExec (binname, exec_argc, exec_argv, env));
}
