/*
 * SDBUpd.c
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/SDBUpd.c#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 *
 */

static char szWhatHeader[] =
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/SDBUpd.c#1 $";

/*
 * general perl preprocessor code
 */
#ifndef WIN32
#define UNIX
#endif

#include "helpers.h"
#include <string.h>

#define MAINSYM_KEY     "--main"
#define MAINSYM_VAL     "SAPDB::Install::InstanceUpgrade::main"

#define PROGRAMNAME_KEY "--programname"
#define PROGRAMNAME_VAL "SDBUPD"

int
main (int argc, char **argv, char **env) {
	char *RelPath;
	char *ProgName;
	int exec_argc;
	char **exec_argv;

	char *MainsymKey  = MAINSYM_KEY;
	char *MainsymVal  = MAINSYM_VAL;
	char *PrognameKey = PROGRAMNAME_KEY;
	char *PrognameVal = PROGRAMNAME_VAL;
	char *Separator   = PATH_SEPARATOR;
	char *RuntimeName = RUNTIME_NAME;

	int needMainsym;
	int useFullname;
	char *binname;

	ProgName = getProgName (argv[0]);

	needMainsym = hasMainSymbolInArgv (argc, argv) == 0 ? 1 : 0;
	if (needMainsym) {
		exec_argv = alloca ((argc + 5) * sizeof (char *));
	} else {
		exec_argv = alloca ((argc + 3) * sizeof (char *));
	}

	for (exec_argc = 0; exec_argc < argc; exec_argc++) {
		exec_argv[exec_argc] = argv[exec_argc];
	}

	if (needMainsym) {
		exec_argv[exec_argc++] = MainsymKey;
		exec_argv[exec_argc++] = MainsymVal;
	}

	exec_argv[exec_argc++] = PrognameKey;
	exec_argv[exec_argc++] = PrognameVal;

	exec_argv[exec_argc] = 0;

	RelPath = getRelPath (argv[0]);
	useFullname = (RelPath != 0 && strlen (RelPath) > 0) ? 1 : 0;
	if (useFullname) {
		exec_argv[0] = 
		alloca (strlen (RelPath) + strlen (Separator) + 
		        strlen (RuntimeName) + 1);
		strcpy (exec_argv[0], RelPath); 
		strcat (exec_argv[0], Separator); 
		strcat (exec_argv[0], RuntimeName); 
	} else {
		exec_argv[0] = alloca (strlen (RuntimeName) + 1);
		strcpy (exec_argv[0], RuntimeName); 
	}

	free (RelPath);
	free (ProgName);
	return (LoadAndExec (exec_argv[0], exec_argc, exec_argv, env));
}

