/*
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/SDBVerify.c#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 *
 */

static char szWhatHeader[] =
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/SDBVerify.c#1 $";
 
/*
 * general perl preprocessor code
 */
#ifndef WIN32
#define UNIX
#endif

#include "helpers.h"
#include <string.h>

#define MAINSYMBOL_KEY  "--main"
#define MAINSYMBOL_VAL  "SAPDB::Install::InstallRegistry::Verify::main"

#define PROGRAMNAME_KEY "--programname"
#define PROGRAMNAME_VAL "sdbverify"

int
main (int argc, char **argv, char **env) {
	char *RelPath;
	char *ProgName;
	int exec_argc;
	char **exec_argv;

	char *MainsymKey   = MAINSYMBOL_KEY;
	char *MainsymVal   = MAINSYMBOL_VAL;
	char *PrognameKey  = PROGRAMNAME_KEY;
	char *PrognameVal  = PROGRAMNAME_VAL;
	char *Separator    = PATH_SEPARATOR;
	char *RuntimeName  = RUNTIME_NAME;
	char *RuntimePath  = RUNTIME_PATH;
	
	int needMainsym;
	int useFullname;

	char *binname;
	
	ProgName = getProgName (argv[0]);

	needMainsym = hasMainSymbolInArgv (argc, argv) == 0 ? 1 : 0;
	if (needMainsym) {
		exec_argv = alloca ((argc + 5) * sizeof (char *));
	} else {
		exec_argv = alloca ((argc + 3) * sizeof (char *));
	}

	for (exec_argc = 0; exec_argc < argc; exec_argc++)
		exec_argv[exec_argc] = argv[exec_argc];

	if (needMainsym) {
		exec_argv[exec_argc++] = MainsymKey;
		exec_argv[exec_argc++] = MainsymVal;
	}

	exec_argv[exec_argc++] = PrognameKey;
	exec_argv[exec_argc++] = PrognameVal;

	exec_argv[exec_argc] = 0;

	RelPath = getRelPath (argv[0]);
	useFullname = (RelPath && strlen (RelPath) > 0) ? 1 : 0;
	if (useFullname) {
		binname = 
		alloca (strlen (RelPath) + strlen (Separator) + 
			  strlen(RuntimePath)+ strlen (RuntimeName) + 1);

		strcpy (binname, RelPath);
		strcat (binname, Separator);
		strcat (binname, RuntimePath);
		strcat (binname, RuntimeName);
	} else {
		char *AbsPath;

		AbsPath = getAbsPath (argv[0]);
		if (AbsPath == 0) {
			printf ("cannot find path for arg0: %s\n", argv[0]);
			return -1;	
		}

		binname =
		alloca (strlen (AbsPath) + 1 + 
		strlen (RuntimePath) + strlen (RuntimeName) + 1);
		strcpy (binname, AbsPath);
		strcat (binname, PATH_SEPARATOR);
		strcat (binname, RuntimePath);
		strcat (binname, RuntimeName);

		free (AbsPath);
	}

	free (RelPath);
	free (ProgName);
	return (LoadAndExec (binname, exec_argc, exec_argv, env));
}
