/*
 * helpers.h
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/helpers/helpers.h#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 *
 */

#ifndef SAPDB_INSTALL_HELPERS_H_INCLUDED
#define SAPDB_INSTALL_HELPERS_H_INCLUDED SAPDB_INSTALL_HELPERS_H_INCLUDED
/*
 * general perl preprocessor code
 */
#ifndef WIN32
#define UNIX
#endif

#ifdef WIN32
#define NEED_ACCESS_MACROS NEED_ACCESS_MACROS
#endif

#ifdef NEED_ACCESS_MACROS
#define access(a,b) _access(a,b)
#ifndef R_OK
#define R_OK 4
#endif
#ifndef X_OK
#define X_OK 0
#endif
#endif

/*
 * preprocessor code for alloca ()
 */
#ifdef _AIX
#define NEED_PRAGMA_ALLOCA NEED_PRAGMA_ALLOCA
#endif
#if defined UNIX && !defined _AIX && !defined SNI
#define NEED_ALLOCA_H  NEED_ALLOCA_H
#endif
#if defined NEED_ALLOCA_H
#include <alloca.h>
#elif defined NEED_PRAGMA_ALLOCA
#pragma alloca
#endif
#if defined __osf__ || defined linux
#define HAS_MKDTEMP HAS_MKDTEMP 
#endif


#ifdef WIN32
#define alloca(size) _alloca(size)
#endif

/*
 * application specific constants
 */
#ifdef WIN32
#define RUNTIME_NAME "sdbrun.dll"
#define RUNTIME_PATH "..\\install\\"
#define PATH_SEPARATOR "\\"
#define PATH_SEPARATOR_CHAR '\\'
#define PATH_SPLIT_CHAR ';'
#define SDBINST_NAME "sdbinst.exe"
#endif
#ifdef UNIX
#define RUNTIME_NAME "SDBRUN"
#define RUNTIME_PATH "../install/"
#define PATH_SEPARATOR "/"
#define PATH_SEPARATOR_CHAR '/'
#define PATH_SPLIT_CHAR ':'
#define SDBINST_NAME "SDBINST"
#endif

#define USE_INSTALLED_RUNTIME "-installed_sdbrun_used"

/*
 * exported functions
 */
char *getAbsPath (char *);
char *getRelPath (char *);
char *getProgName (char *);
int hasMainSymbolInArgv (int, char **);
int LoadAndExec (char *, int, char **, char **);
#ifdef UNIX
int PrepareLibs (char*,char**,char**);
#endif

#endif

