#!/usr/bin/perl
#
# $SRC/install/perl/Makefile.PL
#
# $Header: //sapdb/V74/develop/sys/src/install/perl/Makefile.PL#27 $
# $DateTime: 2002/10/04 11:14:03 $
# $Change: 28214 $
#

use Config;
use Symbol;

sub main {
	print "Generating Makefile for libs\n";

	my %Makedefs = ();

	write_makefile (%Makedefs);

	#
	# setup include path for cross compilation environment
	#
	if ($^O =~ /mswin/i && $Config{'archname'} =~ /IA64/) {
		push @INC, "../win64/libx86", "../win64/lib";
	}

	chdir ("zlib"); do ("Makefile.PL"); chdir ("..");
	chdir ("zip"); do ("Makefile.PL"); chdir ("..");
}

sub write_makefile {
	my %Makedefs = @_;
	my $fh = gensym ();
	open ($fh, "> Makefile");
	print ($fh
	"#\n".
	"# Makefile\n".
	"# this file is generated from Makefile.PL\n".
	"# do not edit this file, any changes will be lost\n".
	"#\n".
	"\n".	
	".SUFFIXES:\n".
	"\n");

	if ($^O =~ /^aix/) {
		print ($fh
		"#\n".
		"# make sure that we are in 32 bit mode on aix\n".
		"#\n".
		"OBJECT_MODE = 32\n".
		"\n");
	}

	while (my ($key, $value) = each %Makedefs) {
		next unless (defined $value);
		print ($fh $key." = ".$value."\n");
	}
	print $fh ("\n");

	write_body ($fh);
	close ($fh);
}

sub write_body {
	my $fh = shift;
	while (<DATA>) {
		chomp;

		print ($fh $_."\n");
	}
}

main (@ARGV);

__DATA__
all:
	cd zlib && $(MAKE)
	cd zip && $(MAKE)

clean:
	cd zlib && $(MAKE) clean
	cd zip && $(MAKE) clean

