/*
 * GetBuild.xs
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/BuildInfo.xs#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 */

static char szWhatHeader[] = 
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/BuildInfo.xs#1 $";

#ifndef __cplusplus
#ifndef HAS_BOOL
typedef char bool;
#endif
#endif

#ifndef WIN32
#define UNIX UNIX
#endif

#ifdef __hpux
#define DONT_DECLARE_STD
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef PERL_OBJECT
#define FILE struct _PerlIO
#endif

/*
 * expect compiler warning 4113 when using Microsoft C
 * in c code generated by xs preprocessor
 */
#if _MSC_VER >= 1200
#pragma warning(disable : 4113)
#pragma warning(disable : 4101)
#endif

/*
 * windows ia64 has problems with get magic for jar files
 */
#if defined WIN32 && defined _M_IA64
#pragma optimize ("", off)
#endif 

#ifdef __cplusplus
#define externC extern "C"
#else
#define externC extern
#endif

#ifdef UNIX
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#endif

#ifdef WIN32
#include <WINDOWS.h>
#include <tchar.h>
#include <io.h>
#include <fcntl.h>
#endif

#ifdef WIN32
#ifndef alloca
#define alloca(size) _alloca(size)
#endif
#define snprintf _snprintf
#endif

#ifdef _AIX
#define NEED_PRAGMA_ALLOCA NEED_PRAGMA_ALLOCA
#endif
#if defined UNIX && !defined _AIX && !defined SNI
#define NEED_ALLOCA_H  NEED_ALLOCA_H
#endif

#if defined NEED_ALLOCA_H
#include <alloca.h>
#elif defined NEED_PRAGMA_ALLOCA
#pragma alloca
#endif

#if defined WIN32
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#define NEED_TYPEDEF_UNIT16_T NEED_TYPEDEF_UNIT16_T
#define NEED_TYPEDEF_UNIT32_T NEED_TYPEDEF_UNIT32_T
#define NEED_TYPEDEF_UNIT64_T NEED_TYPEDEF_UNIT64_T
#elif defined linux
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __hpux && defined __hppa
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __hpux && defined __ia64 && ! defined HAS_STRTOLL
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __osf__
#define NEED_TYPEDEF_UNIT16_T NEED_TYPEDEF_UNIT16_T
#define NEED_TYPEDEF_UNIT32_T NEED_TYPEDEF_UNIT32_T
#define NEED_TYPEDEF_UNIT64_T NEED_TYPEDEF_UNIT64_T
#define NEED_SNPRINTF NEED_SNPRINTF
#define HAS_SPRINTF_INTRINSIC HAS_SPRINTF_INTRINSIC
#endif

#ifdef NEED_TYPEDEF_UCHAR_T
typedef unsigned char  uchar_t;
#endif
#ifdef NEED_TYPEDEF_UNIT16_T
typedef unsigned short uint16_t;
#endif
#ifdef NEED_TYPEDEF_UNIT32_T
typedef unsigned int   uint32_t;
#endif
#ifdef NEED_TYPEDEF_UNIT64_T
typedef unsigned long  uint64_t;
#endif

#if defined _WIN64
typedef __int64 ptr_t;
#else
typedef long ptr_t;
#endif

#ifdef HAS_SPRINTF_INTRINSIC
#define snprintf mysnprintf
#endif 

#ifdef NEED_SNPRINTF
#include <stdarg.h>
static int
snprintf (char *sz_out, int cb_out, char *fmt, ...) {
	int rc;

	va_list args;
	va_start (args, fmt);
	rc = vsprintf (sz_out, fmt, args);
	va_end (args);

	return (rc);
}
#endif

#define BUFFER_SIZE         (512 * 1024)
#define LINE_SIZE            (64 * 1024)

#define BUILD_TYPE_REL 1
#define BUILD_TYPE_APO 2
#define BUILD_TYPE_JAR 3

typedef struct {
	int type;
	int major;
	int minor;
	int correction;
	int build;
} build_t;

typedef struct sysinfo {
	char *key;
	char *val;
	struct sysinfo *next;
} info_t;

typedef int (*readfunc_t) (void *, char *, int);

#ifdef WIN32
static char *
convert_slashes (char *filename) {
	unsigned int i;
	/*
	 * convert slashes in filename
	 */
	for (i = 0; i <= strlen (filename); i++) {
		if (filename[i] == '/') filename[i] ='\\';
	}

	return (filename);
}
#endif

/*
 * common helper functions get magic
 */
typedef struct {
	int value;
	char name[64];
} names_t;

static char 
*get_name (int value, names_t *ptr) {
	while (ptr->value >= 0) {
		if (ptr->value == value) {
			return (ptr->name);
		}
		ptr++;
	} 
	return 0;
}

static int is_windowsdos (char *, char *, int);
static int is_windowspe (char *, char *, int);
static int is_coffalpha (char *, char *, int);
static int is_elf (char *, char *, int);
static int is_elf32 (char *, char *, int);
static int is_elf64 (char *, char *, int);
static int is_hpuxsom (char *, char *, int);
static int is_aix (char *, char *, int);

/*
 * SYSV, Linux and HP-UX (64-bit) ELF-Header
 */
typedef struct {
	uchar_t ei_magic[4];
	uchar_t ei_class;
	uchar_t ei_data;
	uchar_t ei_version;
	uchar_t ei_osabi;
	uchar_t ei_abiversion;
	uchar_t ei_pad[7];
} elf_ident_t;

typedef struct {
	elf_ident_t e_ident;   /* Magic number and other info */
	uint16_t e_type;       /* Object file type */
	uint16_t e_machine;    /* Architecture */
	uint32_t e_version;    /* Object file version */
	uint32_t e_entry;      /* Entry point virtual address */
	uint32_t e_phoff;      /* Program header table file offset */
	uint32_t e_shoff;      /* Section header table file offset */
	uint32_t e_flags;      /* Processor-specific flags */
	uint16_t e_ehsize;     /* ELF header size in bytes */
	uint16_t e_phentsize;  /* Program header table entry size */
	uint16_t e_phnum;      /* Program header table entry count */
	uint16_t e_shentsize;  /* Section header table entry size */
	uint16_t e_shnum;      /* Section header table entry count */
	uint16_t e_shstrndx;   /* Section header string table index */
} elf32_hdr_t;

typedef struct {
	elf_ident_t  e_ident;  /* Magic number and other info */
	uint16_t e_type;       /* Object file type */
	uint16_t e_machine;    /* Architecture */
	uint32_t e_version;    /* Object file version */
	uint64_t e_entry;      /* Entry point virtual address */
	uint64_t e_phoff;      /* Program header table file offset */
	uint64_t e_shoff;      /* Section header table file offset */
	uint32_t e_flags;      /* Processor-specific flags */
	uint16_t e_ehsize;     /* ELF header size in bytes */
	uint16_t e_phentsize;  /* Program header table entry size */
	uint16_t e_phnum;      /* Program header table entry count */
	uint16_t e_shentsize;  /* Section header table entry size */
	uint16_t e_shnum;      /* Section header table entry count */
	uint16_t e_shstrndx;   /* Section header string table index */
} elf64_hdr_t;

static names_t elf_class_names[] = {
	{0, "invalid class"},
	{1, "32-bit"},
	{2, "64-bit"},
	{-1, ""}
};

static names_t elf_data_names[] = {
	{0, "invalid data encoding"},
	{1, "lsb"},
	{2, "msb"},
	{-1, ""}
};

static names_t elf_mach_names[] = {
	{ 0, "no machine"},
	{ 1, "AT&T WE32100"},
	{ 2, "SPARC"},
	{ 3, "i386"},
	{ 4, "Motorola 68000"},
	{ 5, "Motorola 88000"},
	{ 6, "i486"},
	{ 7, "i860"},
	{ 8, "MIPS R3000 big endian"},
	{10, "MIPS R3000 little endian"},
	{11, "RS6000"},
	{15, "PA-RISC"},
	{16, "nCUBE"},
	{17, "Fujitsu VPP500"},
	{18, "SPARC V8plus"},
	{20, "PPC"},
	{21, "PPC64"},
	{22, "S390"},
	{43, "SPARC V9"},
	{50, "IA64"},
	{62, "X86-64"},
	{-1, ""}
};

static names_t elf_type_names[] = {
	{0, "no type"},
	{1, "relocatable object"},
	{2, "executable"},
	{3, "shared object"},
	{4, "core"},
	{-1, ""}
};

static names_t elf_osabi_names[] = {
	{0, ""},
	{1, "HP-UX ABI"},
	{-1, ""}
};

static uchar_t ei_magic[4] = {0x7f, 'E', 'L', 'F'};

static int
is_elf (char *buff, char *sz_text, int cb_text) {
	if (is_elf32 (buff, sz_text, cb_text) == 0) {
		return 0;
	}

	if (is_elf64 (buff, sz_text, cb_text) == 0) {
		return 0;
	}
	return -1;
}

static int
is_elf32 (char *buff, char *sz_text, int cb_text) {
	elf32_hdr_t *elf_hdr;
	char *mach;
	char *type;
	char *elfclass;
	char *data;	
	char *osabi;	

	elf_hdr = (elf32_hdr_t*) buff;

	/* look for elf magic */
	if (memcmp 
	(elf_hdr->e_ident.ei_magic, ei_magic, sizeof (ei_magic)) != 0) {
		return -1;
	}

	/* look for elf 32-bit elf class */
	if (elf_hdr->e_ident.ei_class != 1) {
		return -1;
	}

	/* current version of elf header must be 1 */
	if ((elf_hdr->e_ident.ei_version != 1) || 
	    (elf_hdr->e_version != 1)) {
		return -1;
	}
	
	osabi = get_name (elf_hdr->e_ident.ei_osabi, elf_osabi_names);
	if (osabi == 0) {
		return -1;
	}

	elfclass = get_name (elf_hdr->e_ident.ei_class, elf_class_names);
	if (elfclass == 0) {
		return -1;
	}

	data = get_name (elf_hdr->e_ident.ei_data, elf_data_names);
	if (data == 0) {
		return -1;
	}

	mach = get_name (elf_hdr->e_machine, elf_mach_names);
	if (mach == 0) {
		return -1;
	}

	type = get_name (elf_hdr->e_type, elf_type_names);
	if (type == 0) {
		return -1;
	}

	if (strlen (osabi) != 0) {
		snprintf (sz_text, cb_text - 1, 
		"elf %s %s %s %s %s", osabi, elfclass, data, mach, type);
	} else {
		snprintf (sz_text, cb_text - 1, 
		"elf %s %s %s %s", elfclass, data, mach, type);
	}
	return 0;
}

static int
is_elf64 (char *buff, char *sz_text, int cb_text) {
	elf64_hdr_t *elf_hdr;
	char *mach;
	char *type;
	char *elfclass;
	char *data;	
	char *osabi;

	elf_hdr = (elf64_hdr_t *) buff;
	
	/* look for elf magic */
	if (memcmp 
	(elf_hdr->e_ident.ei_magic, ei_magic, sizeof (ei_magic)) != 0) {
		return -1;
	}

	/* look for elf 64-bit elf class */
	if (elf_hdr->e_ident.ei_class != 2) {
		return -1;
	}

	osabi = get_name (elf_hdr->e_ident.ei_osabi, elf_osabi_names);
	if (osabi == 0) {
		return -1;
	}

	elfclass = get_name (elf_hdr->e_ident.ei_class, elf_class_names);
	if (elfclass == 0) {
		return -1;
	}

	data = get_name (elf_hdr->e_ident.ei_data, elf_data_names);
	if (data == 0) {
		return -1;
	}

	mach = get_name (elf_hdr->e_machine, elf_mach_names);
	if (mach == 0) {
		return -1;
	}

	type = get_name (elf_hdr->e_type, elf_type_names);
	if (type == 0) {
		return -1;
	}

	if (strlen (osabi) != 0) {
		snprintf (sz_text, cb_text - 1, 
		"elf %s %s %s %s %s", osabi, elfclass, data, mach, type);
	} else {
		snprintf (sz_text, cb_text - 1, 
		"elf %s %s %s %s", elfclass, data, mach, type);
	}
	return 0;
}

/*
 * true64 alpha coff
 */
typedef struct {
        uint16_t f_magic;        /* magic number */
        uint16_t f_nscns;        /* number of sections */
        uint32_t f_timdat;       /* time & date stamp */
        uint64_t f_symptr;       /* file pointer to symbolic header */
        uint32_t f_nsyms;        /* sizeof(symbolic hdr) */
        uint16_t f_opthdr;       /* sizeof(optional hdr) */
        uint16_t f_flags;        /* flags */
} coff64_filehdr_t;

typedef struct {
	uint16_t magic;		/* aout magic */
	uint16_t vstamp;	/* version stamp */ 
} coff_aoutmagic_t;

static names_t coff_filemagic_names[] = {
	{0603, "ALPHA 64-bit"},
	{0610, "ALPHA 64-bit compressed"},
	{0617, "ALPHA 64-bit UCODE"},
	{-1, ""}
};

static names_t coff_aoutmagic_names[] = {
	{0407, "OMAGIC"},
	{0410, "NMAGIC"},
	{0411, "SMAGIC"},
	{0413, "ZMAGIC"},
	{0443, "LIBMAGIC"},
	{-1, ""}
};

static names_t coff_flag_names[] = {
	{0000002, "executable"},
	{0000020, "no shared"},
	{0000040, "no call shared"},
	{-1, ""}
};

static int
is_coffalpha (char *buff, char *sz_text, int cb_text) {
	coff64_filehdr_t *filehdr;
	coff_aoutmagic_t *aouthdr;
	char *filemagic;
	char *aoutmagic;
	names_t *ptr;

	filehdr = (coff64_filehdr_t *) buff;
	aouthdr = (coff_aoutmagic_t *)(filehdr + 1);	

	filemagic = get_name (filehdr->f_magic, coff_filemagic_names);
	if (filemagic == 0)
		return -1;

	aoutmagic = get_name (aouthdr->magic, coff_aoutmagic_names);
	if (aoutmagic == 0)
		return -1;

	snprintf (sz_text, cb_text - 1, "coff %s %s", filemagic, aoutmagic);
	ptr = coff_flag_names;
	while (ptr->value != -1) {
		if (ptr->value & filehdr->f_flags) {
			snprintf (sz_text + strlen (sz_text),
			cb_text - 1, " %s", ptr->name);
		}
		ptr++;
	}
	return 0;
}

/*
 * HP-UX (32-bit) SOM
 */
typedef struct {
	uint16_t system_id;
	uint16_t type_id;
} hpuxsom_magic_t;

static names_t hpuxsom_system_names[] = {
	{0x0208, "HP 9000 Series 500"},
	{0x020a, "HP 9000 Series 200"},
	{0x020b, "PA-RISC 1.0"},
	{0x020c, "Motorola 68020"},
	{0x020d, "Motorola 68030"},
	{0x020e, "Motorola 68040"},
	{0x0210, "PA-RISC 1.1"},
	{0x0211, "PA-RISC 1.2"},
	{0x0214, "PA-RISC 2.0"},
	{-1, ""}
};

static names_t hpuxsom_type_names[] = {
	{0x0106, "relocatable object"},
	{0x0107, "normal executable"},
	{0x0108, "shared executable"},
	{0x0109, "shm-magic executable"},
	{0x010b, "demand-load executable"},
	{0x010d, "dynamic load library"},
	{0x010e, "shared library"},
	{-1, ""}
};

static int
is_hpuxsom (char *buff, char *sz_text, int cb_text) {
	hpuxsom_magic_t *hdr;
	char *type;
	char *system;

	hdr = (hpuxsom_magic_t *) buff;

	if ((hdr->type_id & 0xff00) != 0x0100)
		return -1;
	
	if ((hdr->system_id & 0xff00) != 0x0200)
		return -1;

	type = get_name (hdr->type_id, hpuxsom_type_names);
	if (type == 0)
		return -1;
	
	system = get_name (hdr->system_id, hpuxsom_system_names);
	if (system == 0)
		return -1;
	
	switch (hdr->system_id) {
	case 0x0208:
	case 0x020a:
	case 0x020c:
	case 0x020d:
	case 0x020e:
		snprintf (sz_text, cb_text - 1, 
		"HP %s %s", system, type);
		break;
	default:
		snprintf (sz_text, cb_text - 1, 
		"HP-UX 32-bit %s %s", system, type);
		break;
	}
	return 0;
}

/*
 * AIX XCOFF
 */
typedef struct {
	uint16_t magic_id;
} aix_magic_t;

static names_t aix_magic_names[] = {
	{0x0104, "shared library"},
	{0x0103, "RT2 executable or obj module"},
	{0x01f7, "AIX 5 64-bit executable or object module" },
	{0x01df, "RS6000 32-bit executable or object module"},
	{0x01ef, "AIX 4 64-bit executable or object module"},
	{-1, ""}
};

static int
is_aix (char *buff, char *sz_text, int cb_text) {
	aix_magic_t *hdr;
	char *text;

	hdr = (aix_magic_t *) buff;	

	text = get_name (hdr->magic_id, aix_magic_names);
	if (text == 0)
		return -1;
	
	snprintf (sz_text, cb_text - 1, "%s", text);
	return 0;
}

/*
 * JAR (java archive)
 */
typedef struct {
	uchar_t id[4];
} jar_magic_t;

static jar_magic_t jar_magic[1] = {'P', 'K', 3, 4}; 

static int
is_jar (char *buff, char *sz_text, int cb_text) {
	jar_magic_t *hdr;

	hdr = (jar_magic_t *) buff;	

	if (memcmp (hdr, jar_magic, sizeof (jar_magic_t)) != 0)
		return -1;
	
	snprintf (sz_text, cb_text - 1, "JAR or ZIP archive");
	return 0;
}

/*
 * structures from windows PE header
 */
typedef struct {
	uint16_t e_magic;    /* Magic number */
	uint16_t e_cblp;     /* Bytes on last page of file */
	uint16_t e_cp;       /* Pages in file */
	uint16_t e_crlc;     /* Relocations */
	uint16_t e_cparhdr;  /* Size of header in paragraphs */
	uint16_t e_minalloc; /* Minimum extra paragraphs needed */
	uint16_t e_maxalloc; /* Maximum extra paragraphs needed */
	uint16_t e_ss;       /* Initial (relative) SS value */
	uint16_t e_sp;       /* Initial SP value */
	uint16_t e_csum;     /* Checksum */
	uint16_t e_ip;       /* Initial IP value */
	uint16_t e_cs;       /* Initial (relative) CS value */
	uint16_t e_lfarlc;   /* File address of relocation table */
	uint16_t e_ovno;     /* Overlay number */
	uint16_t e_res[4];   /* Reserved words */
	uint16_t e_oemid;    /* OEM identifier (for e_oeminfo) */
	uint16_t e_oeminfo;  /* OEM information; e_oemid specific */
	uint16_t e_res2[10]; /* Reserved words */
	uint16_t e_lfanew;   /* File address of new exe header */
} win_doshdr_t;

typedef struct {
	uchar_t  Signatur[4];
	uint16_t Machine;
	uint16_t NumberOfSections;
	uint32_t TimeDateStamp;
	uint32_t PointerToSymbolTable;
	uint32_t NumberOfSymbols;
	uint16_t SizeOfOptionalHeaders;
	uint16_t Characteristics;
} win_imagefilehdr_t;

typedef struct {
	uint16_t Magic;
	uchar_t MajorLinkerVersion;
	uchar_t MinorLinkerVersion;
	uint32_t SizeOfCode;
	uint32_t SizeOfInitializedData;
	uint32_t SizeOfUninitializedData;
	uint32_t AddressOfEntryPoint;
	uint32_t BaseOfCode;
	uint32_t BaseOfData;
	uint32_t ImageBase;
	uint32_t SectionAlignment;
	uint32_t FileAlignment;
	uint16_t MajorOperatingSystemVersion;
	uint16_t MinorOperatingSystemVersion;
	uint16_t MajorImageVersion;
	uint16_t MinorImageVersion;
	uint16_t MajorSubsystemVersion;
	uint16_t MinorSubsystemVersion;
	uint32_t Win32VersionValue;
	uint32_t SizeOfImage;
	uint32_t SizeOfHeaders;
	uint32_t CheckSum;
	uint16_t Subsystem;
	uint16_t DllCharacteristics;
	uint32_t SizeOfStackReserve;
	uint32_t SizeOfStackCommit;
	uint32_t SizeOfHeapReserve;
	uint32_t SizeOfHeapCommit;
	uint32_t LoaderFlags;
	uint32_t NumberOfRvaAndSizes;
} win_optionalhdr32_t;

typedef struct {
	uint16_t Magic;
	uchar_t MajorLinkerVersion;
	uchar_t MinorLinkerVersion;
	uint32_t SizeOfCode;
	uint32_t SizeOfInitializedData;
	uint32_t SizeOfUninitializedData;
	uint32_t AddressOfEntryPoint;
	uint32_t BaseOfCode;
	uint32_t BaseOfData;
	uint32_t ImageBase;
	uint32_t SectionAlignment;
	uint32_t FileAlignment;
	uint16_t MajorOperatingSystemVersion;
	uint16_t MinorOperatingSystemVersion;
	uint16_t MajorImageVersion;
	uint16_t MinorImageVersion;
	uint16_t MajorSubsystemVersion;
	uint16_t MinorSubsystemVersion;
	uint32_t Win32VersionValue;
	uint32_t SizeOfImage;
	uint32_t SizeOfHeaders;
	uint32_t CheckSum;
	uint16_t Subsystem;
	uint16_t DllCharacteristics;
	uint32_t SizeOfStackReserve0;
	uint32_t SizeOfStackReserve1;
	uint32_t SizeOfStackCommit0;
	uint32_t SizeOfStackCommit1;
	uint32_t SizeOfHeapReserve0;
	uint32_t SizeOfHeapReserve1;
	uint32_t SizeOfHeapCommit0;
	uint32_t SizeOfHeapCommit1;
	uint32_t LoaderFlags;
	uint32_t NumberOfRvaAndSizes;
} win_optionalhdr64_t;

typedef struct {
	uint32_t VirtualAddress;
	uint32_t Size;
} win_datadirectory_t;

typedef struct {
	uchar_t Name[8];
	uint32_t PhysicalAddress;
	uint32_t VirtualAddress;
	uint32_t SizeOfRawData;
	uint32_t PointerToRawData;
	uint32_t PointerToRelocations;
	uint32_t PointerToLinenumbers;
	uint16_t NumberOfRelocations;
	uint16_t NumberOfLinenumbers;
	uint32_t Characteristics;
} win_sectionhdr_t;

typedef struct {
	uint32_t Characteristics;
	uint32_t TimeDateStamp;
	uint16_t MajorVersion;
	uint16_t MinorVersion;
	uint16_t NumberOfNamedEntries;
	uint16_t NumberOfIdEntries;
} win_resdirectory_t;

typedef struct {
	uint32_t Name;
	uint32_t OffsetToData;
} win_resdirentry_t;

typedef struct {
	uint32_t OffsetToData;
	uint32_t Size;
	uint32_t CodePage;
	uint32_t Reserved;
} win_resdataentry_t;

typedef struct {
	uchar_t Signatur[4];
} win_signatur_t;

static uchar_t win_dosmagic[2] = {'M', 'Z'};
static uchar_t win_ntmagic[4] = {'P', 'E', '\0', '\0'};

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
	uint16_t Magic[16];
} win_versioninfo_t;

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
	uint16_t Magic[15];
} win_stringfileinfo_t;

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
	uint16_t Magic[12];
} win_varfileinfo_t;

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
	uint16_t Key[9];
} win_stringtable_t;

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
} win_string_t;

static uint16_t win_versioninfo_magic[16] =
	{'V', 'S', '_', 'V', 'E', 'R', 'S', 'I', 'O', 'N', '_',
	 'I', 'N', 'F', 'O', 0};

static uint16_t win_stringfileinfo_magic[15] =
	{'S', 't', 'r', 'i', 'n', 'g', 'F', 'i', 'l', 'e',
	 'I', 'n', 'f', 'o', 0};

static uint16_t win_varfileinfo_magic[12] =
	{'V', 'a', 'r', 'F', 'i', 'l', 'e',
	 'I', 'n', 'f', 'o', 0};

static names_t win_flag_names[] = {
	{0x0002, "executable"},
	{0x1000, "system file"},
	{0x2000, "dll"},
	{-1, ""}
};

static names_t win_machine_names[] = {
	{0x0000, "unknown machine"},
	{0x014c, "i386"},
	{0x0160, "MIPS R3000 big-endian"},
	{0x0166, "MIPS R4000 little-endian"},
	{0x0168, "MIPS R10000 little-endian"},
	{0x0169, "MIPS WCE v2 little-endian"},
	{0x0184, "ALPHA 32-bit"},
	{0x01f0, "PowerPC"},
	{0x0200, "IA64"},
	{0x0284, "ALPHA 64-bit"},
	{-1, ""}
};

static int
is_windowsdos (char *buff, char *sz_text, int cb_text) {
	win_doshdr_t *doshdr;

	doshdr = (win_doshdr_t *) buff;
	
	if (memcmp 
	(&doshdr->e_magic, win_dosmagic, sizeof (win_dosmagic)) != 0) {
		return -1;
	}

	snprintf (sz_text, cb_text - 1, "MS DOS");
	return 0;
}

static int
is_windowspe (char *buff, char *sz_text, int cb_text) {
	win_imagefilehdr_t *winnthdr;
	win_signatur_t *signature;
	char *machine;
	names_t *ptr;
	
	signature = (win_signatur_t *) buff;
	winnthdr = (win_imagefilehdr_t *) buff;

	if (memcmp 
	(&signature->Signatur, win_ntmagic, sizeof (win_ntmagic)) != 0) {
		return -1;
	}

	machine = get_name (winnthdr->Machine, win_machine_names);
	if (machine == 0)
		return -1;
	
	snprintf (sz_text, cb_text - 1, "MS Windows");
	switch (winnthdr->Machine) {
	case 0x014c:
		/* i386 */
		snprintf (sz_text + strlen (sz_text), cb_text - 1, " 32-bit");
		break;
	case 0x0200:
		/* ia64 */
		snprintf (sz_text + strlen (sz_text), cb_text - 1, " 64-bit");
		break;
	}

	snprintf (sz_text + strlen (sz_text), cb_text - 1, " %s", machine);

	ptr = win_flag_names;
	while (ptr->value != -1) {
		if (ptr->value & winnthdr->Characteristics) {
			snprintf (sz_text + strlen (sz_text),
			          cb_text - 1, " %s", ptr->name);
		}
		ptr++;
	}
	return 0;
}

static int
get_magic (char *buff, char *sz_text, int cb_text) {
	if (is_windowsdos (buff, sz_text, cb_text) == 0) {
		return 0;
	} else if (is_windowspe (buff, sz_text, cb_text) == 0) {
		return 0;
	} else if (is_elf (buff, sz_text, cb_text) == 0) {
		return 0;
	} else if (is_hpuxsom (buff, sz_text, cb_text) == 0) {
		return 0;
	} else if (is_coffalpha (buff, sz_text, cb_text) == 0) {
		return 0;
	} else if (is_aix (buff, sz_text, cb_text) == 0) {
		return 0;
	} else if (is_jar (buff, sz_text, cb_text) == 0) {
		return 0;
	}

	strncpy (sz_text, "unknown magic", cb_text - 1);	
	return 0;
}

#ifdef UNIX
typedef void *handle_t;

static handle_t
myopen (char *filename, int mode) {
	return ((handle_t) ((ptr_t) open (filename, mode)));
}

static int
myclose (handle_t fd) {
	return (close ((int) ((ptr_t) fd)));
}

static int
myread (handle_t fd, char *buff, int want) {
	return (read ((int) ((ptr_t) fd), buff, want));
}
#endif

#ifdef WIN32
typedef void *handle_t;

static handle_t
myopen (char *filename, int mode) {
	return ((handle_t) ((ptr_t) _open (filename, mode | O_BINARY)));
}

static int
myclose (handle_t fd) {
	return (_close ((int) ((ptr_t) fd)));
}

static int
myread (handle_t fd, char *buff, int want) {
	return (_read ((int)((ptr_t) fd), buff, want));
}
#endif

/*
 * helper function to make untgz read look like UNIX read
 */
static int
untgzread (void *handle, char *buffer, int want) {	
	int rc;
	int got;
	SV *sv_buffer;
	SV *sv_archive;

	sv_archive = (SV *) handle;

	/*
	 * untgz an only use blocks of 512 byte
	 */	
	if (want != 512)
		return -1;

	sv_buffer = newSVsv (&PL_sv_undef);

	{
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	XPUSHs (sv_archive);
	XPUSHs (sv_buffer);
	PUTBACK;

	rc = perl_call_pv ("SAPDB::Install::Untgz::ExtractRead", G_ARRAY);
	
	SPAGAIN;

	got = -1;

	if (rc == 1)
		got = POPi;

	PUTBACK;
	FREETMPS;
	LEAVE;
	}

	if (got > 0)
		memcpy (buffer, SvPV (sv_buffer, PL_na), got);

	SvREFCNT_dec (sv_buffer);
	return (got);
}

static int
add_vars (char *key, char *val, info_t **p_vars) {
	info_t *my;
	info_t *their;

	my = (info_t *) malloc (sizeof (info_t));
	if (my == 0) return 0;

	my->next = 0;
	my->key = (char *) malloc (strlen (key) + 1);

	if (my->key == 0) {
		free (my);
		return 0;
	}
		
	my->val = (char *) malloc (strlen (val) + 1);
	if (my->val == 0) {
		free (my->key);
		free (my);
		return 0;
	}

	strcpy (my->key, key);
	strcpy (my->val, val);

	if (*p_vars == 0) {
		*p_vars = my;
		return 1;
	}

	for (their = *p_vars; their->next != 0; their = their->next);

	their->next = my;
	return 1;
}

#ifdef UNIX
#define convert_slashes(a) (a)
#endif

#ifdef UNIX
static int  check_vars (char *, info_t **);
static int  check_sysinfo (char *, info_t **);
static int  check_build (char *, build_t *);
static int  check_buildstr (char *, char *);
static char *get_what (char *, char *, char *, int);
static int  split_build (char *, build_t *);
static int  gt_build (build_t *, build_t *);
static void remove_colon (char *);
static int  add_vars (char *, char *, info_t **);

static int
get_build (void *handle, void *func,
info_t **p_sysinfo, info_t **p_vars, build_t **p_build) {
	int got;
	int done;
	char *at;
	char *buff;
	int buff_size;
	int offset;
	char *line;
	build_t *build;
	int found_build = 0;

	/* 
	 * set return values to defaults
	 */
	*p_build = 0;
	*p_sysinfo = 0;
	*p_vars = 0;

	/*
	 * init buildinfo structure
	 */

	build = (build_t *) malloc (sizeof (build_t));
	if (build == 0)
		return 0;

	memset (build, 0, sizeof (build_t));

	at = 0;
	buff = 0;
	buff_size = 0;
	offset = 0;

	for (;;	offset += got) {
		int rc;
		int at_offset;

		if (at != 0) {
			at_offset = at - buff;
		}

		if (buff == 0 | buff_size == 0) {
			buff = realloc (buff, 512);
			buff_size = 0;
			at_offset = 0;
			got = 0;
		} else if (buff_size != 0) {
			buff = realloc (buff, buff_size + got);
		}

		at = buff + at_offset;

		got = (*(readfunc_t) func) (handle, buff + buff_size, 512);

		if (got <= 0) break;

		buff_size += got;

		if (offset == 0) {
			char sz_magic[1024];

			get_magic (buff, sz_magic, 1024);
			add_vars ("magic", sz_magic, p_vars);

			/*
			 * if this is a java archive
			 * it makes no sense to look for any 'what' strings here
			 */
			if (memcmp (sz_magic, "JAR", 3) == 0) {
				free (buff);
				free (build);
				return 0;
			}
		}

		done = 0;
		for (;;) {
			char *end;
			int len;
		
			len =  buff - at + buff_size;
			at = (char *) memchr (at, '@', buff - at + buff_size);
			if (at == 0) {
				buff_size = 0;
				break;
			}

			if (at + 3 >= buff + buff_size) {
				break;
			}

			if (at[1] != '(') {
				at++;
				continue;
			}

			if (at[2] != '#') {
				at++;
				continue;
			}

			if (at[3] != ')') {
				at++;
				continue;
			}

			end =
			(char *) memchr (at, '\0', buff_size - (at - buff));	

			if (end == 0) {
				break;
			}

			line = at + 4;
			at = end;
			
			check_sysinfo (line, p_sysinfo);
			check_vars (line, p_vars);
			found_build |= check_build (line, build);

			at++;
			if (at >= buff + buff_size) {
				buff_size = 0;
				break;
			}
		}

		if (done) break;
	}

	if (buff != 0)
		free (buff);

	if (found_build) {
		*p_build = build;
		return 1;
	}

	free (build);
	return 0;
}

static int
get_buildstr (char *filename, char *buildstr) {
	int fd;
	int got;
	int got_buildstr;
	int done;
	char *end;
	char *at;
	static char buff[BUFFER_SIZE + 3];
	char line[LINE_SIZE];

	fd = open (filename, O_RDONLY);
      
	buildstr[0] = '\0';
	buff[0] = buff[1] = buff[2] = '\0';
	for (;;) {
		got = read (fd, buff + 3, BUFFER_SIZE);
		if (got <= 0)
			break;

		got_buildstr = 0;
		done = 0;
		at = buff;  
		end = buff + got;
		for (;;) {
			at = (char *) memchr (at, '@', end - at);
			if (at == 0)
				break;
	
			if (at[1] == '(' && at[2] == '#' && at[3] == ')') {
				at = get_what (at + 4, end + 3, line, fd);
				if (at == 0) {
					done = 1; 
					break;
				}
				check_buildstr (line, buildstr);
			}
			at++;
			if (at >= end)
				break;
		}

		if (done != 0) 
			break;
		
		buff[0] = end[0]; 
		buff[1] = end[1];
		buff[2] = end[2];
	}

	close (fd);

	if (strlen (buildstr) == 0) {
		return 0;
	}

	remove_colon (buildstr);
	return 1;
}

static char *
get_what (char *begin, char *end, char *line, int fd) {
	char *ptr = line;

	while (begin < end) {
		*ptr = *begin;
		if (*begin == '\0') {
			return (begin);
		}
		ptr++; begin++;
	}
	
	for (;;) {
		if (read (fd, ptr, 1) <= 0) {
			*ptr = '\0';
			return 0;
		}

		if (*ptr == '\0')
			return (end);
		ptr++;
	}
	return 0;
}

static int
check_vars (char *line, info_t **p_vars) {
	char *p_key;
	char *p_val;
	int rc;

	if (p_key = strstr (line, "Architecture")) {
		p_val = strchr (p_key, ':');
		p_key = "architecture";
	} else if (p_key = strstr (line, "Operating System")) {
		p_val = strchr (p_key, ':');
		p_key = "os";
	} else if (p_key = strstr (line, "C Compiler")) {
		p_val = strchr (p_key, ':');
		p_key = "cc";
	} else if (p_key = strstr (line, "C++ Compiler")) {
		p_val = strchr (p_key, ':');
		p_key = "cxx";
	} else {
		return 0;
	}

	if (p_val == 0)
		return 0;

	p_val += 2;

	rc = add_vars (p_key, p_val, p_vars);

	return (rc);
}

static int
check_sysinfo (char *line, info_t **p_sysinfo) {
	char *sz_sysinfo = "sysinfo.";
	char *p_key;
	char *p_val;
	int key_len;
	info_t *my;
	info_t *their;

	p_key = strstr (line, sz_sysinfo);
	if (p_key == 0) return 0;
	
	p_key += strlen (sz_sysinfo);

	p_val = strchr (p_key, ':');
	if (p_val == 0) return 0;

	key_len = (p_val - p_key);
	if (key_len <= 0) return 0;

	p_val += 2;

	my = (info_t *) malloc (sizeof (info_t));
	if (my == 0) return 0;

	my->next = 0;

	my->key = (char *) malloc (key_len + 1);
	if (my->key == 0) {
		free (my);
		return 0;
	}

	my->val = (char *) malloc (strlen (p_val) + 1);
	if (my->val == 0) {
		free (my->key);
		free (my);
		return 0;
	}

	my->next = 0;
	memcpy (my->key, p_key, key_len);
	my->key[key_len] = '\0';
	strcpy (my->val, p_val);

	if (*p_sysinfo == 0) {
		*p_sysinfo = my;
		return 1;
	}

	for (their = *p_sysinfo; their->next != 0; their = their->next);

	their->next = my;
	return 1;
}

static int
check_buildstr (char *line, char *buildstr) {
	build_t my[1], their[1];

	if (split_build (line, my) != 0) {
		return 0;
	}

	/*
	 * it is the first buildstring we found
	 */
	if (strlen (buildstr) == 0) {
		strcpy (buildstr, line);
		return 1;
	}

	if (split_build (buildstr, their) != 0) {
		return 0;
	}

	if (gt_build (my, their) != 0) {
		return 0;
	}

	/*
	 * my buildsting this greater than theirs
	 */
	strcpy (buildstr, line);
	return 1;
}

static int
check_build (char *line, build_t *their) {
	build_t my[1];

	if (split_build (line, my) != 0) {
		return 0;
	}

	if (gt_build (my, their) != 0) {
		return 0;
	}

	their->type = my->type;
	their->major = my->major;
	their->minor = my->minor;
	their->correction = my->correction;
	their->build = my->build;

	return 1;
}

static int
split_build (char *line, build_t *my) {
	char *szAPO = "APO ";
	char *szRel = "Rel. ";
	char *szBuild = "Build: ";
	char *pRel;
	char *pBuild;
	char *pNext;

	pRel = strstr (line, szRel);
	my->type = BUILD_TYPE_REL;

	if (pRel == 0) {
		pRel = strstr (line, szAPO);
		my->type = BUILD_TYPE_APO;
	}

	if (pRel == 0)
		return -1;

	pBuild = strstr (line, szBuild);
	if (pBuild == 0)
		return -1;

	switch (my->type) {
	case BUILD_TYPE_REL:
		my->major = strtol (pRel + strlen (szRel), &pNext, 10);
		my->minor = strtol (pNext + 1, &pNext, 10);
		my->correction = strtol (pNext + 1, &pNext, 10);
		my->build = strtol (pBuild + strlen (szBuild), &pNext, 10);
		break;
	case BUILD_TYPE_APO:
		my->major = strtol (pRel + strlen (szAPO), &pNext, 10);
		my->minor = pNext[1] - '0';
		my->correction = pNext[2];
		if (my->correction >= 'A' && my->correction <= 'Z') {
			my->correction -= 'A';
		} else if (my->correction >= '0' && my->correction <= '9') {
			my->correction -= '0';
		} else if (my->correction == ' ' || my->correction == '\t') {
			my->correction = 0;
		}
		my->build = strtol (pBuild + strlen (szBuild), &pNext, 10);

		break;
	default:
		return -1;
	}

	return 0;
}

static int
gt_build (build_t *my, build_t *their) {

	if (my->type < their->type) {
		return -1;
	}

	if ((my->type == their->type) && (my->major < their->major)) {
		return -1;
	}

	if ((my->type == their->type) && (my->major == their->major) &&
	    (my->minor < their->minor)) {
		return -1;
	}

	if ((my->type == their->type) && (my->major == their->major) &&
	(my->minor == their->minor) && (my->correction < their->correction)) {
		return -1;
	}

	if ((my->major == their->major) && (my->minor == their->minor) &&
	(my->correction == their->correction) && (my->build < their->build)) {
		return -1;
	}

	return 0;
}

static void
remove_colon (char *line) {
	char *szBuild = "Build: ";
	char *ptr;

	/*
	 * remove ':' after 'Build'
	 */
	ptr = strstr (line, szBuild);
	if (ptr == 0)
		return;

	ptr[5] = ' ';
	return;
}
#endif

#ifdef WIN32

#include "VersionInfo.h"

static char *
get_versioninfo (void *handle, void *func, char *resinfo, int *p_size,
                 char *magic, int *p_magicsize) {
	int rc;
	int val;
	char *sz_func = "SAPDB::Install::System::Win32::VersionInfo::GetVersionInfo";
	versioninfo_param_t param[1];

	if (perl_get_cv (sz_func, FALSE) == 0) {
		char *sz_bootstrap = "SAPDB::Install::System::Win32::VersionInfo::bootstrap";

		if (perl_get_cv (sz_bootstrap, FALSE) != 0) {
			dSP;
			ENTER;
			SAVETMPS;
			PUSHMARK (sp);
			PUTBACK;
			perl_call_pv (sz_bootstrap, G_VOID);
			SPAGAIN;
			PUTBACK;
			FREETMPS;
			LEAVE;
		}
	}

	if (perl_get_cv (sz_func, FALSE) == 0)
		return 0;

	param->handle = handle;
	param->func = func;
	param->resinfo = resinfo;
	param->p_size = p_size;
	param->magic = magic;
	param->p_magicsize = p_magicsize;

	{
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	XPUSHs (sv_2mortal (newSViv ((ptr_t) param)));
	PUTBACK;

	rc = perl_call_pv (sz_func, G_SCALAR);

	SPAGAIN;

	val = -1;
	if (rc == 1)
		val = POPi;

	PUTBACK;
	FREETMPS;
	LEAVE;
	}

	return ((char *) val);
}

static int
version_query_value (char * raw, char *desc, void **info, int *infosize) {
	int rc;
	int val;
	char *ptr;
	char *sz_func = "SAPDB::Install::System::Win32::VersionInfo::QueryVersionValue";
	versionquery_param_t param[1];

	if (perl_get_cv (sz_func, FALSE) == 0) {
		char *sz_bootstrap = "SAPDB::Install::System::Win32::VersionInfo::bootstrap";

		if (perl_get_cv (sz_bootstrap, FALSE) != 0) {
			dSP;
			ENTER;
			SAVETMPS;
			PUSHMARK (sp);
			PUTBACK;
			perl_call_pv (sz_bootstrap, G_VOID);
			SPAGAIN;
			PUTBACK;
			FREETMPS;
			LEAVE;
		}
	}

	if (perl_get_cv (sz_func, FALSE) == 0)
		return 0;

	param->raw = raw;
	param->desc = desc;
	param->info = info;
	param->infosize = infosize;

	{
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	XPUSHs (sv_2mortal (newSViv ((ptr_t) param)));
	PUTBACK;

	rc = perl_call_pv (sz_func, G_SCALAR);

	SPAGAIN;

	if (rc == 1) {
		val = POPi;
	} else {
		val = -1;
	}

	PUTBACK;
	FREETMPS;
	LEAVE;
	}

	return (val);
}

static int
get_build (void *handle, void *func, info_t **p_sysinfo,
info_t **p_vars, build_t **p_build) {
	build_t *build;
	int rawInfoSize;
	void *rawInfo;
	void *Info = 0;
	int InfoSize;
	char *Magic;
	int MagicSize;
	char *next;
	int i;
	char *AsciiInfo;

	build = (build_t *) malloc (sizeof (build_t));
	if (build == 0)
		return 0;		

	memset (build, 0, sizeof (build_t));

	/* 
	 * set return values to defaults
	 */
	*p_build = 0;
	*p_sysinfo = 0;
	*p_vars = 0;

	/*
	 * look for version information
	 */
	get_versioninfo (handle, func, 0, &rawInfoSize, 0, &MagicSize);

	rawInfo = malloc (rawInfoSize);
	if (rawInfo == 0) {
		return 0;
	}

	Magic = malloc (MagicSize);
	if (Magic == 0) {
		free (rawInfo);
		return 0;
	}

	get_versioninfo (handle, func, rawInfo,
	&rawInfoSize, Magic, &MagicSize);

	if (Magic != 0) {
		add_vars ("magic", Magic, p_vars);
		free (Magic);

		/*
		 * if this is a java archive
		 * it makes no sense to look for any resources here
		 */
		if (memcmp (Magic, "JAR", 3) == 0) {
			free (rawInfo);
			free (build);
			return 0;
		}
	}

	version_query_value
	(rawInfo, "\\StringFileInfo\\040904E4\\FileVersion", &Info, &InfoSize);

	if (InfoSize == 0) {
		free (rawInfo);
		free (build);
		return 0;
	}

	AsciiInfo = (char *) malloc (InfoSize);
	if (AsciiInfo == 0) {
		free (rawInfo);
		free (build);
		return 0;
	}

	for (i = 0; i < InfoSize; i++) {
		AsciiInfo[i] = (char) ((uint16_t *)Info)[i];
	}

	if (strchr (AsciiInfo, '.') == 0) {
		/*
		 * no dots, this is an apo version
		 * apo version looks like
		 *      3029 => APO 3.0A Build 29
		 * or
		 *      3103 => APO 3.10 Build 03
		 */
		build->major = AsciiInfo[0] - '0';
		build->minor = AsciiInfo[1] - '0';
		build->correction = 0;
		build->build = strtol (AsciiInfo + 2, &next, 10);

		*p_build = build;

		free (rawInfo);
		free (AsciiInfo);
		return 1;
	}

	/*
	 * sapdb version
	 */
	build->major = strtol (AsciiInfo, &next, 10);
	build->minor = strtol (next + 1, &next, 10);
	build->correction = strtol (next + 1, &next, 10);

	version_query_value
	(rawInfo, "\\StringFileInfo\\040904E4\\Build", &Info, &InfoSize);

	if (InfoSize == 0) {
		free (AsciiInfo);
		free (rawInfo);
		free (build);
		return 0;
	}

	AsciiInfo = (char *) realloc (AsciiInfo, InfoSize);
	if (AsciiInfo == 0) {
		free (rawInfo);
		free (build);
		return 0;
	}

	for (i = 0; i < InfoSize; i++) {
		AsciiInfo[i] = (char) ((uint16_t *)Info)[i];
	}

	build->build = strtol (AsciiInfo, &next, 10);

	free (rawInfo);
	free (AsciiInfo);

	*p_build = build;
	return 1;
}

static int
get_buildstr (char *filename, char *buildstr) {

	DWORD rawInfoSize;
	DWORD dummy;
	void *rawInfo;
	void *Info = 0;
	UINT InfoSize = 0;
	char InfoRoot[30];
	char InfoDescription[50];
	HANDLE hMem;
	char *next;

	/* 
	 * set return values to defaults
	 */
	*buildstr = '\0';

	/*
	 * look for version information
	 */
	rawInfoSize = GetFileVersionInfoSize (filename, &dummy); 
	if (rawInfoSize == 0) {
		return 0;
	}

	/*
	 * and get it into a buffer
	 */
	hMem = GlobalAlloc (GMEM_MOVEABLE, rawInfoSize);
	if (hMem == 0) {
		return 0;
	}

	rawInfo = GlobalLock (hMem);
	GetFileVersionInfo (filename, 0, rawInfoSize, rawInfo);

	/*
	 * look for an english language version info
	 */
	_tcscpy (InfoRoot, __TEXT ("\\StringFileInfo\\040904E4\\"));

	_tcscpy (InfoDescription, InfoRoot);
	_tcscat (InfoDescription, __TEXT ("FileVersion"));
	VerQueryValue ((void *) rawInfo, InfoDescription, &Info, &InfoSize);
	if (InfoSize == 0) {
		GlobalFree (hMem);
		return 0;
	}
	
	if (_tcschr ((char *) Info, '.') == 0) {
		/*
		 * no dots, this is an apo version
		 * apo version looks like
		 *      3029 => APO 3.0A Build 29
		 * or
		 *      3103 => APO 3.10 Build 03
		 */
		long major;
		long minor;
		long correction;
		long build;

		major = *((char *) Info + 0) - '0';
		minor = *((char *) Info + 1) - '0';
		correction = 0;
		build = _tcstol ((char *) Info + 2, &next, 10);

		strcat (buildstr, "APO ");
		if (major == 3 && minor == 0 && correction == 0) {
			strcat (buildstr, "3.0A");
		} else {
			sprintf (buildstr + strlen (buildstr),
		                 "%d.%d%d", major, minor, correction);
		}
		strcat (buildstr, "    Build ");
		sprintf (buildstr + strlen (buildstr), "%d", build);
	} else {
		/*
		 * sapdb version
		 */
		strcat (buildstr, "Rel. ");
		strcat (buildstr, (char *) Info);
		strcat (buildstr, "    Build ");

		_tcscpy (InfoDescription, InfoRoot);
		_tcscat (InfoDescription, TEXT ("Build"));
		VerQueryValue ((void *) rawInfo, InfoDescription,
		               &Info, &InfoSize);

		if (InfoSize == 0) {	
			GlobalFree (hMem);
			return 0;
		}

		strcat (buildstr, (char *) Info);
	}

	GlobalFree (hMem);
	return 1;
}
#endif

static int
jar_buildstr (char *filename, char *buildstr) {
	int rc;
	char *ptr;
	char *sz_func = "SAPDB::Install::Jar::JarBuildString";

	if (perl_get_cv (sz_func, FALSE) == 0) {
		char *sz_bootstrap = "SAPDB::Install::Jar::bootstrap";

		if (perl_get_cv (sz_bootstrap, FALSE) != 0) {
			dSP;
			ENTER;
			SAVETMPS;
			PUSHMARK (sp);
			PUTBACK;
			perl_call_pv (sz_bootstrap, G_VOID);
			SPAGAIN;
			PUTBACK;
			FREETMPS;
			LEAVE;
		}
	}

	if (perl_get_cv (sz_func, FALSE) == 0)
		return 0;

	{
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	XPUSHs (sv_2mortal (newSVpv (filename, strlen (filename))));
	PUTBACK;

	rc = perl_call_pv (sz_func, G_SCALAR);

	SPAGAIN;

	buildstr[0] = '\0';
	if (rc == 1) {
		ptr = POPp;

		if (ptr != 0 && strlen (ptr) > 0) {
			strcpy (buildstr, ptr);
		}
	}

	PUTBACK;
	FREETMPS;
	LEAVE;
	}

	if (buildstr[0] == '\0')
		return 0;

	return 1;
}

static int
jar_build (char *filename, info_t **p_sysinfo,
info_t **p_vars, build_t **p_build) {
	build_t *build;
	int rc;
	char *p_key;
	char *sz_func = "SAPDB::Install::Jar::JarBuildInfo";
	SV *rv;

	*p_build = 0;

	if (perl_get_cv (sz_func, FALSE) == 0) {
		char *sz_bootstrap = "SAPDB::Install::Jar::bootstrap";

		if (perl_get_cv (sz_bootstrap, FALSE) != 0) {
			dSP;
			ENTER;
			SAVETMPS;
			PUSHMARK (sp);
			PUTBACK;
			perl_call_pv (sz_bootstrap, G_VOID);
			SPAGAIN;
			PUTBACK;
			FREETMPS;
			LEAVE;
		}
	}

	if (perl_get_cv (sz_func, FALSE) == 0)
		return 0;

	build = (build_t *) malloc (sizeof (build_t));
	if (build == 0)
		return 0;

	memset (build, 0, sizeof (build_t));

	{
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	XPUSHs (sv_2mortal (newSVpv (filename, strlen (filename))));
	PUTBACK;

	rc = perl_call_pv (sz_func, G_ARRAY);

	SPAGAIN;

	p_key = 0;
	rv = 0;

	if (rc == 2) {
		rv = POPs;
		p_key = POPp;
	}

	if (p_key == 0 || strcmp (p_key, "Build") != 0)
		rv = 0;

	if (rv != 0 &&  SvTYPE (SvRV (rv)) == SVt_PVAV)
		build->type = BUILD_TYPE_JAR;

	if (build->type == BUILD_TYPE_JAR) {
		AV *av;
		SV **psv;
		int idx, len;

		av = (AV *) SvRV (rv);

		len = av_len (av);

		for (idx = 0; idx <= len; idx++) {
			psv = av_fetch (av, idx, 0);

			switch (idx) {
			case 0:
				build->major = SvIV (*psv);
				break;
			case 1:
				build->minor = SvIV (*psv);
				break;
			case 2:
				build->correction = SvIV (*psv);
				break;
			case 3:
				build->build = SvIV (*psv);
				break;
			}
		}
	}

	PUTBACK;
	FREETMPS;
	LEAVE;
	}

	if (build->type == 0) {
		free (build);
		return 0;
	}

	*p_build = build;
	return 1;
}

/*
 * now we add the perl source as as inline code
 * symbol name of the string containing the code
 * is sz_text
 * this code will be evaled in the BOOT method of the module
 */
#include "FileMagic.h"

/*                                                                        */
/* GetBuildInfo                                                           */  
/* $_[0] : filename                                                       */
/*                                                                        */  
/* @ret  : array representing values from a hash containing the buildinfo */
/*         if the key is 'Build', the value is a reference to an array    */
/*         containing the elements of the buildnumber                     */
/*         it looks like this:                                            */
/*                                                                        */
/*         'Build'            => ARRAY[0] = <major>                       */
/*                               ARRAY[1] = <minor>                       */
/*                               ARRAY[2] = <corretion>                   */
/*                               ARRAY[3] = <build>                       */
/*         'Operating_System' => <operating system>                       */
/*         'Architecture'     => <architecture>                           */
/*         'C_Compiler'       => <c compiler>                             */ 
/*         'C++_Compiler'     => <c++ compiler>                           */
/*                                                                        */
/*         if only the buildnumber but no other information is found,     */
/*         the return looks like this :                                   */
/*                                                                        */
/*         'Build'            => ARRAY[0] = <major>                       */
/*                               ARRAY[1] = <minor>                       */
/*                               ARRAY[2] = <corretion>                   */
/*                               ARRAY[3] = <build>                       */
/*                                                                        */
/*         return an empty arry on error                                  */
/*                                                                        */

MODULE = SAPDB::Install::BuildInfo	PACKAGE = SAPDB::Install::BuildInfo


PROTOTYPES: DISABLE

BOOT:
	perl_eval_pv ((char *) sz_text, 1);
	
SV *
GetBuildString (...)
PREINIT:
	char *filename;
	char buildstr[1024];
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	filename = (char *) SvPV (ST (0), PL_na);
	convert_slashes (filename);

	if (get_buildstr (filename, buildstr) == 1) {
		XPUSHs (sv_2mortal (newSVpv (buildstr, strlen (buildstr))));
		XSRETURN (1);
	}

	if (jar_buildstr (filename, buildstr) == 1) {
		XPUSHs (sv_2mortal (newSVpv (buildstr, strlen (buildstr))));
		XSRETURN (1);
	}

	XSRETURN_UNDEF;

SV *
GetBuildInfo (...)
PREINIT:
	int rc;
	build_t *build;
	info_t *sysinfo;
	info_t *vars;
	HV *hv;
	SV *rv;
	HV *hv_sysinfo;
PPCODE:
	if (items != 1)
		XSRETURN_EMPTY;

	if ((sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		rc = get_build
		(ST(0), (void *) &untgzread, &sysinfo, &vars, &build);
	} else {
		handle_t fd;
		char *filename;

		filename = convert_slashes ((char *) SvPV (ST (0), PL_na));
		fd = myopen (filename, O_RDONLY);
		rc = get_build (fd, (void *) &myread, &sysinfo, &vars, &build);
		myclose (fd);
		
		if (rc == 0 && vars != 0) {
			info_t *curr;

			for (curr = vars; curr != 0;  curr = curr->next)
				if (strcmp (curr->key, "magic") == 0) break;

			if (
			strcmp (curr->key, "magic") == 0 &&
			memcmp (curr->val, "JAR", 3) == 0)
				jar_build (filename, &sysinfo, &vars, &build);
		}
	}

	if (build == 0 && vars != 0) {
		info_t *curr;

		for (curr = vars; curr != 0;  curr = curr->next)
			if (strcmp (curr->key, "magic") == 0) break;

		if (
		strcmp (curr->key, "magic") == 0 &&
		memcmp (curr->val, "JAR", 3) == 0) {
			build = (build_t *) malloc (sizeof (build_t));
			if (build == 0)
				XSRETURN_EMPTY;

			build->major = 0;
			build->minor = 0;
			build->correction = 0;
			build->build = 0;
		}
	}

	hv = newHV ();

	if (build != 0) {
		char *sz_build = "Build";
		AV *av_build;

		av_build = newAV ();
		av_push (av_build, newSViv (build->major));
		av_push (av_build, newSViv (build->minor));
		av_push (av_build, newSViv (build->correction));
		av_push (av_build, newSViv (build->build));

		hv_store (hv, sz_build, strlen (sz_build),
			newRV ((SV *) av_build), 0);

		free (build);
	}

	if (sysinfo != 0) {
		char *sz_sysinfo = "sysinfo";
		info_t *curr, *ptr;

		hv_sysinfo = newHV ();
		for (curr = sysinfo; curr != 0;) {
			hv_store (hv_sysinfo, curr->key, strlen (curr->key),
			newSVpv (curr->val, strlen (curr->val)), 0);

			ptr = curr;
			curr = curr->next;
			free (ptr->key);
			free (ptr->val);
			free (ptr);
		}

		hv_store (hv, sz_sysinfo, strlen (sz_sysinfo),
		newRV ((SV *) hv_sysinfo), 0);
	}

	if (vars != 0) {
		info_t *curr, *ptr;

		for (curr = vars; curr != 0;) {
			hv_store (hv, curr->key, strlen (curr->key),
			newSVpv (curr->val, strlen (curr->val)), 0);

			ptr = curr;
			curr = curr->next;
			free (ptr->key);
			free (ptr->val);
			free (ptr);
		}
	}

	rv = sv_2mortal (newRV ((SV *) hv));
	SvREFCNT_dec (hv);

	XPUSHs (rv);
	XSRETURN (1);
