/*
 * FSUsage.xs
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/FSUsage.xs#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 */

static char szWhatHeader[] = 
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/FSUsage.xs#1 $";

#ifndef __cplusplus
#ifndef HAS_BOOL
typedef char bool;
#endif
#endif

/*
 * expect compiler warning 4113 when using Microsoft C
 * in c code generated by xs preprocessor
 */
#if _MSC_VER >= 1200
#pragma warning(disable : 4113)
#endif

#ifndef WIN32
#define UNIX UNIX
#endif

/*
 * alloca specific defines
 */
#ifdef _AIX
#define NEED_PRAGMA_ALLOCA NEED_PRAGMA_ALLOCA
#endif
#if defined UNIX && !defined _AIX && !defined SNI
#define NEED_ALLOCA_H NEED_ALLOCA_H
#endif

#ifdef NEED_ALLOCA_H
#include <alloca.h>
#endif

#ifdef NEED_PRAGMA_ALLOCA
#pragma alloca
#endif

/*
 * statfs specific defines
 */
#if defined linux

#define NEED_SYS_VFS_H NEED_SYS_VFS_H
#define NEED_SYS_STATVFS_H NEED_SYS_STATVFS_H
#define HAS_STATVFS HAS_STATVFS
#undef  HAS_STATFS
#define HAS_STAT_ST_BLKSIZE HAS_STAT_ST_BLKSIZE

#ifndef SMB_SUPER_MAGIC
#define SMB_SUPER_MAGIC 0x517b
#endif

#ifndef CIFS_MAGIC_NUMBER
#define CIFS_MAGIC_NUMBER 0xff534d42
#endif

#ifndef NFS_SUPER_MAGIC
#define NFS_SUPER_MAGIC 0x6969
#endif

#elif defined sun || defined SNI

#define NEED_SYS_STATVFS_H NEED_SYS_STATVFS_H
#define NEED_SYS_MNTENT_H NEED_SYS_MNTENT_H
#define HAS_STATVFS HAS_STATVFS
#undef  HAS_STATFS
#define HAS_STAT_ST_BLKSIZE HAS_STAT_ST_BLKSIZE

#elif defined __hpux

#define NEED_SYS_VFS_H NEED_SYS_VFS_H
#define NEED_MNTENT_H NEED_MNTENT_H
#define HAS_STATFS HAS_STATFS
#undef  HAS_STATVFS
#define HAS_STAT_ST_BLKSIZE HAS_STAT_ST_BLKSIZE
#define HAS_STATFS_F_BSIZE HAS_STATFS_F_BSIZE 

#elif defined __osf__

#define NEED_SYS_MOUNT_H NEED_SYS_MOUNT_H
#define HAS_STATFS HAS_STATFS
#undef  HAS_STATVFS
#define HAS_STAT_ST_BLKSIZE HAS_STAT_ST_BLKSIZE
#define HAS_STATFS_F_FSIZE HAS_STATFS_F_FSIZE 

#elif defined _AIX

#define NEED_SYS_VMOUNT_H NEED_SYS_VMOUNT_H
#define NEED_SYS_VFS_H NEED_SYS_VFS_H
#define NEED_SYS_STATFS_H NEED_SYS_STATFS_H
#define HAS_AIX_STATFS HAS_AIX_STATFS
#undef  HAS_STATFS
#undef  HAS_STATVFS

#elif defined WIN32

#define HAS_STAT_ST_SIZE HAS_STAT_ST_SIZE

#endif



#ifdef NEED_SYS_VFS_H
#include <sys/vfs.h>
#endif

#ifdef NEED_SYS_STATVFS_H
#include <sys/statvfs.h>
#endif

#ifdef NEED_SYS_STATFS_H
#include <sys/statfs.h>
#endif

#ifdef NEED_SYS_MOUNT_H
#include <sys/mount.h>
#endif

#ifdef NEED_SYS_VMOUNT_H
#include <sys/vmount.h>
#endif

#ifdef NEED_MNTENT_H
#include <mntent.h>
#endif 

#ifdef NEED_SYS_MNTENT_H
#include <sys/mntent.h>
#endif 

#include <sys/stat.h>
typedef struct stat stat_t;

#ifdef WIN32
#include <malloc.h>
#ifndef alloca
#define alloca(size) _alloca(size)
#endif
#endif

#ifdef __hpux
#define DONT_DECLARE_STD
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

static int get_fsname (char*, char **);
static int get_fssize (char *, I32 *, I32 *);

#ifdef UNIX
static char *find_directory (char *);
#endif

static int
get_fssize (char *filename, I32 *p_total, I32 *p_avail) {
#if defined HAS_AIX_STATFS
	typedef struct statfs statfs_t;
	statfs_t statfs_buff[1];
	struct stat stat_buff[1];
	I32 blksize;

	filename = find_directory (filename);
	if (stat (filename, stat_buff) != 0)
		return -1;

	if (statfs (filename, statfs_buff) != 0)
		return -1;

	blksize = statfs_buff->f_fsize;

	if (blksize < 1024) {
		*p_total = statfs_buff->f_blocks / (1024 / blksize);
		*p_avail = statfs_buff->f_bavail / (1024 / blksize);
	} else {
		*p_total = statfs_buff->f_blocks * (blksize / 1024);
		*p_avail = statfs_buff->f_bavail * (blksize / 1024);
	}
#endif
#if defined HAS_STATFS
	typedef struct statfs statfs_t;
	statfs_t statfs_buff[1];
	I32 blksize;

	filename = find_directory (filename);
	
	if (statfs (filename, statfs_buff) != 0)
		return -1;

#if defined HAS_STATFS_F_FSIZE
	blksize = statfs_buff->f_fsize;
#elif defined HAS_STATFS_F_BSIZE
	blksize = statfs_buff->f_bsize;
#else
#error cannot determine blocksize
#endif	
		
	if (blksize < 1024) {
		*p_total = statfs_buff->f_blocks / (1024 / blksize);
		*p_avail = statfs_buff->f_bavail / (1024 / blksize);
	} else {
		*p_total = statfs_buff->f_blocks * (blksize / 1024);
		*p_avail = statfs_buff->f_bavail * (blksize / 1024);
	}
#endif
#if defined HAS_STATVFS
	typedef struct statvfs statfs_t;
	statfs_t statfs_buff[1];
	I32 blksize;

	filename = find_directory (filename);
	if (statvfs (filename, statfs_buff) != 0)
		return -1;

	blksize = statfs_buff->f_frsize;

	if (blksize < 1024) {
		*p_total = statfs_buff->f_blocks / (1024 / blksize);
		*p_avail = statfs_buff->f_bavail / (1024 / blksize);
	} else {
		*p_total = statfs_buff->f_blocks * (blksize / 1024);
		*p_avail = statfs_buff->f_bavail * (blksize / 1024);
	}
#endif
#if defined WIN32
	int rc;
	void *p_func;
	char *dirname;

	/*
	 * get the name of the directory where the file is located
	 */
	rc = get_fsname (filename, &dirname);
	if (rc < 0)
		return -1;

	/*
	 * looking for GetDiskFreeSpaceEx ()
	 * this is default method for OS >= Windows 95 SR2
	 * otherwise we have to use GetDiskFreeSpace,
	 * this will only work correctly up to 2 GBytes
	 */
	p_func = GetProcAddress (
		GetModuleHandle ("kernel32.dll"), "GetDiskFreeSpaceExA");

	if (p_func) {
		ULARGE_INTEGER ularge_avail;
		ULARGE_INTEGER ularge_total;
		ULARGE_INTEGER ularge_free;

		__int64 i64_avail;
		__int64 i64_total;

		rc =
		GetDiskFreeSpaceEx (dirname,
		(PULARGE_INTEGER) &ularge_avail,
		(PULARGE_INTEGER) &ularge_total,
		(PULARGE_INTEGER) &ularge_free);
		
		i64_avail = ularge_avail.QuadPart;
		*p_avail = (I32)(i64_avail / (__int64) 1024);

		i64_total = ularge_total.QuadPart;
		*p_total = (I32)(i64_total / (__int64) 1024);
	} else {
		I32 scaling;
		DWORD secs_per_cluster;
		DWORD bytes_per_sec;
		DWORD free_clusters;
		DWORD total_clusters;

		rc =
		GetDiskFreeSpace (dirname, &secs_per_cluster, 
		&bytes_per_sec, &free_clusters, &total_clusters);

		scaling = (secs_per_cluster * bytes_per_sec) / 1024;
		*p_total = total_clusters * scaling;
		*p_avail = free_clusters * scaling;
	}

	free (dirname);
#endif
	return 0;	
}

static int
get_fsname (char *filename, char **p_fsname) {
#ifdef UNIX
	struct stat last_stat[1];
	struct stat stat_buff[1];
	char cwd[1024 + 1];
	char mountpoint[1024 + 1];

	/*
	 * save current directory
	 */
	if (getcwd (cwd, 1024) == 0)
		return (-1);

	filename = find_directory (filename);

	/*
	 * find directory where 'filename' is located
	 */
	if (stat (filename, stat_buff) != 0)
		return (-1);

	if (S_ISDIR (stat_buff->st_mode)) {
		/*
		 * it is already a directory
		 */
		memcpy (last_stat, stat_buff, sizeof (struct stat));
		if (chdir (filename) != 0)
			return (-1);
	} else {
		char *dirname;
		char *ptr;

		dirname = alloca (strlen (filename) + 1);
		strcpy (dirname, filename);

		ptr = strrchr (dirname, '/');
		if (ptr != 0) {
			*ptr = '\0';
		} else {
			strcpy (dirname, ".");
		}

		if (stat (dirname, stat_buff) != 0) {
			if (chdir (cwd) != 0)
				return -1;
		}

		memcpy (last_stat, stat_buff, sizeof (struct stat));
		if (chdir (dirname) != 0)
			return (-1);
	}

	/*
	 * walk up directory tree, until we come to other filesystem
	 */
	for (;;) {
		if (stat ("..", stat_buff) != 0) {
			if (chdir (cwd) != 0)
				return -1;
		}

		if (
		stat_buff->st_dev != last_stat->st_dev || 
		stat_buff->st_ino == last_stat->st_ino)
			break;

		if (chdir ("..") != 0) {
			if (chdir (cwd) != 0)
				return -1;
		}

		memcpy (last_stat, stat_buff, sizeof (struct stat));
	}

	if (getcwd (mountpoint, 1024) == 0)
		return (-1);

	if (chdir (cwd) != 0)
		return -1;

	*p_fsname = malloc (strlen (mountpoint) + 1);
	strcpy (*p_fsname, mountpoint);
#endif
#ifdef WIN32
	char *dirname;
	char *ptr;

	dirname = (char *) _alloca (strlen (filename) + 1);
	strcpy (dirname, filename);
	if (dirname[0] == '\\' && dirname[1] == '\\') {
		/*
		 * UNC name
		 */
		ptr = strchr (&dirname[2], '\\');
		if (ptr != 0) {
			if (strlen (ptr + 1) > 0) {
				/* 
				 * looks like \\host\share\...
				 * or \\host\share
				 */
				ptr = strchr (ptr + 1, '\\');
				if (ptr != 0)
					*ptr = '\0';
			} else {
					/* looks like \\host\ */
					return -1;
			}
		} else {
			/* looks like \\host */
			return -1;
		}
	} else if ((dirname[0] >= 'a' && dirname[0] <= 'z') || 
	           (dirname[0] >= 'A' && dirname[0] <= 'Z') && 
	           dirname[1] == ':') {
		/*
		 * drivename
		 */
		 dirname[2] = '\0';
	} else {
		/*
		 * use current working directory
		 */
		int dirname_len_max = 1024;
		dirname = (char *) alloca (dirname_len_max + 1);
		_getcwd (dirname, dirname_len_max);
		dirname[2] = '\0';
	}

	/*
	 * set dirname to upper case
	 */
	for (ptr = dirname; *ptr != '\0'; ptr++) {
		if (*ptr >= 'a' && *ptr <= 'z') {
			*ptr -= 'a' - 'A';
		}
	}

	*p_fsname = (char *) malloc (strlen (dirname) + 1);
	strcpy (*p_fsname, dirname);
#endif

	return 0;
}

static int
is_remote_fs (char *szfilename) {
#ifdef UNIX	

#if defined HAS_STATVFS && !defined linux 
	typedef struct statvfs statvfs_t;
	statvfs_t statvfs_buff[1];
#else
	typedef struct statfs statfs_t;
	statfs_t statfs_buff[1];
#endif

#ifdef __hpux
	char szfstype[FSTYPSZ];
#endif

#if defined HAS_STATVFS && !defined linux 
	if (statvfs (szfilename, statvfs_buff) != 0)
		return -1;

#else
	if (statfs (szfilename, statfs_buff) != 0)
		return -1;

#endif

#if defined linux
	if (
	statfs_buff->f_type == SMB_SUPER_MAGIC ||
	statfs_buff->f_type == NFS_SUPER_MAGIC ||
	statfs_buff->f_type == CIFS_MAGIC_NUMBER)
		return 1;

#elif defined _AIX
	if (
	statfs_buff->f_vfstype == MNT_NFS ||
	statfs_buff->f_vfstype == MNT_NFS3)
		return 1;

#elif defined sun || defined SNI
	if (
	strcmp (statvfs_buff->f_basetype, MNTTYPE_NFS) == 0 ||
	strcmp (statvfs_buff->f_basetype, MNTTYPE_NFS3) == 0)
		return 1;

#elif defined __hpux
	sysfs (GETFSTYP, statfs_buff->f_fsid[1], szfstype);

	if (
	strcmp (szfstype, MNTTYPE_NFS) == 0 ||
	strcmp (szfstype, MNTTYPE_NFS3) == 0)
		return 1;

#elif defined __osf__
	if (
	statfs_buff->f_type == MOUNT_NFS ||
	statfs_buff->f_type == MOUNT_NFS3)
		return 1;

#endif

	return 0;
#endif

#ifdef WIN32
	UINT drive_type;
	char *szfsname;
	char *szfsname_bs;

	if (get_fsname (szfilename, &szfsname) != 0)
		return -1;
	
	szfsname_bs = malloc (strlen (szfsname) + 2);
	if (szfsname_bs == 0)
		return -1;

	strcpy (szfsname_bs, szfsname);
	strcat (szfsname_bs, "\\");

	drive_type = GetDriveType (szfsname_bs);
	free (szfsname_bs);

	if (drive_type == DRIVE_REMOTE)
		return 1;

	if (drive_type == DRIVE_UNKNOWN)
		return -1;

	if (drive_type == DRIVE_NO_ROOT_DIR)
		return -1;

	return 0;
#endif
}

#ifdef UNIX
static char *
find_directory (char *filename) {
	struct stat stat_buff[1];
	char *ptr;

	for (;;) {
		if (strlen (filename) == 0)
			break;

		if (stat (filename, stat_buff) == 0)
			break;
	
		ptr = strrchr (filename, '/');
		if (ptr == 0)
			ptr = strrchr (filename, '\\');

		if (ptr == 0)
			break;
		
		*ptr = '\0';
	}
	return (filename);
}
#endif

MODULE = SAPDB::Install::FSUsage	PACKAGE = SAPDB::Install::FSUsage

PROTOTYPES: DISABLE

void
GetFSName (...)
PREINIT:
	int rc;
	char *filename;
	char *fsname;
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	filename = SvPV (ST(0), PL_na);

	if (filename == 0 || strlen (filename) == 0)
		XSRETURN_UNDEF;

	rc = get_fsname (filename, &fsname);
	if (rc < 0)
		XSRETURN_UNDEF;
	
	PUSHs (sv_2mortal (newSVpv (fsname, strlen (fsname))));
	free (fsname);
	XSRETURN (1);

void
IsRemoteFS (...)
PREINIT:
	int rc;
	char *filename;
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	filename = SvPV (ST(0), PL_na);

	if (filename == 0 || strlen (filename) == 0)
		XSRETURN_UNDEF;

	rc = is_remote_fs (filename);
	if (rc < 0)
		XSRETURN_UNDEF;
	
	XSRETURN_IV (rc);

void
GetFSSize (...)
PREINIT:
	int rc;
	char *filename;
	I32 total;
	I32 avail;
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	filename = SvPV (ST(0), PL_na);
	if (filename == 0 || strlen (filename) == 0)
		XSRETURN_UNDEF;

	rc = get_fssize (filename, &total, &avail);
	if (rc < 0)
		XSRETURN_UNDEF;

	PUSHs (sv_2mortal (newSViv (total)));
	PUSHs (sv_2mortal (newSViv (avail)));
	XSRETURN (2);
