/*
 * $SRC/install/perl/Comm.xs
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/GetParam.xs#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 */

static char szWhatHeader[] = 
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/GetParam.xs#1 $";

#ifndef __cplusplus
#ifndef HAS_BOOL
typedef char bool;
#endif
#endif

#ifndef WIN32
#define UNIX UNIX
#endif

#ifdef UNIX
#include <stdio.h>
static int myfread (void *ptr, int size, int nmemb, void *fp) {
    return (fread (ptr, size, nmemb, (FILE *) fp));
}
#endif

#ifdef WIN32
#define myfread(a,b,c,d) fread (a, b, c, d)
#endif

#ifdef __hpux
#define DONT_DECLARE_STD
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef PERL_OBJECT
#define FILE struct _PerlIO
#endif

/*
 * expect compiler warning 4113 when using Microsoft C
 * in c code generated by xs preprocessor
 */
#if _MSC_VER >= 1200
#pragma warning(disable : 4113)
#endif

/*
 * includes and defines needed by access ()
 */
#ifdef UNIX
#include <unistd.h>
#endif
#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <io.h>
#define R_OK 4
#endif

#if defined WIN32
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#define NEED_TYPEDEF_UNIT16_T NEED_TYPEDEF_UNIT16_T
#define NEED_TYPEDEF_UNIT32_T NEED_TYPEDEF_UNIT32_T
#define NEED_TYPEDEF_UNIT64_T NEED_TYPEDEF_UNIT64_T
#elif defined linux
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __hpux  && defined __hppa
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __hpux && defined __ia64 && ! defined HAS_STRTOLL
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __osf__
#define NEED_TYPEDEF_UNIT16_T NEED_TYPEDEF_UNIT16_T
#define NEED_TYPEDEF_UNIT32_T NEED_TYPEDEF_UNIT32_T
#define NEED_TYPEDEF_UNIT64_T NEED_TYPEDEF_UNIT64_T
#define NEED_SNPRINTF NEED_SNPRINTF
#define HAS_SPRINTF_INTRINSIC HAS_SPRINTF_INTRINSIC
#endif

#ifdef NEED_TYPEDEF_UCHAR_T
typedef unsigned char  uchar_t;
#endif
#ifdef NEED_TYPEDEF_UNIT16_T
typedef unsigned short uint16_t;
#endif
#ifdef NEED_TYPEDEF_UNIT32_T
typedef unsigned int   uint32_t;
#endif
#ifdef NEED_TYPEDEF_UNIT64_T
typedef unsigned long  uint64_t;
#endif

#ifdef WIN32
typedef __int64 int64_t;
/*#else
#if ! defined _AIX  &&  ! defined __osf__
#ifdef _LP64
typedef long int64_t;
#else
typedef long long int64_t;
#endif
#endif*/
#endif


#if defined UNIX
#define PATH_SEPARATOR "/"
#elif defined WIN32
#define PATH_SEPARATOR "\\"
#endif

#define PARAM_DIR_NAME     "config"

#define PARAM_TYPE_NOFILE 0
#define PARAM_TYPE_FST    1
#define PARAM_TYPE_RW1    2
#define PARAM_TYPE_RW2    3
#define PARAM_TYPE_RW3    4
#define PARAM_TYPE_RW4    5

static char *
access_paramfile (char *instancename, char *path) {
	char *filename;

	filename =
	(char *) malloc (strlen (path) + strlen (PATH_SEPARATOR) +
	strlen (PARAM_DIR_NAME) + strlen (PATH_SEPARATOR) +
	strlen (instancename) + 1);
	
	if (filename == 0)
		return 0;
	
	strcpy (filename, path);
	strcat (filename, PATH_SEPARATOR);
	strcat (filename, PARAM_DIR_NAME);
	strcat (filename, PATH_SEPARATOR);
	strcat (filename, instancename);

	if (access (filename, F_OK) == 0)
		return (filename);

	free (filename);
	return 0;
}

static char *
get_datapath () {
#if defined WIN32
	char *datapath;
	HKEY hkey;
	DWORD type;
	DWORD len;

	if
	(RegOpenKeyEx (HKEY_LOCAL_MACHINE, "Software\\SAP\\SAP DBTech", 0,
	KEY_READ, &hkey) != ERROR_SUCCESS)
		return 0;

	if
	(RegQueryValueEx (hkey, "IndepData", 0,
	&type, 0, &len) != ERROR_SUCCESS) {
		RegCloseKey (hkey);
		return 0;
	}

	if (type != REG_SZ && type != REG_EXPAND_SZ) {
		RegCloseKey (hkey);
		return 0;
	}

	datapath = (char *) malloc (len + 1);
	if (datapath == 0) {
		RegCloseKey (hkey);
		return 0;
	}	

	if
	(RegQueryValueEx (hkey, "IndepData", 0, &type,
	(unsigned char *) datapath, &len) != ERROR_SUCCESS) {
		free (datapath);
		RegCloseKey (hkey);
		return 0;
	}

	RegCloseKey (hkey);
	return (datapath);
#elif defined UNIX
	int rc;
	char *datapath;
	char *ptr;

	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	rc = perl_call_pv (
		"SAPDB::Install::GetParam::GetDataPathUX",
		G_SCALAR);

	SPAGAIN;

	datapath = 0;
	if (rc == 1) {
		ptr = POPp;
		if (strlen (ptr) > 0) {
			datapath = malloc (strlen (ptr) + 1);
			if (datapath != 0)
				strcpy (datapath, ptr);
		}
	}

	PUTBACK;
	FREETMPS;
	LEAVE;

	return (datapath);
#endif
}

static char *
get_paramfile (char *instancename) {
	char *filename;
	char *datapath;
	char *dbroot;
	
	filename = 0;

	datapath = get_datapath ();
	if (datapath != 0 && strlen (datapath) > 0)
			filename = access_paramfile (instancename, datapath);

	if (datapath != 0)
		free (datapath);

	if (filename != 0)
		return (filename);

	/*
	 * last chance to find the paramfile
	 * it could be located in %DBROOT% on windows
	 * or in /usr/spool/sql on unix
	 * or in /var/spool/sql on linux
	 *
	 *              !!! warning !!!
	 *
	 * usage of %DBROOT%\\config or /usr/spool/sql/config
	 * and similar is deprecate since SAPDB 7.2.04.04,
	 * but still used in development environment
	 */

#if defined WIN32
	dbroot = getenv ("DBROOT");
	if (dbroot != 0 && strlen (dbroot) > 0)
		filename = access_paramfile (instancename, dbroot);
#elif defined UNIX
	filename = access_paramfile (instancename, "/usr/spool/sql");
	if (filename != 0)
		return (filename);

	filename = access_paramfile (instancename, "/var/spool/sql");
#endif

	return (filename);
}

/*
 * definitions for generic parameters
 */
typedef struct param {
	char *key;
	char *val;
	struct param *next;
} param_t;

#define PARAM_DIRTY_KEY    "__PARAM_CHANGED___"
#define PARAM_VERIFIED_KEY "__PARAM_VERIFIED__"

static param_t *paramfree (param_t *);
static param_t *paramget (char *, char *);

/*
 * definitions for paramfile using format by r.w.
 */
#define PRW_MAGIC   "SAPDB_XPARAM_FILE"
#define PRW_MAGIC_1 "SAPDB_XPARAM_FILE_01RW"
#define PRW_MAGIC_2 "SAPDB_XPARAM_FILE_02RW"
#define PRW_MAGIC_3 "SAPDB_XPARAM_FILE_03RW"
#define PRW_MAGIC_4 "SAPDB_XPARAM_FILE_04RW"

typedef struct {
	uchar_t year[2];
	uchar_t mon[2];
	uchar_t dow[2];
	uchar_t dom[2];
	uchar_t hour[2];
	uchar_t min[2];
	uchar_t sec[2];
	uchar_t msec[2];
} prw_timestamp_t;

typedef uchar_t  prw_flag_t;
typedef uint32_t prw_len_t;

#define PRW_TIMESTAMP_OFF  0
#define PRW_CRASHFLAG_OFF (PRW_TIMESTAMP_OFF + sizeof (prw_timestamp_t))
#define PRW_KEYLENMAX_OFF (PRW_CRASHFLAG_OFF + sizeof (prw_flag_t))
#define PRW_VALLENMAX_OFF (PRW_KEYLENMAX_OFF + sizeof (prw_len_t))

typedef struct {
	char magic[22];
	char buffer[64];
} prw_header_t;


/*
 * definitions for paramfile using format by fst
 */
#define PFST_KEY_LEN_MAX  18
#define PFST_TYPE_LEN_MAX  4
#define PFST_VAL_LEN_MAX  64

typedef struct {
	char key[PFST_KEY_LEN_MAX];
	char type[PFST_TYPE_LEN_MAX];
	char val[PFST_VAL_LEN_MAX];
} pfst_rec_t;

#define PFST_HEADER_0     "XP_FST_XP_HEADER_0"
#define PFST_KEY_DEL      "XP_FST_XP_DELETE__"

#define PFST_TYPE_INT2    0
#define PFST_TYPE_INT4    1
#define PFST_TYPE_C8      2
#define PFST_TYPE_C18     3
#define PFST_TYPE_C24     4
#define PFST_TYPE_C40     5
#define PFST_TYPE_C64     6
#define PFST_TYPE_CRYPT   7

#define PFST_SIZE_CRYPT  24

/*
 * implementation of functions for paramfile using format by r.w.
 */
static param_t *
prwread (void *buff, size_t size, int *pos, int version) {
	unsigned char *key, *type, *val;
	param_t *param;
	uchar_t typeid;
	int i;

	key = (unsigned char *) buff + *pos;
	type = key + strlen ((char *) key) + 1;

	switch (version) {
	case 1:
	case 2:
		val = type + 1;
		typeid = 0;
		memcpy (&typeid, type, sizeof (uchar_t));
		break;
	case 3:
		val = type + 2;
		typeid = 0;
		memcpy (&typeid, type + 1, sizeof (uchar_t));
		break;
	case 4:
		val = type + 3;
		typeid = 0;
		memcpy (&typeid, type + 2, sizeof (uchar_t));
		break;
	default:
		return 0;
	}

	switch (typeid) {
	case 0x11:
		*pos += val - key + 8;
		break;
	case 0x22:
		*pos += val - key + 8;
	case 0x33:
		*pos += val - key + strlen ((char *) val) + 1;
		break;
	case 0x44:
		*pos += val - key + 24;
		break;
	default:
		return 0;
	}

	param = (param_t *) malloc (sizeof (param_t));
	if (param == 0)
		return 0;

	memset (param , 0, sizeof (param_t));

	param->key = (char *) malloc (type - key);
	if (param->key == 0) 
		return (paramfree (param));

	strcpy (param->key, (char *) key);

	switch (typeid) {
	case 0x11:
		param->val = (char *) malloc (22);
		if (param->val == 0)
			return (paramfree (param));
		
#if HAS_BYTEORDER == 1234 || HAS_BYTEORDER == 12345678
		sprintf (param->val, "%ld",
			0x1 * val[0] +
			0x100 * val[1] +
			0x10000 * val[2] +
			0x1000000 * val[3] +
#ifdef __LP64
			0x100000000 * val[4] +
			0x10000000000 * val[5] +
			0x1000000000000 * val[6] +
			0x100000000000000 * val[7] +
#endif
			0);
#endif
#if HAS_BYTEORDER == 4321 || HAS_BYTEORDER == 87654321
		sprintf (param->val, "%ld",
			0x1 * val[7] +
			0x100 * val[6] +
			0x10000 * val[5] +
			0x1000000 * val[4] +
#ifdef __LP64
			0x100000000 * val[3] +
			0x10000000000 * val[2] +
			0x1000000000000 * val[1] +
			0x100000000000000 * val[0] +
#endif
			0);
#endif

		break;
	case 0x22:
		param->val = (char *) malloc (6);
		if (param->val == 0)
			return (paramfree (param));

		strcpy (param->val, "FLOAT");
		break;
	case 0x33:
		param->val = (char *) malloc (strlen ((char *) val) + 1);
		if (param->val == 0)
			return (paramfree (param));

		strcpy (param->val, (char *) val);
		break;
	case 0x44:
		param->val = (char *) malloc (49);
		if (param->val == 0)
			return (paramfree (param));

		for (i = 0; i < 24; i++) 
			sprintf (&param->val[2 * i], "%02X",
			((unsigned char *)val)[i]);

		break;
	default:
		return (paramfree (param));
	}

	return (param);
}

static char *
prwverified (prw_header_t *hdr) {
	char *val;
	char format[] = "%04d-%02d-%02d %02d:%02d:%02d";
	prw_timestamp_t *ts;
	int year, mon, day, hour, min, sec;

	if (hdr == 0)
		return 0;

	ts = (prw_timestamp_t *)(&hdr->buffer[PRW_TIMESTAMP_OFF]);
	year = ts->year[1] << 8 | ts->year[0];
	mon  = ts->mon[1]  << 8 | ts->mon[0];
	day  = ts->dom[1]  << 8 | ts->dom[0];
	hour = ts->hour[1] << 8 | ts->hour[0];
	min  = ts->min[1]  << 8 | ts->min[0];
	sec  = ts->sec[1]  << 8 | ts->sec[0];

	if (
	year > 9999 || mon > 12 || day > 31 ||
	hour > 24 || min > 60 || sec > 60)
		return 0; 

	val = (char *) malloc (22);
	if (val == 0)
		return 0;

	sprintf (val, format, year, mon, day, hour, min, sec);
	return (val);
}

static char *
prwdirty (prw_header_t *hdr) {
	char *val;
	prw_timestamp_t *ts;
	prw_timestamp_t null[1];
	int dirty;

	if (hdr == 0)
		return 0;

	ts = (prw_timestamp_t *)(&hdr->buffer[PRW_TIMESTAMP_OFF]);
	memset (null, 0, sizeof (prw_timestamp_t));

	dirty = memcmp (ts, null, sizeof (prw_timestamp_t)) ? 0 : 1;
	val = (char *) malloc (2);
	if (val == 0)
		return 0;

	sprintf (val, "%d", dirty);
	return (val);
}

static param_t *
prwnew (char *filename, int *type) {
	int rc;
	FILE *fp;
	int pos;
	size_t size;
	char *buff;
	Stat_t sb[1];
	prw_header_t hdr[1];
	param_t *param, *curr, *last;
	char *val;
	int version;

	fp = fopen (filename, "rb");
	if (fp == 0)
		return 0;

	rc = myfread (hdr, 1, sizeof (prw_header_t), fp);
	if (rc != sizeof (prw_header_t)) {
		fclose (fp);
		return 0;
	}

	if (memcmp (hdr->magic, PRW_MAGIC, strlen (PRW_MAGIC)) != 0) {
		fclose (fp);
		return 0;
	}

	version =
	memcmp (hdr->magic, PRW_MAGIC_1, strlen (PRW_MAGIC_1)) == 0 ? 1 :
	memcmp (hdr->magic, PRW_MAGIC_2, strlen (PRW_MAGIC_2)) == 0 ? 2 :
	memcmp (hdr->magic, PRW_MAGIC_3, strlen (PRW_MAGIC_3)) == 0 ? 3 :
	memcmp (hdr->magic, PRW_MAGIC_4, strlen (PRW_MAGIC_4)) == 0 ? 4 :
	0;

	switch (version) {
	case 1:
		*type = PARAM_TYPE_RW1;
		break;
	case 2:
		*type = PARAM_TYPE_RW2;
		break;
	case 3:
		*type = PARAM_TYPE_RW3;
		break;
	case 4:
		*type = PARAM_TYPE_RW4;
		break;
	}

	if (version == 0) {
		fclose (fp);
		return 0;
	}

	rc = fstat (fileno (fp), sb);
	if (rc != 0) {
		fclose (fp);
		return 0;
	}

	size = (size_t) sb->st_size - sizeof (prw_header_t);
	if (size < 0) {
		fclose (fp);
		return 0;
	}

	buff = (char *) malloc (size);
	if (buff == 0) {
		fclose (fp);
		return 0;
	}

	rc = myfread (buff, 1, size, fp);
	if (rc != size) {
		free (buff);
		fclose (fp);
		return 0;
	}

	fclose (fp);
	
	pos = 0;
	curr = param = last = 0;
	for (;;) {
		curr = prwread (buff, size, &pos, version);
		if (curr == 0)
			break;

		if (param == 0)
			param = last = curr;
		else
			last = last->next = curr;
	}
	free (buff);

	val = prwverified (hdr);
	if (val == 0)
		return (param);

	curr = paramget (PARAM_VERIFIED_KEY, val);
	if (curr == 0)
		return (param);

	free (val);

	if (param == 0)
		param = last = curr;
	else
		last = last->next = curr;
		
	val = prwdirty (hdr);
	if (val == 0)
		return (param);

	curr = paramget (PARAM_DIRTY_KEY, val);
	if (curr == 0)
		return (param);

	free (val);

	if (param == 0)
		param = last = curr;
	else
		last = last->next = curr;
		
	return (param);
}

/*
 * implementation of functions for paramfile using format by fst
 */
static char *
chomp (char *buff) {
	char *ptr;
	int len;

	for (;;) {
		len = strlen (buff);
		if (len <= 0)
			break;

		ptr = (char *) buff + len - 1;
		if (*ptr != ' ')
			break;

		*ptr = '\0';
	}

	return (buff);
}

static param_t *
pfstread (void *paramfile) {
	int i;
	uint32_t type;
	uint16_t val16;
	uint32_t val32;
	param_t *param;
	pfst_rec_t rec[1];

	int rc;
	char buff[PFST_KEY_LEN_MAX + 1];

	rc = myfread (rec, 1, sizeof (pfst_rec_t), (FILE *) paramfile);
	if (rc != sizeof (pfst_rec_t))
		return 0;

	memcpy (buff, rec->key, PFST_KEY_LEN_MAX);
	buff[PFST_KEY_LEN_MAX] = '\0';
	chomp (buff);
	memcpy (rec->key, buff, PFST_KEY_LEN_MAX);

	param = (param_t *) malloc (sizeof (param_t));
	if (param == 0)
		return 0;

	memset (param, 0, sizeof (param_t));

	param->key = (char *) malloc (PFST_KEY_LEN_MAX + 1);
	if (param->key == 0) {
		free (param);
		return 0;
	}

	param->val = (char *) malloc (PFST_VAL_LEN_MAX + 1);
	if (param->val == 0) {
		free (param->key);
		free (param);
		return 0;
	}

	memcpy (param->key, rec->key, PFST_KEY_LEN_MAX);
	(param->key)[PFST_KEY_LEN_MAX] = '\0';

	type = ((uchar_t *)(rec->type))[3];

	switch (type) {
	case PFST_TYPE_C8:
		memcpy (param->val, rec->val, 8);
		(param->val)[8] = '\0';
		chomp (param->val);
		break;
	case PFST_TYPE_C18:
		memcpy (param->val, rec->val, 18);
		(param->val)[18] = '\0';
		chomp (param->val);
		break;
	case PFST_TYPE_C24:
		memcpy (param->val, rec->val, 24);
		(param->val)[24] = '\0';
		chomp (param->val);
		break;
	case PFST_TYPE_C40:
		memcpy (param->val, rec->val, 40);
		(param->val)[40] = '\0';
		chomp (param->val);
		break;
	case PFST_TYPE_C64:
		memcpy (param->val, rec->val, 64);
		(param->val)[64] = '\0';
		chomp (param->val);
		break;
	case PFST_TYPE_CRYPT:
		for (i = 0; i < PFST_SIZE_CRYPT; i++) {
			sprintf (&(param->val[2 * i]), "%02x",
			        (unsigned char) rec->val[i]);
		}
		break;
	case PFST_TYPE_INT2:
		val16 = 0;
		memcpy ((char *)&val16, rec->val, 2);
		sprintf (param->val, "%d", val16);
		break;
	case PFST_TYPE_INT4:
		val32 = 0;
		memcpy ((char *)&val32, rec->val, 4);
		sprintf (param->val, "%d", val32);
		break;
	default:
		param->val[0] = '\0';
		break;
	}

	return (param);
}

static param_t *
pfstnew (char *filename, int *type) {
	int rc;
	FILE *fp;
	pfst_rec_t rec[1];
	param_t *param, *curr, *last;

	fp = fopen (filename, "rb");
	if (fp == 0)
		return 0;

	rc = myfread (rec, 1, sizeof (pfst_rec_t), fp);
	if (rc != sizeof (pfst_rec_t)) {
		fclose (fp);
		return 0;
	}

	param = curr = last = 0;
	for (;;) {
		curr = pfstread (fp);
		if (curr == 0)
			break;

		if (strcmp (curr->key, PFST_HEADER_0) == 0)
			continue;

		if (strcmp (curr->key, PFST_KEY_DEL) == 0)
			continue;

		if (param == 0)
			param = last = curr;
		else
			last = last->next = curr;
	}

	fclose (fp);

	*type = PARAM_TYPE_FST;
	return (param);
}

/*
 * implementation of functions for generic format of paramfile
 */
static param_t *
paramget (char *key, char *val) {
	param_t *param;

	param = (param_t *) malloc (sizeof (param_t));
	if (param == 0)
		return 0;

	memset (param, 0, sizeof (param_t));
	param->key = (char *) malloc (strlen (key) + 1);
	if (param->key == 0) {
		free (param);
		return 0;
	}

	param->val = (char *) malloc (strlen (val) + 1);
	if (param->val == 0) {
		free (param->key);
		free (param);
		return 0;
	}

	strcpy (param->key, key);
	strcpy (param->val, val);

	return (param);
}

static param_t *
paramfree (param_t *param) {
	if (param == 0)
		return 0;

	if (param->key != 0)
		free (param->key);

	if (param->val != 0)
		free (param->val);

	free (param);
	return 0;
}

static param_t *
paramdel (param_t *param) {
	while (param != 0) {
		param_t *next;

		next = param->next;
		paramfree (param);
		param = next;
	}

	return 0;
}

static param_t *
paramnew (char *filename, int *type) {
	Stat_t sb[1];
	param_t *param;

	*type = PARAM_TYPE_NOFILE;
	if (stat (filename, sb) != 0)
		return 0;

	param = prwnew (filename, type);

	if (param == 0)
		param = pfstnew (filename, type);

	return (param);
}

/*
 * now we add the perl source as as inline code
 * symbol name of the string containing the code
 * is sz_text
 * this code will be evaled in the BOOT method of the module 
 */

static char *paramfile_type_names[] = {
	"NOFILE", "FST", "RW1", "RW2",	"RW3", "RW4", 0
};

#include "GetParam.h"

MODULE = SAPDB::Install::GetParam       PACKAGE = SAPDB::Install::GetParam

PROTOTYPES: DISABLE

BOOT:
	perl_eval_pv ((char *) sz_text, 1);

void
GetParam (...)
PREINIT:
	char *instancename;
	char *filename;
	char *typename;
	param_t *param, *curr;
	SV *rv;
	HV *hv;
	HV *hv0;
	int type[1];
	char *data_key = "data";
	char *type_key = "type";
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	instancename = SvPV (ST(0), PL_na);
	if (strlen (instancename) == 0)
		XSRETURN_UNDEF;

	filename = get_paramfile (instancename);
	if (filename == 0)
		XSRETURN_UNDEF;

	if (strlen (filename) == 0) {
		free (filename);
		XSRETURN_UNDEF;
	}

	*type = 0;
	param = paramnew (filename, type);
	free (filename);

	if (param == 0)
		XSRETURN_UNDEF;

	hv = newHV ();

	typename = paramfile_type_names[*type]; 
	hv_store (
	hv, type_key, strlen (type_key),
	newSVpv (typename, strlen (typename)), 0);

	hv0 = newHV ();
	for (curr = param; curr != 0; curr = curr->next) {
		hv_store
		(hv0, curr->key, strlen (curr->key),
        newSVpv (curr->val, strlen (curr->val)), 0);
	}

	paramdel (param);

	rv = newRV ((SV *) hv0);
	SvREFCNT_dec (hv0);
	hv_store (hv, data_key, strlen (data_key), rv, 0);

	rv = sv_2mortal (newRV ((SV *) hv));
	SvREFCNT_dec (hv);

	XPUSHs (rv);
	XSRETURN (1);
