#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/PipeExec.pl#1 $
# $DateTime: 2005/03/21 16:21:00 $  
# $Change: 93297 $
#

package SAPDB::Install::PipeExec;

sub new {
	my $self = {};
	bless $self;

	$self->{'sess'} = 0;
	$self->{'errtext'} = undef;
	$self->{'sess'} = newXS ();
	return ($self);
}

sub DESTROY {
	my ($self) = @_;

	return unless (defined $self->{'sess'});
	return if ($self->{'sess'} == 0);
	CloseXS ($self->{'sess'});
	$self->{'sess'} = 0;
	delete $self->{'errtext'};
	return;
}

sub Open {
	my ($self, $cmdline) = @_;
	
	unless (defined OpenXS ($self->{'sess'}, $cmdline)) {
		$self->{'errtext'} = GetErrorXS ($self->{'sess'});
		return undef;
	} 

	return 0;
}

sub Timeout {
	my ($self, $sec) = @_;

	return undef unless (defined $self->{'sess'});
	return undef if ($self->{'sess'} == 0);

	unless (defined TimeoutXS ($self->{'sess'}, $sec)) {
		$self->{'errtext'} = GetErrorXS ($self->{'sess'});
		return undef;
	} 

	return 0;
}

sub WasaTimeout {
	my ($self) = @_;

	return undef unless (defined $self->{'sess'});
	return undef if ($self->{'sess'} == 0);

	my $rc = WasaTimeoutXS ($self->{'sess'});
	return undef unless (defined $rc);

	return $rc;
}

sub Close {
	my ($self) = @_;
	my $rc;	

	return undef unless (defined $self->{'sess'});
	return 0 if ($self->{'sess'} == 0);

	$rc = CloseXS ($self->{'sess'});

	$self->{'errtext'} = undef;
	$self->{'sess'} = 0;

	return $rc;
}

sub Readline {
	my ($self) = @_;
	
	return undef unless (defined $self->{'sess'});
	return 0 if ($self->{'sess'} == 0);

	my $buffer = ReadlineXS ($self->{'sess'});
	$self->{'errtext'} = GetErrorXS ($self->{'sess'});
	return undef if (defined $self->{'errtext'});

	return ($buffer)
}

sub GetError {
	my ($self) = @_;
	return ($self->{'errtext'});
}

#
# internal helper for unix cmd line splitting
#
sub PrepareArgv {
	my ($cmd) = @_;
	my @argv = SplitArgv ($cmd);
	my $file = shift (@argv);

	if ($file =~ /\//) {
		return ($file.': '.$!) unless (-x $file);
		return ('', $file, @argv);
	}

	foreach my $path (split (':', $ENV{'PATH'})) {
		if (-x $path.'/'.$file) {
			$file = $path.'/'.$file;
			return ('', $file, @argv);
		}
	}
	return $file.': No such command';
}

sub SplitArgv {
	my ($cmdline, @argv) = @_;

	if (not defined $cmdline || $cmdline eq "") {
		return (@argv);
	}

	# doublequoted argument
	if ($cmdline =~ s/^\s*\"(.*?)\"//) {
		push @argv, $1;
		return (SplitArgv ($cmdline, @argv));
	}

	# argument surrunded with withespaces
	if ($cmdline =~ s/^\s*(.+?)\s+//) {
		push @argv, $1;
		return (SplitArgv ($cmdline, @argv));
	}

	# last argument 
	if ($cmdline =~ s/^\s*(.+)//) {
		push @argv, $1;
		return (SplitArgv ($cmdline, @argv));
	}

	return (@argv);
}

