/* 
 * WIN32APISystem.xs
 * 
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/SystemWin32API.xs#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 */

static char szWhatHeader[] = 
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/SystemWin32API.xs#1 $";

#ifndef __cplusplus
#ifndef HAS_BOOL
typedef char bool;
#endif
#endif

#ifdef __hpux
#define DONT_DECLARE_STD
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/*
 * expect compiler warning 4113 when using Microsoft C
 * in c code generated by xs preprocessor
 */
#if _MSC_VER >= 1200
#pragma warning(disable : 4113)
#endif

#ifndef WIN32
#define UNIX UNIX
#endif

#ifdef UNIX
static const int IsWindows = 0;
#endif

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

static const int IsWindows = 1;
#endif

#ifdef WIN32
static int
getErrMsg (char ** szMsg){
	char *szErrMsg, *index1, *index2, *szResult;
	int count;
	
	FormatMessage (
		FORMAT_MESSAGE_ALLOCATE_BUFFER |
        	FORMAT_MESSAGE_FROM_SYSTEM |
		FORMAT_MESSAGE_IGNORE_INSERTS,
        	NULL,
        	(DWORD) GetLastError(),
        	0, // Default language
        	(LPTSTR) &szErrMsg,
        	0,
        	NULL
	);
	index1 = szErrMsg;
	count = 0;

	/* find number of \r\n */
	while(1){
		if(*index1 == '\0')
			break;	
		if(*index1 == '\r' && *(index1 + 1) == '\n'){
			count++;
			index1 += 2;
		}
		else{
			index1++;
		}
	}
	szResult = (char *) malloc(strlen(szErrMsg) + 1 - count);
	if(szResult == 0)
		return -1;

	/* copy errmsg into result and replace '\r\n' with ' ' */
	index1 = szErrMsg;
	index2 = szResult;
	while(1){
		if(*index1 == '\0'){
			*index2 = '\0';
			break;	
		}
		if(*index1 == '\r' && *(index1 + 1) == '\n'){
			*(index2++) = ' ';
			index1 += 2;
		}
		else{
			*(index2++) = *(index1++); 
		}
	}
	if(szErrMsg != 0)
		LocalFree(szErrMsg);

	return 0;
}

static int
myMoveFileEx( char * szSrc, char * szDst){
	OSVERSIONINFO osinfo[1];
	osinfo->dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx (osinfo);
	switch(osinfo->dwPlatformId){
		case VER_PLATFORM_WIN32_WINDOWS:{

			/************************
				WINDOWS 9x
			***************************/
			const int BUFSIZE = 0x8000;
			char RenameSection[0x8000];
			char * szAction;
			char szDelete[] = "NUL=";
			char szMove[] = "=";
			char szWinInit[_MAX_PATH];
			char szWinInitFileName[] = "WININIT.INI";
			int len;
			
			if(szDst == NULL){
				szAction = (char *) malloc(strlen(szSrc) + strlen(szDelete) + 1);
				strcpy(szAction,szDelete);
				strcat(szAction,szSrc);
			}
			else{
				szAction = (char *) malloc(strlen(szSrc) + strlen(szDst) + strlen(szMove) + 1);
				strcpy(szAction,szDst);
				strcat(szAction,szMove);
				strcat(szAction,szSrc);
			}
			if(GetWindowsDirectory(szWinInit,_MAX_PATH) == 0){
				return -1;
			}
			if(*(szWinInit + strlen(szWinInit) - 1) != '\\'){
				strcat(szWinInit,"\\");
			}
			strcat(szWinInit,szWinInitFileName);
			len = GetPrivateProfileSection("Rename",RenameSection,BUFSIZE,szWinInit);
			strcpy(RenameSection + len,szAction);
			if(WritePrivateProfileSection("rename",RenameSection,szWinInit) == 0){
				return -1;
			}
			break;
		}
		case VER_PLATFORM_WIN32_NT:{

			/************************
				WINDOWS NT
			***************************/

			if(!MoveFileEx(szSrc,szDst, MOVEFILE_DELAY_UNTIL_REBOOT | MOVEFILE_REPLACE_EXISTING)){
				return -1;	
			}
			break;
		}
		default:
			return -1;
	}
	return 0;
}

static int
mySfcIsFileProtected (char *filename) {
	OSVERSIONINFO osversion[1];

	BOOL (WINAPI *fSfcIsFileProtected)(HANDLE, LPSTR);
	HANDLE hSFCDLL;

	/*
	 * system file protection can only be found on
	 * windows me and better or windows 2000 and better
	 */
	GetVersionEx (osversion);
	if (osversion->dwMajorVersion < 5 &&
	!(osversion->dwMajorVersion == 4 && osversion->dwMinorVersion >= 90))
		return 0;

	hSFCDLL = LoadLibrary ("sfc.dll");
	if (hSFCDLL == 0)
		return (-1);

	fSfcIsFileProtected = (BOOL (WINAPI *)(HANDLE, LPSTR))
	GetProcAddress (hSFCDLL, "SfcIsFileProtected");
	if (fSfcIsFileProtected == 0) {
		FreeLibrary (hSFCDLL);
		return (-1);
	}

	if (fSfcIsFileProtected (0, filename) != 0) {
		FreeLibrary (hSFCDLL);
		return 1;
	}

	if (GetLastError () == 0) {
		FreeLibrary (hSFCDLL);
		return 0;
	}

	FreeLibrary (hSFCDLL);
	return (-1);
}


static int
myGetHDDrives(char *** drives){
	DWORD drive_mask = GetLogicalDrives();
	int i;
	int drive_num = 0;
	*drives = (char **) malloc ( sizeof(char*) * 26);
	if(*drives == 0)
		return -1;
	memset(*drives,0,26);
	for(i = 0;i < 26;i++){
		if(drive_mask & 1){
			DWORD nDriveType;
			char * szRootFs = (char *) malloc(4);
			if( szRootFs == 0)
				return -1;
			memset(szRootFs,0,4);
			sprintf(szRootFs,"%c:\\",(char) (i + 'A'));
			nDriveType = GetDriveType(szRootFs);
			if (nDriveType == DRIVE_FIXED || 
				nDriveType == DRIVE_REMOTE){
				DWORD nFileSystemFlags;
				BOOL rc;
				if (nDriveType != DRIVE_REMOTE){
					rc = GetVolumeInformation(
							szRootFs,
							NULL,
							0,
							NULL,
							NULL,
							&nFileSystemFlags,
							NULL,
							0
					);
				}
				if(nDriveType == DRIVE_REMOTE ||
				  (rc != 0 && !(nFileSystemFlags & FILE_READ_ONLY_VOLUME))){
					(*drives)[drive_num] = (char*) malloc(3);
					if( (*drives)[drive_num] == 0)
						return -1; 
					memset((*drives)[drive_num],0,3); 
					strncpy((*drives)[drive_num],szRootFs,2);
					drive_num++;
				}
			}			
			free(szRootFs);
		}
		drive_mask >>= 1;		
		if(drive_mask == 0)
			break;
	}
	
	if (drive_num == 0)
		return -1;
	
	return drive_num;

}

static int
myGetComputerName(char ** pszhostname){
	DWORD nSize = MAX_COMPUTERNAME_LENGTH;
	LPTSTR lpBuffer = malloc(MAX_COMPUTERNAME_LENGTH + 1);
	if(lpBuffer){
		GetComputerName(lpBuffer,&nSize);
		*pszhostname = malloc(nSize + 1);
		strcpy(*pszhostname,lpBuffer);
		free(lpBuffer);
		return nSize;
	}
	else{
		return -1;
	}
}

#endif

#ifdef UNIX
static int
getErrMsg(char ** szMsg){
	char * msg = "unix does not support this feature\n";
	*szMsg = msg;
	return 0;
}

static int
myMoveFileEx( char * szSrc, char * szDst){
	return -1;
}

static int
mySfcIsFileProtected (char *filename) {
	return -1;
}

static int
myGetHDDrives(char ** drives){
	return -1;
}

static int
myGetComputerName(char ** pszhostname){
	return -1;
}

#endif

MODULE = SAPDB::Install::System::Win32::API	PACKAGE = SAPDB::Install::System::Win32::API

PROTOTYPES: DISABLE

void
MoveFileAfterReboot (...)
PREINIT:
	int rc;
	char * szErrMsg;
PPCODE:
	if (IsWindows == 0)
		XSRETURN_UNDEF;

	rc = -1;
	switch (items) {
	case 1:
		rc = myMoveFileEx ((char*) SvPV(ST(0), PL_na), NULL);
		break;
	case 2:
		rc = myMoveFileEx ((char*) SvPV(ST(0), PL_na),
		                   (char*) SvPV(ST(1), PL_na));
		break;
	default:
		XSRETURN_UNDEF;
	}

	if (rc != 0 && getErrMsg (&szErrMsg) == 0) {
		XPUSHs (sv_2mortal (newSViv (rc)));
		XPUSHs (sv_2mortal (newSVpv (szErrMsg, strlen (szErrMsg))));	
		free (szErrMsg);
		XSRETURN (2);
	}

	XSRETURN_IV (rc);

void
SfcIsFileProtected (...)
PREINIT:
	int rc;
	char *filename;
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	filename = (char*) SvPV(ST(0), PL_na);

	rc = mySfcIsFileProtected (filename);
	if (rc < 0)
		XSRETURN_UNDEF;

	XPUSHs (sv_2mortal (newSViv (rc)));

void
GetHDDrives (...)
PREINIT:
	int rc,i;
	char **drives;
PPCODE:
	if (items != 0)
		XSRETURN_UNDEF;

	rc = myGetHDDrives (&drives);
	if (rc < 0)
		XSRETURN_UNDEF;

	for(i = 0;i < rc;i++){
		PUSHs (sv_2mortal (newSVpv (drives[i], strlen (drives[i]))));
		free (drives[i]);
	}
	free(drives);
	XSRETURN (rc);

void
GetComputerName (...)
PREINIT:
	int rc;
	char * szHostName;
PPCODE:
	if (items != 0)
		XSRETURN_UNDEF;

	rc = myGetComputerName (&szHostName);
	if (rc < 0)
		XSRETURN_UNDEF;

	PUSHs (sv_2mortal (newSVpv (szHostName,rc)));
	free(szHostName);
	XSRETURN (1);
