/* 
 * SystemWIN32Console.xs
 * 
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/SystemWin32Console.xs#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 */

static char szWhatHeader[] = 
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/SystemWin32Console.xs#1 $";

#ifndef __cplusplus
#ifndef HAS_BOOL
typedef char bool;
#endif
#endif

#ifdef __hpux
#define DONT_DECLARE_STD
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/*
 * expect compiler warning 4113 when using Microsoft C
 * in c code generated by xs preprocessor
 */
#if _MSC_VER >= 1200
#pragma warning(disable : 4113)
#endif

#ifndef WIN32
#define UNIX UNIX
#endif

#ifdef UNIX
static const int IsWindows = 0;
#endif

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#define ATTACH_PARENT_CONSOLE -1
#include <windows.h>

static const int IsWindows = 1;
#endif

#ifdef WIN32

/************************************
*
*	set CRT std file descriptors 0, 1, 2
*
*************************************/


int setCrtStdHandles(HANDLE hScreenBuffer){
		
	int hCrtOut, hCrtErr, hCrtIn;
	FILE *hfOut, *hfErr, *hfIn;
	PerlIO *pperlio_out,*pperlio_err,*pperlio_in;
	if(hScreenBuffer == NULL){
		hCrtOut = _open_osfhandle(
			(long) GetStdHandle(STD_OUTPUT_HANDLE),
				_O_TEXT
			);
	
		hCrtErr = _open_osfhandle(
			(long) GetStdHandle(STD_ERROR_HANDLE),
				_O_TEXT
			);
	}
	else{
		hCrtOut = _open_osfhandle(
				(long) hScreenBuffer,
				_O_TEXT
			);
	
		hCrtErr =  _open_osfhandle(
				(long) hScreenBuffer,
				_O_TEXT
			);
		/*hCrtIn = _open_osfhandle(
				(long) hScreenInBuffer,
				_O_TEXT
			);*/
	}

	hCrtIn = _open_osfhandle(
		(long) GetStdHandle(STD_INPUT_HANDLE),
			_O_TEXT
		);
		
	
	hfOut = _fdopen( hCrtOut, "w" );
	*stdout = *hfOut;
	setvbuf(hfOut, NULL, _IONBF, 0 );
	pperlio_out = PerlIO_stdout();
	*pperlio_out = *(PerlIO_importFILE(hfOut,"w")); 
		
		
	hfErr = _fdopen( hCrtErr, "w" );
	*stderr = *hfErr;
	setvbuf(hfErr, NULL, _IONBF, 0 );
	pperlio_err = PerlIO_stderr();
	*pperlio_err = *(PerlIO_importFILE(hfErr,"w")); 

	hfIn = _fdopen( hCrtIn, "r" );
	*stdin = *hfIn;
	setvbuf(hfIn, NULL, _IONBF, 0 );
	pperlio_in = PerlIO_stdin();
	*pperlio_in = *(PerlIO_importFILE(hfIn,"r")); 

	return 1;
}

int openNewConsole(void){
	HWND (WINAPI *fGetConsoleWindow) ();
	HANDLE hKERNEL32;	
	
	if(AllocConsole() == 0){
		return (0);
	}
	
	hKERNEL32 = LoadLibrary ("kernel32.dll");
	
	if (hKERNEL32 != 0){
		
		fGetConsoleWindow = (HWND (WINAPI *)())
			GetProcAddress (hKERNEL32, "GetConsoleWindow");

		if (fGetConsoleWindow != 0) {
			SetForegroundWindow((*fGetConsoleWindow)());		
		}
	}	

	if(setCrtStdHandles(NULL) == 0){
		FreeLibrary (hKERNEL32);
		return (0);
	}
	FreeLibrary (hKERNEL32);
	return (1);
}

int openParentConsole(void){
	HANDLE hKERNEL32,hScreenBuffer;
	OSVERSIONINFO os_info[1];	
	BOOL (WINAPI *fAttachConsole) (DWORD);

	GetVersionEx (os_info);
	
	/********************************************************
	*
	*	AttachConsole needs WinXP, Win Server 2003 or greater
	*
	********************************************************/
	
	if( os_info->dwMajorVersion < 5  || 
	    (os_info->dwMajorVersion == 5 && 
		 os_info->dwMinorVersion < 1)){
		return (0);
	}
		
	
	hKERNEL32 = LoadLibrary ("kernel32.dll");
	
	if (hKERNEL32 == 0)
		return (0);
	
	fAttachConsole = (BOOL (WINAPI *)(DWORD))
		GetProcAddress (hKERNEL32, "AttachConsole");

	if (fAttachConsole == 0) {
		FreeLibrary (hKERNEL32);
		return (0);
	}			
			
	
	if((*fAttachConsole)(ATTACH_PARENT_CONSOLE) == 0){
		FreeLibrary (hKERNEL32);
		return (0);
	}
	
	FreeLibrary (hKERNEL32);

	
	hScreenBuffer = CreateConsoleScreenBuffer(
		GENERIC_WRITE,
		0,
		NULL,
		CONSOLE_TEXTMODE_BUFFER,
		NULL

	);
	
	if(hScreenBuffer == INVALID_HANDLE_VALUE){
		return (0);
	}

	if(SetConsoleActiveScreenBuffer(hScreenBuffer) == 0){
		return (0); 
	} 

		
	if(setCrtStdHandles(hScreenBuffer) == 0){
		return (0);
	}

	return (1);
}


int openConsole(void){
	/*if(openParentConsole() == 0){
		return openNewConsole();
	}
	return (1);*/
	
	return openNewConsole();
}

int hasRedirectedStdHandles(void){
	HANDLE hStdOut,hStdIn;
	
	hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	hStdIn = GetStdHandle(STD_INPUT_HANDLE);
	
	if( (((long)hStdOut % 4) == 0) || ((((long)hStdIn % 4) == 0) && (long)hStdIn != 0)){
		return (1);
	}
	return (0);
}

int SetErrorMsg(char * szmsg,char * sztitle){
  int rc = MessageBox(
				NULL, 
				szmsg, 
				sztitle, 
				MB_OK | MB_ICONERROR);
  return rc;
}


#else

int openConsole(void){
	return 0;
}

int hasRedirectedStdHandles(void){
	return 0;
}

int SetErrorMsg(char * szmsg,char * sztitle){
	return 0;
}

int openParentConsole(void){
	return 0;
}

#endif




MODULE = SAPDB::Install::System::Win32::Console	PACKAGE = SAPDB::Install::System::Win32::Console

PROTOTYPES: DISABLE

void
OpenConsole (...)
PREINIT:
	int rc;
PPCODE:
	rc = openConsole();
	
	XSRETURN_IV (rc);


void
HasRedirectedStdHandles (...)
PREINIT:
	int rc;
PPCODE:
	rc = hasRedirectedStdHandles();
	
	XSRETURN_IV (rc);

void
AttachParentConsole (...)
PREINIT:
	int rc;
PPCODE:
	rc = openParentConsole();
	
	XSRETURN_IV (rc);

void
SetErrorWithoutConsole (...)
PREINIT:
	int rc;
	char * sztitle;
PPCODE:
	sztitle = "Error";

	if (items != 1 && items != 2) 
		XSRETURN_UNDEF;
	
	if(items == 2){
		sztitle = (char*) SvPV(ST(1), PL_na);
	}
	

	rc = SetErrorMsg((char*) SvPV(ST(0), PL_na),sztitle);
	
	XSRETURN_IV (rc);

