#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/Untgz.pl#1 $
# $DateTime: 2005/03/21 16:21:00 $
# $Change: 93297 $
#

package SAPDB::Install::Untgz;

sub ExtractEval {
	my $self = shift;

	# prevent eval form print to STDERR and die ('__WARN__')
	local $SIG{'__WARN__'} = sub {};

	my ($rc, $evalbuff);
	$rc = $self->ExtractScalar ($evalbuff);
	unless ($rc == 0) {
		$self->ErrAdd ("cannot eval extracted data");
		return (undef)
	}

	eval ($evalbuff);
	if ($@) {
		$self->ErrAdd ($@);
		$self->ErrAdd ("cannot eval extracted data");
		return (undef);
	}

	return (0);
}

#
# returns a summary of filesystem usage of involved filesystem
# this summary will be created during test run of extraction of 
# an archive
#
# returns an array of references to hashes,
# each hash contains information for a filesystem
#
# in a hash you will find the following key value pairs
#     FSNAME => mountpoint or drive name
#     TOTAL  => size of filesystem in kbytes
#     AVAIL  => user available free size of filesystem in kbytes
#     USED   => size of filesytems that will be replaced by installation
#     NEEDED => size of filesystem that will by totaly used by installation
#
sub GetFSUsage {
	my $self = shift;
	my @fsusage = ();

	my $count = $self->FetchFSUsage ();
	for (my $i = 0; $i < $count; $i++) {
		my %item = $self->FetchFSUsage ($i);
		push @fsusage, \%item;	
	}
	return @fsusage;
}


sub ExtractBuildInfo {
	my ($self) = @_;

	return (SAPDB::Install::BuildInfo::GetBuildInfo ($self));
}

sub ExtractMagic {
	my ($self) = @_;

	my $buildinfo = SAPDB::Install::BuildInfo::GetBuildInfo ($self);	
	
	return ($buildinfo->{'magic'});
}

sub ExtractSysVersionInfo {
	my ($self) = @_;

	return '' unless ($^O =~ /mswin/i);
	return (SAPDB::Install::System::Win32::VersionInfo::SysVersionInfo ($self));
}
