/*
 * Untgz.xs
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/Untgz.xs#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 */

static char szWhatHeader[] = 
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/Untgz.xs#1 $";

#ifndef __cplusplus
#ifndef HAS_BOOL
typedef char bool;
#endif
#endif

#ifndef WIN32
#define UNIX UNIX
#endif

#ifdef UNIX
#include <stdio.h>
static int
myfwrite (void *ptr, int size, int nmemb, void *fp) {
	return (fwrite (ptr, size, nmemb, (FILE *) fp));
}
#endif

#ifdef WIN32
#define myfwrite(a,b,c,d) fwrite (a, b, c, d)
#endif

#if _MSC_VER >= 1200
/*
 * expect compiler warning 4113 when using Microsoft C
 * in c code generated by xs preprocessor
 */
#pragma warning(disable : 4113)
#pragma warning(disable : 4101)
#endif



#ifdef UNIX
#include <errno.h>
#include <fcntl.h>
#include <grp.h>
#include <pwd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <utime.h>
#include <unistd.h>
#endif

#ifdef WIN32
#include <malloc.h>
#include <string.h>
#include <sys/utime.h>
#endif

#include "zlib.h"

#ifdef WIN32
typedef struct _utimbuf utimbuf_t;
#define sys_utime _utime
#endif
#ifdef UNIX
typedef struct utimbuf utimbuf_t;
#define sys_utime utime
#endif

#ifdef _WIN64
typedef __int64 ptr_t;
#else
typedef long ptr_t;
#endif

#ifdef __hpux
#define DONT_DECLARE_STD
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef PERL_OBJECT
#define FILE struct _PerlIO
#endif

#if defined WIN32
#define NEED_TYPEDEF_INT64_T NEED_TYPEDEF_INT64_T
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#define NEED_TYPEDEF_UNIT16_T NEED_TYPEDEF_UNIT16_T
#define NEED_TYPEDEF_UNIT32_T NEED_TYPEDEF_UNIT32_T
#define NEED_TYPEDEF_UNIT64_T NEED_TYPEDEF_UNIT64_T
#elif defined linux
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __hpux  && defined __hppa
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __hpux && defined __ia64 && ! defined HAS_STRTOLL
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#elif defined __osf__
#define NEED_TYPEDEF_UNIT16_T NEED_TYPEDEF_UNIT16_T
#define NEED_TYPEDEF_UNIT32_T NEED_TYPEDEF_UNIT32_T
#define NEED_TYPEDEF_UNIT64_T NEED_TYPEDEF_UNIT64_T
#define NEED_SNPRINTF NEED_SNPRINTF
#define HAS_SPRINTF_INTRINSIC HAS_SPRINTF_INTRINSIC
#endif
 
#ifdef NEED_TYPEDEF_UCHAR_T
typedef unsigned char  uchar_t;
#endif
#ifdef NEED_TYPEDEF_UNIT16_T
typedef unsigned short uint16_t;
#endif
#ifdef NEED_TYPEDEF_UNIT32_T
typedef unsigned int   uint32_t;
#endif
#ifdef NEED_TYPEDEF_UNIT64_T
typedef unsigned long  uint64_t;
#endif

#ifdef NEED_TYPEDEF_INT64_T
#ifdef WIN32
typedef __int64 int64_t;
#endif
#ifdef UNIX
#ifdef _LP64
typedef long int64_t;
#else
typedef long long int64_t;
#endif
#endif
#endif

/*
 * alloca specific defines
 */
#ifdef _AIX
#define NEED_PRAGMA_ALLOCA NEED_PRAGMA_ALLOCA
#endif
#if defined UNIX && !defined _AIX && !defined SNI
#define NEED_ALLOCA_H NEED_ALLOCA_H
#endif

#ifdef NEED_ALLOCA_H
#include <alloca.h>
#endif

#ifdef NEED_PRAGMA_ALLOCA
#pragma alloca
#endif

/*
 * stat specific defines
 */
#define HAS_STAT_ST_SIZE HAS_STAT_ST_SIZE

#ifdef WIN32
#ifndef alloca
#define alloca(size) _alloca(size)
#endif
#ifndef snprintf
#define snprintf _snprintf
#endif
#ifndef chown
#define chown(file,uid,gid)
#endif
#ifndef INVALID_SET_FILE_POINTER
#define INVALID_SET_FILE_POINTER ((DWORD) -1)
#endif
#endif

/*
 * expect compiler warning 4113 when using Microsoft C
 * in c code generated by xs preprocessor
 */
#if _MSC_VER >= 1200
#pragma warning(disable : 4113)
#endif

/* 
 * tar typeflag types
 */
#define TAR_AREGTYPE '\0'
#define TAR_REGTYPE  '0'
#define TAR_LNKTYPE  '1'
#define TAR_SYMTYPE  '2'
#define TAR_CHRTYPE  '3'
#define TAR_BLKTYPE  '4'
#define TAR_DIRTYPE  '5'
#define TAR_FIFOTYPE '6'

/*
 * gnu tar typeflags
 */
#define TAR_GNUTYPE      'A'
#define TAR_LONGNAMETYPE 'L'

/*
 * tar magic
 */
static char TAR_MAGIC[5] = {'u', 's', 't', 'a', 'r'};

/*
 * this is known as the tar header
 */
typedef struct {
	char name[100];
	char mode[8];
	char uid[8];
	char gid[8];
	char size[12];
	char mtime[12];
	char chksum[8];
	char typeflag[1];	
	char linkname[100];
	char magic[6];
	char version[2];
	char uname[32];
	char gname[32];
	char devmajor[8];
	char devminor[8];
	char prefix[155];
} tar_hdr_t;

/*
 * error list element
 */
typedef struct err {
	struct err *next;
	char *text;
} err_t;

/*
 * filesystem usage structure
 */
typedef struct fsusage {
	struct fsusage *next;
	dev_t devid;
	char *fsname;
	int64_t total;
	int64_t avail;
	int64_t used;
	int64_t needed;
} fsusage_t;

/*
 * session structure
 */
typedef struct tar_obj {
	gzFile fp_tgz;
	tar_hdr_t hdr[1];
	char *dirname;
	FILE *fp;
	int size;
	char *name;
	char *longname;
	char *archname;
	err_t *err;
	int ro_mode;
	fsusage_t *fsusage;
	int inuse;
	uid_t uid;
	gid_t gid;
} tar_obj_t;

/*
 * a lot of prototypes
 */
static int tar (gzFile, tar_obj_t*);
static int obj_init (tar_obj_t *);
static int obj_sethdr (tar_obj_t *, tar_hdr_t *);
static int obj_clearhdr (tar_obj_t *);
static int obj_begin (tar_obj_t *);
static int obj_final (tar_obj_t *);
static int obj_block (tar_obj_t *, char *, int);
static int obj_free (tar_obj_t *);
static int obj_adderr (tar_obj_t *, char *);
static int obj_freeerr (tar_obj_t *);
static char *obj_geterr (tar_obj_t *, void **);
static int mkdir_recursiv (tar_obj_t *, char *, int);
static FILE *fopen_recursiv (tar_obj_t *, char *, int, int, int *);
static int strnocttoi (char *, int);
static int sprintf_hdrmode (char *, tar_hdr_t *);
static int sprintf_hdrmtime (char *, tar_hdr_t *);
static int sprintf_hdrstat (char *, tar_hdr_t *, char *);
static char *getstrerror (int);
static int getfsname (char*, char **);
static int getfssize (char *, int64_t *, int64_t *);

/*
 * this BLOCKSIZE read from an file must be 512 bytes
 * because the tar header and gzip are using 512 byte
 * blocks
 */
#define BLOCKSIZE 512

static int
can_update (tar_obj_t *obj, char *name) {
#ifdef UNIX
	FILE *fp;

	fp = fopen (name, "r+b");
	if (fp == 0) {
		char msg[] = "cannot write to ";
		char *out;

		obj_adderr (obj, getstrerror (errno));

		out = (char *) alloca (strlen (msg) + strlen (name) + 1);
		strcpy (out, msg);
		strcat (out, obj->name);
		obj_adderr (obj, out);
		return 0;
	}

	fclose (fp);
	return 1;
#endif
#ifdef WIN32
	HANDLE hFile;
	DWORD size_low, size_high;
	DWORD got;
	char tmp[2];

	hFile =
	CreateFile (name, GENERIC_READ | GENERIC_WRITE, 0, 0,
	OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

	if (hFile == INVALID_HANDLE_VALUE) {
		if (GetLastError () == ERROR_SHARING_VIOLATION) {
			obj_adderr (obj, "sharing violation during open of existing file");
		} else {
			obj_adderr (obj, "could not open existing file");
		}
		return 0;
	}

	size_low = size_high = 0;
	size_low = GetFileSize (hFile, &size_high);

	if (size_low == INVALID_FILE_SIZE) {
		obj_adderr (obj, "could not get file size");
		CloseHandle (hFile);
		return 0;
	}

	if (size_high == 0 && size_low == 0) {
		CloseHandle (hFile);
		return 1;
	}

	if ((SetFilePointer (hFile, size_low - 1, &size_high, FILE_BEGIN) ==
	INVALID_SET_FILE_POINTER) && (GetLastError () != NO_ERROR)) {
		obj_adderr (obj, "could not seek to eof for read");
		CloseHandle (hFile);
		return 0;
	}

	if (ReadFile (hFile, &tmp[0], 1, &got, 0) == 0 || got != 1) {
		obj_adderr (obj, "could not read at eof");
		CloseHandle (hFile);
		return 0;
	}

	if ((SetFilePointer (hFile, size_low - 1, &size_high, FILE_BEGIN) ==
	INVALID_SET_FILE_POINTER) && (GetLastError () != NO_ERROR)) {
		obj_adderr (obj, "could not seek to eof for trunc");
		CloseHandle (hFile);
		return 0;
	}

	if (SetEndOfFile (hFile) == 0) {
		if (GetLastError () == ERROR_USER_MAPPED_FILE) {
			obj_adderr (obj, "file mapped by user application");
		} else {
			obj_adderr (obj, "could not truncate");
		}
		CloseHandle (hFile);
		return 0;
	}

	if (WriteFile (hFile, &tmp[0], 1, &got, 0) == 0 || got != 1) {
		obj_adderr (obj, "could not write at eof");
		CloseHandle (hFile);
		return 0;
	}

	CloseHandle (hFile);
	return 1;
#endif
}

/*
 * these functions are working with a fsusage_t structure
 */
static int
free_fsusage (tar_obj_t *obj) {
	fsusage_t *curr, *next;	

	curr = obj->fsusage;
	while (curr != 0) {
		next = curr->next;
		if (curr->fsname != 0) {
			free (curr->fsname);
		}
		free (curr);
		curr = next;
	}
	return 0;
}

static int
add_fsusage (tar_obj_t *obj, Stat_t *stat_buff) {
	fsusage_t *curr;
	int64_t needed;
	int64_t used;
	dev_t devid;

	int rc;

	needed = obj->size;

#ifdef HAS_STAT_ST_BLKSIZE
	blksize = stat_buff->st_blksize;
	if (needed % blksize == 0) {
		needed = needed / 1024;
	} else {
		needed = ((needed / blksize) + 1) * (blksize / 1024);
	}
	used = stat_buff->st_blocks * (blksize / 1024);
#endif
#ifdef HAS_STAT_ST_SIZE
	if (needed % 1024 == 0) {
		needed = needed / 1024;
	} else {
		needed = (needed / 1024) + 1;
	}

	if (stat_buff->st_size % 1024 == 0) {
		used = (stat_buff->st_size / 1024);
	} else {
		used = (stat_buff->st_size / 1024) + 1;
	}
#endif
	devid = stat_buff->st_dev;

	if (obj->fsusage != 0) {
		/* 
		 * find devid in existing fsusage list
		 */
		curr = obj->fsusage;
		for (;;) {
			if (curr->devid == devid) {
				/*
				 * add data for known devid
				 */
				curr->used += used;
				curr->needed += needed;
				return 0;
			}

			if (curr->next == 0) break;
			curr = curr->next;
		}
	}

	/*
	 * create new list element for new devid
	 */
	if (obj->fsusage == 0) {
		obj->fsusage = (fsusage_t *) malloc (sizeof (fsusage_t));
		curr = obj->fsusage;
	} else {
		curr->next = (fsusage_t *) malloc (sizeof (fsusage_t));
		curr = curr->next;
	}

	if (curr == 0) {
		/*
		 * malloc fail
		 */
		return -1;
	}

	/*
	 * get filesystem information
	 */
	rc = getfssize (obj->name, &curr->total, &curr->avail);
	rc = getfsname (obj->name, &curr->fsname);

	curr->next = 0;
	curr->devid = devid;
	curr->used = used;
	curr->needed = needed;
	return 0;
}

/*
 * these function are using code implemented in SAPDB::Install::GetFSUsage
 * keep in mind that this module has to be initialized before using
 * dry run of extraction to avoid exeptions caused be unknown symbols
 */
static int
getfssize (char *filename, int64_t *p_total, int64_t *p_avail) {
	int rc;
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	*p_total = 0;
	*p_avail = 0;

	XPUSHs (sv_2mortal (newSVpv (filename, strlen (filename))));
	PUTBACK;

	rc = perl_call_pv (
		"SAPDB::Install::FSUsage::GetFSSize",
		G_ARRAY);

	SPAGAIN;

	if (rc == 2) {
		*p_avail = POPi;
		*p_total = POPi;
	}

	PUTBACK;
	FREETMPS;
	LEAVE;
	
	if (rc == 2) {
		return 0;	
	} else {
		return -1;
	}
}

static int
getfsname (char *filename, char **p_fsname) {
	int rc;
	char *p_text;

	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	XPUSHs (sv_2mortal (newSVpv (filename, strlen (filename))));
	PUTBACK;

	rc = perl_call_pv (
		"SAPDB::Install::FSUsage::GetFSName",
		G_ARRAY);

	SPAGAIN;

	if (rc == 1) {
		p_text = POPp;
		*p_fsname = (char *) malloc (strlen (p_text) + 1);
		strcpy (*p_fsname, p_text); 
	} else {
		*p_fsname = 0;
	}

	PUTBACK;
	FREETMPS;
	LEAVE;

	if (rc == 1) {
		return 0;
	} else {
		return -1;
	}
}

/*
 * these funtions are working with an error message list
 *
 * every perl XS must free this list by calling obj_freeerr ()
 * before calling other functions of this module
 * 
 * every funtion can add one or more error messages
 * to this list by calling obj_adderr ()
 *
 * this list can be read by the perl XS geterr () 
 */
static int
obj_freeerr (tar_obj_t *obj) {
	err_t *ptr;
	
	if (obj->err == 0)
		return 0;

	ptr = obj->err;
	do {
		err_t *next;
		next = ptr->next;

		free (ptr->text);
		free (ptr);
		ptr = next;
	} while (ptr != 0);

	obj->err = 0;
	return 0;
} 

static int
obj_adderr (tar_obj_t *obj, char *sz_err) {
	err_t *ptr;

	ptr = (err_t *) malloc (sizeof (err_t));
	ptr->next = obj->err;
	ptr->text = (char *) malloc (strlen (sz_err) + 1);
	strcpy (ptr->text, sz_err);
	obj->err = ptr;
	return 0;
}

static char *
obj_geterr (tar_obj_t *obj, void **ptr) {
	err_t *err;

	/* 
	 * if (*ptr == 0) start from beginning
	 */
	err = *ptr == 0 ? obj->err : * (err_t **) ptr;
	if (err == 0) {
		/* no error list */
		*ptr = 0;
		return 0;
	}

	*(err_t **) ptr = err->next;
	return (err->text);
}

/*
 * these obj_...() functions are handling any action on
 * opened tar archives, every open archive is using a
 * session structure called an 'obj'
 */

/*
 * initialize a new session structure
 */
static int
obj_init (tar_obj_t *obj) {
	memset (obj, 0, sizeof (tar_obj_t));
	return 0;
}

/*
 * free an used session structure
 */
static int
obj_free (tar_obj_t *obj) {
	if (obj == 0)
		return 0;

	if (obj->err != 0)
		obj_freeerr (obj);	

	if (obj->fsusage != 0)
		free_fsusage (obj);

	if (obj->archname != 0)
		free (obj->archname);

	if (obj->name != 0)
		free (obj->name);

	if (obj->longname != 0)
		free (obj->longname);

	if (obj->dirname != 0)
		free (obj->dirname);

	if (obj->fp_tgz != 0)
		gzclose (obj->fp_tgz);

	free (obj);	

	return 0;
}

/*
 * save tar header of present file form archive to session structure
 */
static int
obj_sethdr (tar_obj_t *obj, tar_hdr_t *hdr) {
	memcpy (obj->hdr, hdr, sizeof (tar_hdr_t));
	return 0;
}

static int
obj_clearhdr (tar_obj_t *obj) {
	memset (obj->hdr, 0, sizeof (tar_hdr_t));
	return 0;
}

/*
 * handle first action when finding next file in archive
 */
static int
obj_begin (tar_obj_t *obj) {
	int dirmode;
	int err;
	int rc;
	char *name;

	name = (obj->longname != 0) ? obj->longname : obj->hdr->name;

	if (obj->dirname != 0) {
		obj->name = (char *) malloc 
		(strlen (name) + strlen (obj->dirname) + 2);

		if (obj->name == 0) {
			obj_adderr (obj, "out of memory");
			return -1;
		}

		strcpy (obj->name, obj->dirname);
		strcat (obj->name, "/");
		strcat (obj->name, name);
	} else {
		obj->name = (char *) malloc (strlen (name) + 1);
		if (obj->name == 0) {
			obj_adderr (obj, "out of memory");
			return -1;
		}

		strcpy (obj->name, name);
	}

	switch (*obj->hdr->typeflag) {
	case TAR_AREGTYPE:
	case TAR_REGTYPE:
		dirmode = strnocttoi (obj->hdr->mode, sizeof (obj->hdr->mode));
		dirmode &= 0777;
		if (dirmode & 0600) dirmode |= 0100;
		if (dirmode &  060) dirmode |=  010;
		if (dirmode &   06) dirmode |=   01;
		obj->fp = 
		fopen_recursiv (obj, obj->name, obj->ro_mode, dirmode, &err);
		if (err != 0) {
			char msg[] = "cannot extract ";
			char *out;
			
			out =
			(char *) alloca (strlen (msg) + strlen (obj->name) + 1);

			strcpy (out, msg);
			strcat (out, obj->hdr->name);
			obj_adderr (obj, out);
			return -1;
		}
		break;
	case TAR_DIRTYPE:
		dirmode = strnocttoi (obj->hdr->mode, sizeof (obj->hdr->mode));
		rc = mkdir_recursiv (obj, obj->name, dirmode);
		if (rc < 0) {
			char msg[] = "cannot make directory ";
			char *out;

			out = (char *) alloca (strlen (msg) + strlen (obj->name) + 1);

			strcpy (out, msg);
			strcat (out, obj->name);
			obj_adderr (obj, out);
			return -1;
		}

#ifdef UNIX
		/* set permissions only if we are not in read only mode */
		if (obj->ro_mode == 0) {
			rc = chmod (obj->name, dirmode);
			if (rc != 0) {
				char msg[] = "cannot change permissions of directory ";
				char *out;

				out = (char *) alloca (strlen (msg) + strlen (obj->name) + 1);
				strcpy (out, msg);
				strcat (out, obj->name);
				obj_adderr (obj, out);
				return -1;
			}
		}
#endif

		break;
	}
	return 0;
}

/*
 * handle last action before going to next file entry of archive
 */
static int
obj_final (tar_obj_t* obj) {
	utimbuf_t buff[1];
	int mode;

	switch (*obj->hdr->typeflag) {
	case TAR_AREGTYPE:
	case TAR_REGTYPE:
		if (obj->ro_mode == 0) {
			fclose (obj->fp);
			obj->fp = 0;
			buff->modtime = buff->actime = 
			strnocttoi (obj->hdr->mtime, sizeof (obj->hdr->mtime));
			sys_utime (obj->name, buff);
			chown (obj->name, obj->uid, obj->gid);

			mode = 
			strnocttoi (obj->hdr->mode, sizeof (obj->hdr->mode));
			mode &= 06777;
			chmod (obj->name, mode);
		}
		break;
	default:
		if (obj->ro_mode == 0)
			chown (obj->name, obj->uid, obj->gid);
		break;
	}


	if (obj->longname != 0) {
		free (obj->longname);
		obj->longname = 0;
	}

	if (obj->name != 0) {
		free (obj->name);
		obj->name = 0;
	}

	return 0;
}


/*
 * handle action when reading data between two headers from archive 
 */
static int
obj_block (tar_obj_t *obj, char *ptr, int len) {
	int rc;

	if (obj->ro_mode != 0)
		return 0;

	rc = myfwrite (ptr, 1, len, obj->fp);
	if (rc < 0) {
		char msg[] = "cannot write ";
		char *out;
	
		obj_adderr (obj, getstrerror (errno));
		
		out = (char *) alloca (strlen (msg) + strlen (obj->name) + 1);
		strcpy (out, msg);
		strcat (out, obj->name);
		obj_adderr (obj, out);
	}

	return (rc);
}

/*
 * helper functions used by tar extractor
 */

/*
 * helper funtion for creating directories
 */
static int
create_subdir (tar_obj_t *obj, char *name, int mode) {
	Stat_t statbuf;

	if (strlen (name) <= 0)
		return 0;
	
	/* see if directory already exists */
	if (stat (name, &statbuf) == 0) {
		if (statbuf.st_mode & S_IFDIR) {
			return 0;
		}
	}
		
	/* create it */
	if (mkdir (name, mode) != 0) {
		char msg[] = "cannot create subdirectory ";
		char *out;
		
		obj_adderr (obj, getstrerror (errno));
	
		out = (char *) alloca (strlen (msg) + strlen (name) + 1);
		strcpy (out, msg);
		strcat (out, name);
		obj_adderr (obj, out);
		return -1;
	}

	return 0;
}

static int
mkdir_recursiv (tar_obj_t *obj, char *name, int mode) {
	char *buff;
	char *ptr;
	char save;
	int len;

	len = strlen (name);
	if (len <= 0)
		return -1;

	buff = (char *) alloca (len + 1);
	strcpy (buff, name);

	/* create working buffer and remove trailing slashes */
	for (;;) {
		len = strlen (buff);
#ifdef UNIX
		/*
		 * we do not need to create root directory
		 */
		if (len == 1 && *buff == '/')
			return 0;
#endif
		if (len <= 0)
			return -1;

		switch (buff[len - 1]) {
		case '/':
		case '\\':
			buff[len - 1] = '\0';
			continue;
		}
		break;
	}
	
	/* try to create any subdirectory */
	for (ptr = buff;; ptr++) {
		if (*ptr != '/' && *ptr != '\\' && *ptr != '\0')
			continue;

		save = *ptr;
		*ptr = 0;
		if (create_subdir (obj, buff, mode))
			return (-1);

		*ptr = save;

		if (save == '\0')
			return 0;
	}
	return 0;
}

/*
 * helper funtion for creating regular files
 */
static FILE *
fopen_recursiv (
tar_obj_t *obj, char *name, int ro_mode, int dirmode, int *err) {
	char *buff;
	char *ptr;
	FILE *fp;
	Stat_t stat_buff[1];
	utimbuf_t utime_buff[1];

	buff = (char *) alloca (strlen (name) + 1);
	strcpy (buff, name);

	ptr = strrchr (buff, '/');
	if (ptr == 0)
		ptr = strrchr (name, '\\');

	if (ptr != 0) {
		*ptr = '\0';
		if (mkdir_recursiv (obj, buff, dirmode) != 0) {
			*err = -1;
			return 0;
		}
	}

	if (ro_mode == 0) {
	
		if (Stat(name,stat_buff) == 0)
			unlink(name);
	
		/* real open for write */
		fp = fopen (name, "wb");


		if (fp == 0) {
			char msg0[] = "cannot open ";
			char msg1[] = " for writing";
			char *out;
		
			obj_adderr (obj, getstrerror (errno));
	
			out = (char *) alloca ( strlen (msg0) + 
			strlen (name) + strlen (msg1) + 1);

			strcpy (out, msg0);
			strcat (out, obj->name);
			strcat (out, msg1);
			obj_adderr (obj, out);
			*err = -1;
		} else {
			*err = 0;
		}

		return (fp);
	}


	/* only check */
	if (stat (name, stat_buff) == 0) {
		/* file exists */
		add_fsusage (obj, stat_buff);

		if (can_update (obj, name) == 0) {
			*err = -1;
			return 0;
		}

		chown (name, stat_buff->st_uid, stat_buff->st_gid);
		chmod (name, stat_buff->st_mode);
		utime_buff->modtime = stat_buff->st_mtime;
		utime_buff->actime = stat_buff->st_atime;
		sys_utime (name, utime_buff);
		*err = 0;
		return 0;
	}

	fp = fopen (name, "w+b");
	if (fp == 0) {
		/* cannot create file */
		char msg[] = "cannot create ";
		char *out;
		
		obj_adderr (obj, getstrerror (errno));

		out = (char *) alloca (strlen (msg) + strlen (name) + 1);
		strcpy (out, msg);
		strcat (out, obj->name);
		obj_adderr (obj, out);
		*err = -1;
		return 0;
	}

	fstat (fileno (fp), stat_buff);
	add_fsusage (obj, stat_buff);
	
	fclose (fp);
	unlink (name);
	*err = 0;
	return 0;
}

/*
 * helper funtion for converting octal numbers
 * from tar header to integer numbers
 */
static int
strnocttoi (char *ptr, int count) {
	int val;
	char c;
  
	for (val = 0; count > 0; count--) {
		c = *ptr++;
		if (c == ' ')
			continue;

		if (c == '\0')
			break;

		val = (val << 3)  + (c - '0');
	}
  	return val;
}

/*
 * helper funtions for makeing tar header human readable
 */

static int
get_hdrmode (tar_hdr_t *hdr) {
	int mode;
	mode = strnocttoi (hdr->mode, sizeof (hdr->mode));
	
	return (mode);
}

static time_t
get_hdrtime (tar_hdr_t *hdr) {
	time_t mtime;
	mtime = strnocttoi (hdr->mtime, sizeof (hdr->mtime));

	return (mtime);
}

static int
get_hdrsize (tar_hdr_t *hdr) {
	int size;

	size = strnocttoi (hdr->size, sizeof (hdr->size));

	return (size);
}

static int
sprintf_hdrmode (char *ptr, tar_hdr_t *hdr) {
	int mode;
	int type;
	int mask;
	const char *all = "-rwxrwxrwx";

	mode = strnocttoi (hdr->mode, sizeof (hdr->mode));
	type =  hdr->typeflag[0];

	strcpy (ptr, all);	

	mode &= 07777;
	switch (type) {
	case TAR_SYMTYPE:
		*ptr = 'l';
		break;
	case TAR_CHRTYPE:
		*ptr = 'c';
		break;
	case TAR_BLKTYPE:
		*ptr = 'b';
		break;
	case TAR_DIRTYPE: 
		*ptr = 'd';
		break;
	}
	ptr++;

	for (mask = 0400; mask != 0; mask >>= 1) {
		if (!(mode & mask)) {
			*ptr = '-';
		}
		if ((mask == 0100) && (mode & 04000) ||
		    (mask ==  010) && (mode & 02000)) {
			*ptr = 's';
		}
		ptr++;
	}
	*ptr = '\0';

	return 0;
}

static int
sprintf_hdrmtime (char *ptr, tar_hdr_t *hdr) {
	time_t mtime;
	struct tm *p_tm;

	mtime = get_hdrtime (hdr);
	p_tm = localtime (&mtime);
	sprintf (ptr, "%4d-%02d-%02d %02d:%02d:%02d",
	p_tm->tm_year + 1900, p_tm->tm_mon + 1, p_tm->tm_mday,
	p_tm->tm_hour, p_tm->tm_min, p_tm->tm_sec);

	return 0;
}

static int
sprintf_hdrsize (char *ptr, tar_hdr_t *hdr) {

	sprintf (ptr, "%12d", get_hdrsize (hdr));

	return 0;
}

static int
sprintf_hdrname (char *text, tar_hdr_t *hdr) {
	char *ptr;
	sprintf (text, "%s", hdr->name);
	
	/* remove trailing spaces */
	ptr = text + strlen (text);
	while (ptr > text && *ptr == ' ') {
		ptr--;
	}
	ptr++;
	*ptr = '\0';

	return 0;
}

static int
sprintf_hdrstat (char *ptr, tar_hdr_t *hdr, char *longname) {
	sprintf_hdrmode (ptr, hdr);
	strcat (ptr, " ");
	sprintf_hdrsize (ptr + strlen (ptr), hdr);
	strcat (ptr, " ");
	sprintf_hdrmtime (ptr + strlen (ptr), hdr);
	strcat (ptr, " ");
	if (longname == 0)
		sprintf_hdrname (ptr + strlen (ptr), hdr);
	else
		strcat (ptr + strlen (ptr), longname);
	return 0;
}

/*
 * implementation of tgz/tar extractor
 */

/*
 * open tgz archive
 */
static int
tar_open (tar_obj_t *obj, char *filename, int ro_mode) {
	char *myfilename;
	int rc;
	Stat_t statbuf;

	obj_freeerr (obj);

	if (obj->fp_tgz != 0) {
		char msg0[] = "cannot open ";
		char msg1[] = " handle already used";
		char *out;
		
		out = (char *)
		alloca (strlen (msg0) + strlen (filename) + strlen (msg1) + 1);
		strcpy (out, msg0);
		strcat (out, filename);
		strcat (out, msg1);
		obj_adderr (obj, out);
		return -1;
	}

	myfilename = (char *) alloca (strlen (filename) + 1);
	strcpy (myfilename, filename);	
	rc = stat (myfilename, &statbuf);

#ifdef UNIX
	/* try all upper case, perhaps plain ISO 9660 on HPUX-CDFS */
	if (rc != 0 && errno == ENOENT) {
		int i;
		for (i = 0; i < strlen (filename); i++) {
			if (filename[i] >= 'a' && filename[i] <= 'z')
				myfilename[i] = filename[i] - ('a' - 'A');
		}
		myfilename[i] = '\0';
	}
	rc = stat (myfilename, &statbuf);

	/* try all lower case, perhaps solaris volume mounter used */
	if (rc != 0 && errno == ENOENT) {
		int i;
		for (i = 0; i < strlen (filename); i++) {
			if (filename[i] >= 'A' && filename[i] <= 'Z')
				myfilename[i] = filename[i] + ('a' - 'A');
		}
		myfilename[i] = '\0';
	}
	rc = stat (myfilename, &statbuf);
#endif

	if (rc != 0) {
		char msg0[] = "cannot open ";
		char *out;

		obj_adderr (obj, getstrerror (errno));

		out = (char *)
		alloca (strlen (msg0) + strlen (filename) + 1);
		strcpy (out, msg0);
		strcat (out, filename);
		obj_adderr (obj, out);
		return -1;
	}

	obj->fp_tgz = gzopen (myfilename, "rb");
	if (obj->fp_tgz == 0) {
		char msg0[] = "cannot open archive ";
		char *out;
		
		obj_adderr (obj, getstrerror (errno));
	
		out = (char *)
		alloca (strlen (msg0) + strlen (myfilename) + 1);
		strcpy (out, msg0);
		strcat (out, filename);
		obj_adderr (obj, out);
		return -1;
	}

	obj->archname = (char *) malloc (strlen (myfilename) + 1);
	strcpy (obj->archname, myfilename);

	obj->ro_mode = ro_mode;
	obj->inuse = 0;

	return 0;
}

static int
tar_setreadonly (tar_obj_t *obj, int ro_mode) {

	if (obj == 0)
		return -1;

	if (obj->fp_tgz == 0)
		return -1;

	obj->ro_mode = ro_mode;

	return 0;
}

static int
tar_rewind (tar_obj_t *obj) {
	int rc;

	if (obj == 0)
		return -1;

	obj_freeerr (obj);

	if (obj->fp_tgz == 0)
		return -1;

	if (obj->inuse == 0)
		return 0;

	rc = gzrewind (obj->fp_tgz);

	if (rc < 0) {
		int errcode;
		char *errmsg;
		char *out;
		char msg0[] = "cannot rewind archive ";			

		errmsg = (char *) gzerror (obj->fp_tgz, &errcode);
		if (errcode == Z_ERRNO)
			errmsg = getstrerror (errno);
		
		obj_adderr (obj, errmsg);
	
		out = (char *) alloca
		(strlen (msg0) + strlen (obj->archname) + 1);
		strcpy (out , msg0);
		strcat (out , obj->archname);
		obj_adderr (obj, out);

		gzclose (obj->fp_tgz);
		obj->fp_tgz = 0;

		return -1;	
	}

	obj->inuse = 0;

	if (obj->longname != 0) {
		free (obj->longname);
		obj->longname = 0;
	}

	if (obj->name != 0) {
		free (obj->name);
		obj->name = 0;
	}

	if (obj->fp != 0) {
		fclose (obj->fp);
		obj->fp = 0;
	}
	
	if (obj->fsusage != 0) {
		free_fsusage (obj);
		obj->fsusage = 0;
	} 

	obj->size = 0;

	memset (&obj->hdr[0], 0, sizeof (tar_hdr_t));

	return 0;
}

/*
 * close archive and free session structure
 */
static int
tar_close (tar_obj_t *obj) {
	if (obj->fp_tgz != 0) {
		gzclose (obj->fp_tgz);
		obj->fp_tgz = 0;
	}

	obj_free (obj);
	return 0;
}

/*
 * set destination directory for tar extractor
 */
static int
tar_setdir (tar_obj_t *obj, char *dirname) {
	if (obj == 0) {
		return -1;
	}

	obj_freeerr (obj);

	if (obj->dirname != 0) {
		free (obj->dirname);
		obj->dirname = 0;
	}

	obj->dirname = (char *) malloc (strlen (dirname) + 1);
	if (obj->dirname == 0) {
		return -1;
	}

	strcpy (obj->dirname, dirname);
	return 0;
}

static int
sv2uid (SV *sv, uid_t *uid) {
#ifdef WIN32
	*uid = 0;
	return 0;
#endif
#ifdef UNIX
	if (SvIOKp (sv)) {
		*uid = SvIV (sv);
		return 0;
	}

	if (SvPOKp (sv)) {
		int len;
		char *name;
		struct passwd *pwd;

		name = (char *) SvPV (sv, PL_na);	
		if (strlen (name) == 0)
			return -1;

		pwd = getpwnam (name);
		if (pwd == 0)
			return -1;

		*uid = pwd->pw_uid;
		return 0;
	}

	return -1;
#endif
}

static int
sv2gid (SV *sv, gid_t *gid) {
#ifdef WIN32
	*gid = 0;
	return 0;
#endif
#ifdef UNIX
	if (SvIOKp (sv)) {
		*gid = SvIV (sv);
		return 0;
	}

	if (SvPOKp (sv)) {
		int len;
		char *name;
		struct group *grp;

		name = (char *) SvPV (sv, PL_na);	
		if (strlen (name) == 0)
			return -1;

		grp = getgrnam (name);
		if (grp == 0)
			return -1;

		*gid = grp->gr_gid;
		return 0;
	}

	return -1;
#endif
}

static int
tar_setowner (tar_obj_t *obj, uid_t uid, gid_t gid) {
	if (obj == 0)
		return -1;

	obj_freeerr (obj);

#ifdef UNIX
	obj->uid = uid;
	obj->gid = gid;
#endif

	return 0;
}

/*
 * move read position to next tar header in archive
 */
static int
tar_next (tar_obj_t* obj, tar_hdr_t **p_hdr) {
	char buff[BLOCKSIZE];
	tar_hdr_t *hdr;
	int got;
	int rc;

	obj_freeerr (obj);
	obj->inuse = 1;

	/* default return values */
	*p_hdr = 0; 
	rc = -1;
	for (;;) {
		if (obj->fp_tgz == 0) {
			/* nothing to read */
			rc = -1;
		}

		got = gzread (obj->fp_tgz, &buff, BLOCKSIZE);
		if (got < 0) {
			int errcode;
			char *errmsg;
			char *out;
			char msg0[] = "cannot read form archive ";			
			errmsg = (char *) gzerror (obj->fp_tgz, &errcode);
			if (errcode == Z_STREAM_ERROR) {
				if (obj->fp != 0) {
					fclose (obj->fp);
					obj->fp = 0;
				}

				if (obj->name != 0) {
					free (obj->name);
					obj->name = 0;
				} 
				obj->size = 0;
				obj_clearhdr (obj);
				rc = 0;
				break;
			}

			if (errcode == Z_ERRNO)
				errmsg = getstrerror (errno);
			
			obj_adderr (obj, errmsg);
		
			out = (char *) alloca
			(strlen (msg0) + strlen (obj->archname) + 1);
			strcpy (out , msg0);
			strcat (out , obj->archname);
			obj_adderr (obj, out);

			gzclose (obj->fp_tgz);
			obj->fp_tgz = 0;
			rc = 0;
			break;
		}

		if (got != BLOCKSIZE) {
			char *out;
			char msg0[] = "unexpected end of archive ";			
			out = (char *) alloca
			(strlen (msg0) + strlen (obj->archname) + 1);
			strcpy (out , msg0);
			strcat (out , obj->archname);
			obj_adderr (obj, out);
			break;
		}

		if (obj->size == 0) {
			hdr = (tar_hdr_t *) buff;
		
			if ((got == 0)  || (hdr->name[0] == 0)) { 
				/* end of file */
				if (obj->fp != 0) {
					fclose (obj->fp);
					obj->fp = 0;
				}

				if (obj->name != 0) {
					free (obj->name);
					obj->name = 0;
				} 
				obj_clearhdr (obj);
				rc = 0;
				break;
			}

			if (memcmp 
			(hdr->magic, TAR_MAGIC, sizeof (TAR_MAGIC)) != 0) {
				char *out;
				char msg0[] = "does not look like a tar file";
				char msg1[] = "cannot read from archive ";			
				obj_adderr (obj, msg0);

				out = (char *) alloca (strlen (msg1) + 
				              strlen (obj->archname) + 1);
				strcpy (out , msg1);
				strcat (out , obj->archname);
				obj_adderr (obj, out);

				gzclose (obj->fp_tgz);
				obj->fp_tgz = 0;
				rc = -1;
				break;
			}
			
			obj_sethdr (obj, hdr);
			*p_hdr = obj->hdr;
			obj->size = strnocttoi (hdr->size, sizeof (hdr->size));

			if (hdr->typeflag[0] == TAR_LONGNAMETYPE) {
				if (obj->longname != 0)
					free (obj->longname);

				obj->longname = malloc (obj->size + 1);
				if (obj->longname == 0) {
					char msg[] = "out of memory";			
					obj_adderr (obj, msg);
					rc = -1;
					break;
				}

				obj->longname[0] = 0;

			}

			if (hdr->typeflag[0] >= TAR_GNUTYPE)
				continue;

			rc = 0;
			break;

		} else if (obj->size > BLOCKSIZE) {
			if (obj->hdr->typeflag[0] == TAR_LONGNAMETYPE) {
				int offset;

				offset = strlen (obj->longname);

				memcpy (obj->longname, buff, BLOCKSIZE);
				obj->longname[offset + BLOCKSIZE] = '\0';
			}

			obj->size -= BLOCKSIZE;
		} else {
			if (obj->hdr->typeflag[0] == TAR_LONGNAMETYPE) {
				int offset;

				offset = strlen (obj->longname);

				memcpy (obj->longname, buff, obj->size);
				obj->longname[offset + obj->size] = '\0';
			} else {
				if (obj->longname != 0) {
					free (obj->longname);
					obj->longname = 0;
				}
			}

			obj->size = 0;
		}
	}

	return (rc);
}

/*
 * extract present file from archive to filesystem
 */
static int
tar_extract (tar_obj_t* obj) {
	char buff[BLOCKSIZE];
	int got;
	int rc;
	
	obj->inuse = 1;
	obj_freeerr (obj);

	/* 
	 * is archive open
	 */
	if (obj->fp_tgz == 0)
		return -1;

	rc = obj_begin (obj);
	if (rc < 0)
		return -1;

	if (obj->size == 0) {
		/* diretory or empty file */
		obj_final (obj);
		return 0;
	}

	rc = -1;
	for (;;) {
		int retval;
		got = gzread (obj->fp_tgz, &buff, BLOCKSIZE);
		if (got < 0) {
			int errcode;
			char *errmsg;
			char *out;
			char msg0[] = "cannot read form archive ";			
			errmsg = (char *) gzerror (obj->fp_tgz, &errcode);
			if (errcode == Z_ERRNO)
				errmsg = getstrerror (errno);
			
			obj_adderr (obj, errmsg);
		
			out = (char *) alloca
			(strlen (msg0) + strlen (obj->archname) + 1);
			strcpy (out , msg0);
			strcat (out , obj->archname);
			obj_adderr (obj, out);
			break;
		}

		if (got != BLOCKSIZE) {
			char *out;
			char msg0[] = "unexpected end of archive ";			
			out = (char *) alloca
			(strlen (msg0) + strlen (obj->archname) + 1);
			strcpy (out , msg0);
			strcat (out , obj->archname);
			obj_adderr (obj, out);
			break;
		}

		if (obj->size > BLOCKSIZE) {
			retval = obj_block (obj, buff, BLOCKSIZE);
			if (retval < 0) {
				return -1;
			}
			obj->size -= BLOCKSIZE;
		} else {
			retval = obj_block (obj, buff, obj->size);
			if (retval < 0) {
				return -1;
			}
			obj_final (obj);
			obj->size = 0;
			rc = 0;
			break;
		}
	}
	return (rc);
}

static int
tar_extract_read (tar_obj_t* obj, SV *sv, int want) {
	char *buff;
	int off;
	int got;
	
	obj->inuse = 1;
	obj_freeerr (obj);

	/* 
	 * archive already closed
	 */
	if (obj->fp_tgz == 0)
		return -1;

	/* 
	 * can we write to sv
	 */
	if (SvREADONLY (sv))
		return 0;

	/* 
	 * is it a diretory or an empty file
	 */
	if (obj->size == 0)
		return 0;

	buff = (char *) malloc (want);
	if (buff == 0)
		return -1;

	for (off = 0; off < want && obj->size > 0;) {
		if (obj->size > BLOCKSIZE) {
			got = gzread (obj->fp_tgz, buff + off, BLOCKSIZE);
			if (got != BLOCKSIZE) {
				free (buff);
				return -1;
			}

			obj->size -= got;
			off += got;
		} else {
			got = gzread (obj->fp_tgz, buff + off, obj->size);
			if (got != obj->size) {
				free (buff);
				return -1;
			}

			obj->size = 0;
			off += got;
		}
	}

	sv_setpvn (sv, buff, off);
	free (buff);
	return (off);
}

/*
 * extract present file from archive 
 * without writing to filesystem
 * and put it into a perl scalar
 */
static int
tar_extract_scalar (tar_obj_t* obj, SV *sv) {
	char buff[BLOCKSIZE];
	int got;
	int rc;
	
	obj->inuse = 1;
	obj_freeerr (obj);

	/* 
	 * archive already closed
	 */
	if (obj->fp_tgz == 0)
		return -1;

	/* 
	 * can we write to sv
	 */
	if (SvREADONLY (sv))
		return 0;

	/* 
	 * is it a diretory or an empty file
	 */
	if (obj->size == 0)
		return 0;

	rc = -1;

	sv_setpv (sv, "");
	for (;;) {
		got = gzread (obj->fp_tgz, &buff, BLOCKSIZE);
		if (got != BLOCKSIZE)
			break;

		if (obj->size > BLOCKSIZE) {
			sv_catpvn (sv, buff, BLOCKSIZE);
			obj->size -= BLOCKSIZE;
		} else {
			sv_catpvn (sv, buff, obj->size);
			obj->size = 0;
			rc = 0;
			break;
		}
	}

	return (rc);
}

struct BM_FILE_HEADER {
	uint16_t bfType;
	uint32_t bfSize;
	uint16_t bfReserved1;
	uint16_t bfReserved2;
	uint32_t bfOffBits;
};

struct BM_INFO_HEADER {
	uint32_t biSize;
	uint32_t biWidth;
	uint32_t biHeight;
	uint16_t biPlanes;
	uint16_t biBitCount;
	uint32_t biCompression;
	uint32_t biSizeImage;
	uint32_t biXPelsPerMeter;
	uint32_t biYPelsPerMeter;
	uint32_t biClrUsed;
	uint32_t biClrImportant;
};


#if BYTEORDER == 0x4321 || BYTEORDER == 0x87654321 
static void 
swap32_bytes(uint32_t* buf,unsigned words){
	unsigned char * p = (unsigned char*) buf;
	do {
		*buf++ = (uint32_t)((unsigned)p[3] << 8 | p[2]) << 16 |
			((unsigned)p[1] << 8 | p[0]);
		p += 4;
	} while (--words);
}

static void
swap16_bytes(uint16_t* buf,unsigned words){
	unsigned char * p = (unsigned char*) buf;
	do {
		*buf++ = (uint16_t)((unsigned)p[1] << 8 | p[0]);
		p += 2;
	} while (--words);
}
#else
#define swap32_bytes(buf,words)
#define swap16_bytes(buf,words)
#endif




static int
DIB2BMP(char * data, unsigned long size,struct BM_INFO_HEADER **rbmih, char ** img_data ){
	uint32_t i;
	uint32_t offset = 0;
	uint32_t colour_map_size = 0;	
	uint32_t index = 0;
	uint32_t * colour_map;
	unsigned char * pixels;
	uint32_t img_size = 0;
	char * cur_pos;
	char add_line_bytes = 0;
	uint16_t line_pos = 0;
	int cur_line = -1;
	struct BM_FILE_HEADER *bmfh = (struct BM_FILE_HEADER*) data;
#if (BYTEORDER == 0x1234 || BYTEORDER == 0x12345678) && !defined (__osf__) && 0
	struct BM_INFO_HEADER *bmih = (struct BM_INFO_HEADER*) (data + 14);
#else
	struct BM_INFO_HEADER *bmih = (struct BM_INFO_HEADER*) malloc(sizeof(struct BM_INFO_HEADER));
	memcpy(bmih,data + 14,sizeof(struct BM_INFO_HEADER)); 
#endif
	*rbmih = bmih;
	offset = 54; 	 


	swap32_bytes(&(bmih->biWidth),1);
	swap32_bytes(&(bmih->biHeight),1);
	swap16_bytes(&(bmih->biBitCount),1);
	swap16_bytes(&(bmfh->bfType),1);	

	if(bmfh->bfType != 0x4d42){
		printf(">>>> wrong type\n");
		return -1;
	}
	
	colour_map_size = 1;
	colour_map_size <<= bmih->biBitCount;
	colour_map = (uint32_t*) (data + offset);
	offset += 4 * colour_map_size;
	img_size = bmih->biWidth * bmih->biHeight;
	*img_data = (char*) malloc(img_size * 3);	
	cur_pos = *img_data + (img_size * 3);
	if(img_data == 0){
		return -1;
	}
	pixels = data + offset;
	add_line_bytes = bmih->biWidth % 2;
	for(i=0;i < img_size;i++){
		if(i % bmih->biWidth == 0){
			line_pos = 0;
			cur_line++;
			cur_pos -= bmih->biWidth * 3;  
		}
		memcpy(cur_pos + line_pos++, &((char*) &colour_map[pixels[i + (cur_line * add_line_bytes)]])[2],1);	
		memcpy(cur_pos + line_pos++, &((char*) &colour_map[pixels[i + (cur_line * add_line_bytes)]])[1],1);
		memcpy(cur_pos + line_pos++, &((char*) &colour_map[pixels[i + (cur_line * add_line_bytes)]])[0],1);
				
		/*
		*((char*) (cur_pos + line_pos++)) = ((char*) &colour_map[pixels[i + (cur_line * add_line_bytes)]])[2];
		*((char*) (cur_pos + line_pos++)) = ((char*) &colour_map[pixels[i + (cur_line * add_line_bytes)]])[1];
		*((char*) (cur_pos + line_pos++)) = ((char*) &colour_map[pixels[i + (cur_line * add_line_bytes)]])[0];*/
	}
	return 0;
}





/*
 * extract present bitmap file from archive 
 * without writing to filesystem,
 * converting it to a real rgb bitmap
 * and put it into a perl scalar
 */

static int
tar_extract_dib (tar_obj_t* obj, SV *svwidth, SV *svheight, SV *svdata) {
	char *buff;
	char *img_data;
	int got;
	int rc;
	int pos;
	int bmp_len = 0;
	struct BM_INFO_HEADER *bmih;
	obj->inuse = 1;
	obj_freeerr (obj);

	/* 
	 * archive already closed
	 */
	if (obj->fp_tgz == 0)
		return -1;

	/* 
	 * can we write to sv
	 */
	if (SvREADONLY (svdata) || SvREADONLY (svheight) || SvREADONLY (svwidth) )
		return 0;

	/* 
	 * is it a diretory or an empty file
	 */
	if (obj->size == 0)
		return 0;

	rc = -1;

	buff = 0;
	pos = 0;
	for (;;) {
		buff = realloc (buff, pos + BLOCKSIZE);
		if (buff == 0)
			break;

		got = gzread (obj->fp_tgz, buff + pos, BLOCKSIZE);
		if (got != BLOCKSIZE)
			break;

		if (obj->size > BLOCKSIZE) {
			pos += BLOCKSIZE;
			obj->size -= BLOCKSIZE;
		} else {
			pos += obj->size;
			obj->size = 0;
			rc = 0;
			break;
		}
	}

	if(DIB2BMP(buff,pos,&bmih,&img_data) != 0){
		return -1;
	}		
	
	bmp_len = bmih->biWidth * bmih->biHeight * 3;
	
	if (rc == 0){
		sv_setpvn (svdata, img_data,bmp_len);
		sv_setiv(svwidth,bmih->biWidth);
		sv_setiv(svheight,bmih->biHeight);	
	}
	else
		sv_setpv (svdata, "");

	if (buff != 0)
		free (buff);
    
	if (img_data != 0)
		free (img_data);

#if BYTEORDER == 0x4321 || BYTEORDER == 0x87654321
	if (bmih != 0)
		free(bmih);
#endif

	return (rc);
}


static int
tar_fsusage_count (tar_obj_t *obj) {
	fsusage_t *fsusage;
	int i;

	fsusage = obj->fsusage;
	if (fsusage == 0)
		return 0;

	for (i = 0;; i++) {
		fsusage = fsusage->next;
		if (fsusage == 0)
			break;
	}

	return (i + 1);
}

static int
tar_fsusage_fetch (tar_obj_t *obj, int index, fsusage_t **p_fsusage) {
	fsusage_t *fsusage;
	int i;

	fsusage = obj->fsusage;
	if (fsusage == 0)
		return 0;

	for (i = 0; i < index; i++) {
		fsusage = fsusage->next;
		if (fsusage == 0)
			return -1;
	}
	
	*p_fsusage = fsusage;
	return 0;
}

/*
 * helper function for XS funtion to find
 * session structure from perl object
 */
static tar_obj_t *
self_getobj (HV *self) {
	char *key_obj = "obj";
	SV **psv_obj;
	tar_obj_t *obj;

	psv_obj = hv_fetch (self, key_obj, strlen (key_obj), 0);
	if (psv_obj == 0) {
		return 0;
	}

	obj = (tar_obj_t *) SvIV (*psv_obj);
	return (obj);
}

void
self_putobj (HV *self, tar_obj_t *obj) {
	char *key_obj = "obj";
	SV *sv_obj;

	sv_obj = newSViv ((ptr_t) obj);
	hv_store (self, key_obj, strlen (key_obj), sv_obj, 0);
	return;
}

/*
 * we dont call strerror directly
 * because we dont want localized messages
 */
static char *
getstrerror (int errval) {
	return (Strerror(errval));
}

/*
 * now we add the perl source as as inline code
 * symbol name of the string containing the code
 * is sz_text
 * this code will be evaled in the BOOT method of the module
 */
#include "Untgz.h"

MODULE = SAPDB::Install::Untgz	PACKAGE = SAPDB::Install::Untgz

PROTOTYPES: DISABLE

BOOT:
	perl_eval_pv ((char *) sz_text, 1);
	
void
new (...)
PREINIT:
	char *CLASS = "SAPDB::Install::Untgz";
	HV *self;
	tar_obj_t *obj;
CODE:
	if (items != 0) {
		XSRETURN_UNDEF;
	}
	
	self = newHV ();
	ST(0) = sv_bless (newRV ((SV*) self), gv_stashpv (CLASS, 1));

	obj = (tar_obj_t *) malloc (sizeof (tar_obj_t));
	if (obj == 0) {
		XSRETURN_UNDEF;
	}

	obj_init (obj);

	self_putobj (self, obj);

	sv_2mortal (ST(0));
	SvREFCNT_dec (self);

void
DESTROY (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0)
		XSRETURN_UNDEF;

	tar_close (obj);
	XSRETURN_UNDEF;
	
SV *
Open (...)
PREINIT:
	HV *self;
	char *filename;
	int rc;
	int ro_mode;
	tar_obj_t *obj;
PPCODE:
	if (items < 2 || items > 3)
		XSRETURN_UNDEF;

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0)
		XSRETURN_UNDEF;

	filename = (char *) SvPV (ST (1), PL_na);
	if (strlen (filename) == 0) {
		XSRETURN_UNDEF;
	}

	if (items == 3) {
		ro_mode = SvIV (ST(2));
	} else {
		ro_mode = 0;
	}

	rc = tar_open (obj, filename, ro_mode);
	if (rc != 0) {
		XSRETURN_UNDEF;
	}

	PUSHs (sv_2mortal (newSViv (0)));
	XSRETURN (1);

	
SV *
SetReadOnly (...)
PREINIT:
	HV *self;
	int rc;
	int ro_mode;
	tar_obj_t *obj;
PPCODE:
	if (items != 2)
		XSRETURN_UNDEF;

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0)
		XSRETURN_UNDEF;

	ro_mode = SvIV (ST(1));

	rc = tar_setreadonly (obj, ro_mode);
	if (rc != 0) {
		XSRETURN_UNDEF;
	}

	PUSHs (sv_2mortal (newSViv (0)));
	XSRETURN (1);

SV *
Next (...)
PREINIT:
	HV *self;
	int rc;
	tar_obj_t *obj;
	tar_hdr_t *hdr;
	char sz_text[1024];
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}
	
	rc = tar_next (obj, &hdr);
	if (rc < -1 || hdr == 0) {
		XSRETURN_UNDEF;
	}

	if (GIMME == G_SCALAR) {
		if (obj->longname != 0) {
			char *sz_longtext;

			sz_longtext = alloca (sizeof (sz_text) + strlen (obj->longname));
			sprintf_hdrstat (sz_longtext, hdr, obj->longname);
			XPUSHs (sv_2mortal (newSVpv (sz_longtext, strlen (sz_longtext))));
		} else {
			sprintf_hdrstat (sz_text, hdr, 0);
			XPUSHs (sv_2mortal (newSVpv (sz_text, strlen (sz_text))));
		}
		XSRETURN (1);
	} else if (GIMME == G_ARRAY) {
		XPUSHs (sv_2mortal (newSViv (get_hdrmode (hdr))));
		XPUSHs (sv_2mortal (newSViv (get_hdrsize (hdr))));
		XPUSHs (sv_2mortal (newSViv (get_hdrtime (hdr))));

		if (obj->longname != 0) {
			XPUSHs (sv_2mortal (newSVpv (obj->longname, strlen (obj->longname))));
		} else {
			sprintf_hdrname (sz_text, hdr);
			XPUSHs (sv_2mortal (newSVpv (sz_text, strlen (sz_text))));
		}
		XSRETURN (4);
	}
	XSRETURN_UNDEF;

SV *
Rewind (...)
PREINIT:
	HV *self;
	int rc;
	tar_obj_t *obj;
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}
	
	rc = tar_rewind (obj);
	if (rc < -1) {
		XSRETURN_UNDEF;
	}

	XPUSHs (sv_2mortal (newSViv (rc)));
	XSRETURN (1);

SV *
GetArchivename (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV)))
		XSRETURN_UNDEF;

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0)
		XSRETURN_UNDEF;
	
	if (obj->archname == 0)
		XSRETURN_UNDEF;

	XPUSHs (sv_2mortal (newSVpv (obj->archname, strlen (obj->archname))));
	XSRETURN (1);

SV *
GetHeader (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
	tar_hdr_t *hdr;
	char sz_text[1024];
PPCODE:
	if (items != 1)
		XSRETURN_UNDEF;

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}

	hdr = obj->hdr;	
	if (hdr == 0 || hdr->name[0] == '\0') {
		XSRETURN_UNDEF;
	}

	if (GIMME == G_SCALAR) {
		if (obj->longname != 0) {
			char *sz_longtext;

			sz_longtext = alloca (sizeof (sz_text) + strlen (obj->longname));
			sprintf_hdrstat (sz_longtext, hdr, obj->longname);
			XPUSHs (sv_2mortal (newSVpv (sz_longtext, strlen (sz_longtext))));
		} else {
			sprintf_hdrstat (sz_text, hdr, 0);
			XPUSHs (sv_2mortal (newSVpv (sz_text, strlen (sz_text))));
		}
		XSRETURN (1);
	} else if (GIMME == G_ARRAY) {
		XPUSHs (sv_2mortal (newSViv (get_hdrmode (hdr))));
		XPUSHs (sv_2mortal (newSViv (get_hdrsize (hdr))));
		XPUSHs (sv_2mortal (newSViv (get_hdrtime (hdr))));

		if (obj->longname != 0) {
			XPUSHs (sv_2mortal (newSVpv (obj->longname, strlen (obj->longname))));
		} else {
			sprintf_hdrname (sz_text, hdr);
			XPUSHs (sv_2mortal (newSVpv (sz_text, strlen (sz_text))));
		}
		XSRETURN (4);
	}
	XSRETURN_UNDEF;

SV *
ExtractFile (...)
PREINIT:
	int rc;
	tar_obj_t *obj;
	HV *self;
PPCODE:
	if (items < 1 && items > 2) {
		XSRETURN_UNDEF;
	}

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}

	rc = tar_extract (obj);
	PUSHs (sv_2mortal (newSViv (rc)));
	XSRETURN (1);
	
SV *
SetDestDir (...)
PREINIT:
	HV *self;
	int rc;
	tar_obj_t *obj;
	char *dirname;
PPCODE:
	if (items != 2) {
		XSRETURN_UNDEF;
	}
	
	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}
	
	dirname = SvPV (ST(1), PL_na);
	if (dirname == 0 || strlen (dirname) == 0) {
		XSRETURN_UNDEF;
	}

	rc = tar_setdir (obj, dirname);
	XSRETURN_IV (rc);

SV *
SetOwner (...)
PREINIT:
	HV *self;
	int rc;
	tar_obj_t *obj;
	uid_t uid;
	gid_t gid;
PPCODE:
	if (items != 3) {
		XSRETURN_UNDEF;
	}
	
	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0)
		XSRETURN_UNDEF;
	
	rc = sv2uid (ST(1), &uid);
	if (rc != 0)
		XSRETURN_UNDEF;

	rc = sv2gid (ST(2), &gid);
	if (rc != 0)
		XSRETURN_UNDEF;

	rc = tar_setowner (obj, uid, gid);
	XSRETURN_IV (rc);


void
ExtractRead (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
	int want;
	int rc;
PPCODE:
	if (items < 2 || items > 3)
		XSRETURN_UNDEF;

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV)))
		XSRETURN_UNDEF;

	want = 512;
	if (items >= 3)
		want = SvIV (ST(2));

	if (want % 512 != 0)
		XSRETURN_UNDEF;

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0)
		XSRETURN_UNDEF;

	rc = tar_extract_read (obj, ST(1), want);
	
	if (rc < 0)
		XSRETURN_UNDEF;

	XSRETURN_IV (rc);

void
ExtractScalar (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
	int rc;
PPCODE:
	if (items != 2) {
		XSRETURN_UNDEF;
	}

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}
	
	rc = tar_extract_scalar (obj, ST(1));
	
	if (rc < 0) {
		XSRETURN_UNDEF;
	} else {
		XSRETURN_IV (rc);
	}

void
ExtractDIB (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
	int rc;
PPCODE:
	if (items != 4) {
		XSRETURN_UNDEF;
	}

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}
	
	rc = tar_extract_dib (obj, ST(1), ST(2), ST(3) );
	
	if (rc < 0) {
		XSRETURN_UNDEF;
	} else {
		XSRETURN_IV (rc);
	}


void
FetchFSUsage (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
	int rc;
	int index;
	fsusage_t *fsusage;
	char *sz_fsname = "FSNAME";
	char *sz_total  = "TOTAL";
	char *sz_avail  = "AVAIL";
	char *sz_used   = "USED";
	char *sz_needed = "NEEDED";
PPCODE:
	if (items < 1 || items > 2) {
		XSRETURN_UNDEF;
	}

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}

	if (items == 1) {
		rc = tar_fsusage_count (obj);
		if (rc < 0) {
			XSRETURN_UNDEF;
		}

		XPUSHs (sv_2mortal (newSViv (rc)));
		XSRETURN (1);
	}

	index = SvIV (ST(1));
	rc = tar_fsusage_fetch (obj, index, &fsusage);
	if (rc != 0) {
		XSRETURN_UNDEF;
	}

	XPUSHs (sv_2mortal (newSVpv (sz_fsname, strlen (sz_fsname))));
	if (fsusage->fsname == 0) {
		XPUSHs (sv_2mortal (newSVpv ("", 0)));
	} else {
		XPUSHs (sv_2mortal (newSVpv 
		(fsusage->fsname, strlen (fsusage->fsname))));
	}
	XPUSHs (sv_2mortal (newSVpv (sz_total, strlen (sz_total))));
	XPUSHs (sv_2mortal (newSViv ((IV) fsusage->total)));
	XPUSHs (sv_2mortal (newSVpv (sz_avail, strlen (sz_avail))));
	XPUSHs (sv_2mortal (newSViv ((IV) fsusage->avail)));
	XPUSHs (sv_2mortal (newSVpv (sz_used, strlen (sz_used))));
	XPUSHs (sv_2mortal (newSViv ((IV) fsusage->used)));
	XPUSHs (sv_2mortal (newSVpv (sz_needed, strlen (sz_needed))));
	XPUSHs (sv_2mortal (newSViv ((IV) fsusage->needed)));
	XSRETURN (10);

SV *
GetErr (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
	char *msg;
	void *ptr;
	int i;
PPCODE:
	if (items != 1) {
		XSRETURN_UNDEF;
	}

	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}
	
	ptr = 0;
	i = 0;
	for (;;) {
		msg = obj_geterr (obj, &ptr);
		if (msg == 0)
			break;
		PUSHs (sv_2mortal (newSVpv (msg, strlen (msg))));
		i++; 
		if (ptr == 0)
			break;
	}
	XSRETURN (i);

void
ErrAdd (...)
PREINIT:
	HV *self;
	tar_obj_t *obj;
	char *errmsg;
PPCODE:
	if (items != 2) {
		XSRETURN_UNDEF;
	}
	
	if (!(sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
		XSRETURN_UNDEF;
	}

	self = (HV*) SvRV (ST(0));
	obj = self_getobj (self);
	if (obj == 0) {
		XSRETURN_UNDEF;
	}
	
	errmsg = SvPV (ST(1), PL_na);
	if (errmsg == 0 || strlen (errmsg) == 0) {
		XSRETURN_UNDEF;
	}

	obj_adderr (obj, errmsg);
	XSRETURN_UNDEF;
