/*
 * VersionInfo.xs
 *
 * $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/VersionInfo.xs#1 $
 * $DateTime: 2005/03/21 16:21:00 $
 * $Change: 93297 $
 */

static char szWhatHeader[] = 
	"@(#) $Header: //sapdb/V76/c_00/b_09/sys/src/install/perl/sdbrun/VersionInfo.xs#1 $";

#ifndef __cplusplus
#ifndef HAS_BOOL
typedef char bool;
#endif
#endif

#ifndef WIN32
#define UNIX UNIX
#endif

#ifdef __hpux
#define DONT_DECLARE_STD
#endif

/*
 * expect compiler warning 4113 when using Microsoft C
 * in c code generated by xs preprocessor
 */
#if _MSC_VER >= 1200
#pragma warning(disable : 4113)
#endif

#ifdef __cplusplus
#define externC extern "C"
#else
#define externC extern
#endif

#ifdef WIN32
#include <WINDOWS.h>
#include <tchar.h>
#include <io.h>
#include <fcntl.h>
#include <malloc.h>
#endif

#ifdef UNIX
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif

#ifdef WIN32
#ifndef alloca
#define alloca(size) _alloca(size)
#endif
#define snprintf _snprintf
#endif

#if defined WIN32
#define NEED_TYPEDEF_UCHAR_T NEED_TYPEDEF_UCHAR_T
#define NEED_TYPEDEF_UNIT16_T NEED_TYPEDEF_UNIT16_T
#define NEED_TYPEDEF_UNIT32_T NEED_TYPEDEF_UNIT32_T
#define NEED_TYPEDEF_UNIT64_T NEED_TYPEDEF_UNIT64_T
#endif

#ifdef NEED_TYPEDEF_UCHAR_T
typedef unsigned char  uchar_t;
#endif
#ifdef NEED_TYPEDEF_UNIT16_T
typedef unsigned short uint16_t;
#endif
#ifdef NEED_TYPEDEF_UNIT32_T
typedef unsigned int   uint32_t;
#endif
#ifdef NEED_TYPEDEF_UNIT64_T
typedef unsigned long  uint64_t;
#endif

#if defined _WIN64
typedef __int64 ptr_t;
#else
typedef long ptr_t;
#endif

typedef void *handle_t;
typedef int (*readfunc_t) (void *, char *, int);

#include "VersionInfo.h"

#ifdef WIN32
static handle_t
myopen (char *filename, int mode) {
	return ((handle_t) ((ptr_t) _open (filename, mode | O_BINARY)));
}

static int
myclose (handle_t fd) {
	return (_close ((int) ((ptr_t) fd)));
}

static int
myread (handle_t fd, char *buff, int want) {
	return (_read ((int)((ptr_t) fd), buff, want));
}
#endif

#ifdef UNIX
static handle_t
myopen (char *filename, int mode) {
	return ((handle_t) ((ptr_t) open (filename, mode)));
}

static int
myclose (handle_t fd) {
	return (close ((int) ((ptr_t) fd)));
}

static int
myread (handle_t fd, char *buff, int want) {
	return (read ((int)((ptr_t) fd), buff, want));
}
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef PERL_OBJECT
#define FILE struct _PerlIO
#endif


/*
 * helper function to make untgz read look like UNIX read
 */
#ifdef WIN32
static int
untgzread (void *handle, char *buffer, int want) {	
	int rc;
	int got;
	SV *sv_buffer;
	SV *sv_archive;

	sv_archive = (SV *) handle;

	/*
	 * untgz an only use blocks of 512 byte
	 */	
	if (want != 512)
		return -1;

	sv_buffer = newSVsv (&PL_sv_undef);

	{
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK (sp);

	XPUSHs (sv_archive);
	XPUSHs (sv_buffer);
	PUTBACK;

	rc = perl_call_pv ("SAPDB::Install::Untgz::ExtractRead", G_ARRAY);
	
	SPAGAIN;

	got = -1;

	if (rc == 1)
		got = POPi;

	PUTBACK;
	FREETMPS;
	LEAVE;
	}

	if (got > 0)
		memcpy (buffer, SvPV (sv_buffer, PL_na), got);

	SvREFCNT_dec (sv_buffer);

	return (got);
}
#endif

#ifdef UNIX
static int
untgzread (void *handle, char *buffer, int want) {	
	return 0;
}
#endif

#ifdef WIN32
typedef struct {
	int value;
	char name[64];
} names_t;

static char 
*get_name (int value, names_t *ptr) {
	while (ptr->value >= 0) {
		if (ptr->value == value) {
			return (ptr->name);
		}
		ptr++;
	} 
	return 0;
}

/*
 * structures from windows PE header
 */
typedef struct {
	uint16_t e_magic;    /* Magic number */
	uint16_t e_cblp;     /* Bytes on last page of file */
	uint16_t e_cp;       /* Pages in file */
	uint16_t e_crlc;     /* Relocations */
	uint16_t e_cparhdr;  /* Size of header in paragraphs */
	uint16_t e_minalloc; /* Minimum extra paragraphs needed */
	uint16_t e_maxalloc; /* Maximum extra paragraphs needed */
	uint16_t e_ss;       /* Initial (relative) SS value */
	uint16_t e_sp;       /* Initial SP value */
	uint16_t e_csum;     /* Checksum */
	uint16_t e_ip;       /* Initial IP value */
	uint16_t e_cs;       /* Initial (relative) CS value */
	uint16_t e_lfarlc;   /* File address of relocation table */
	uint16_t e_ovno;     /* Overlay number */
	uint16_t e_res[4];   /* Reserved words */
	uint16_t e_oemid;    /* OEM identifier (for e_oeminfo) */
	uint16_t e_oeminfo;  /* OEM information; e_oemid specific */
	uint16_t e_res2[10]; /* Reserved words */
	uint16_t e_lfanew;   /* File address of new exe header */
} win_doshdr_t;

typedef struct {
	uchar_t  Signatur[4];
	uint16_t Machine;
	uint16_t NumberOfSections;
	uint32_t TimeDateStamp;
	uint32_t PointerToSymbolTable;
	uint32_t NumberOfSymbols;
	uint16_t SizeOfOptionalHeaders;
	uint16_t Characteristics;
} win_imagefilehdr_t;

typedef struct {
	uint16_t Magic;
	uchar_t MajorLinkerVersion;
	uchar_t MinorLinkerVersion;
	uint32_t SizeOfCode;
	uint32_t SizeOfInitializedData;
	uint32_t SizeOfUninitializedData;
	uint32_t AddressOfEntryPoint;
	uint32_t BaseOfCode;
	uint32_t BaseOfData;
	uint32_t ImageBase;
	uint32_t SectionAlignment;
	uint32_t FileAlignment;
	uint16_t MajorOperatingSystemVersion;
	uint16_t MinorOperatingSystemVersion;
	uint16_t MajorImageVersion;
	uint16_t MinorImageVersion;
	uint16_t MajorSubsystemVersion;
	uint16_t MinorSubsystemVersion;
	uint32_t Win32VersionValue;
	uint32_t SizeOfImage;
	uint32_t SizeOfHeaders;
	uint32_t CheckSum;
	uint16_t Subsystem;
	uint16_t DllCharacteristics;
	uint32_t SizeOfStackReserve;
	uint32_t SizeOfStackCommit;
	uint32_t SizeOfHeapReserve;
	uint32_t SizeOfHeapCommit;
	uint32_t LoaderFlags;
	uint32_t NumberOfRvaAndSizes;
} win_optionalhdr32_t;

typedef struct {
	uint16_t Magic;
	uchar_t MajorLinkerVersion;
	uchar_t MinorLinkerVersion;
	uint32_t SizeOfCode;
	uint32_t SizeOfInitializedData;
	uint32_t SizeOfUninitializedData;
	uint32_t AddressOfEntryPoint;
	uint32_t BaseOfCode;
	uint32_t BaseOfData;
	uint32_t ImageBase;
	uint32_t SectionAlignment;
	uint32_t FileAlignment;
	uint16_t MajorOperatingSystemVersion;
	uint16_t MinorOperatingSystemVersion;
	uint16_t MajorImageVersion;
	uint16_t MinorImageVersion;
	uint16_t MajorSubsystemVersion;
	uint16_t MinorSubsystemVersion;
	uint32_t Win32VersionValue;
	uint32_t SizeOfImage;
	uint32_t SizeOfHeaders;
	uint32_t CheckSum;
	uint16_t Subsystem;
	uint16_t DllCharacteristics;
	uint32_t SizeOfStackReserve0;
	uint32_t SizeOfStackReserve1;
	uint32_t SizeOfStackCommit0;
	uint32_t SizeOfStackCommit1;
	uint32_t SizeOfHeapReserve0;
	uint32_t SizeOfHeapReserve1;
	uint32_t SizeOfHeapCommit0;
	uint32_t SizeOfHeapCommit1;
	uint32_t LoaderFlags;
	uint32_t NumberOfRvaAndSizes;
} win_optionalhdr64_t;

typedef struct {
	uint32_t VirtualAddress;
	uint32_t Size;
} win_datadirectory_t;

typedef struct {
	uchar_t Name[8];
	uint32_t PhysicalAddress;
	uint32_t VirtualAddress;
	uint32_t SizeOfRawData;
	uint32_t PointerToRawData;
	uint32_t PointerToRelocations;
	uint32_t PointerToLinenumbers;
	uint16_t NumberOfRelocations;
	uint16_t NumberOfLinenumbers;
	uint32_t Characteristics;
} win_sectionhdr_t;

typedef struct {
	uint32_t Characteristics;
	uint32_t TimeDateStamp;
	uint16_t MajorVersion;
	uint16_t MinorVersion;
	uint16_t NumberOfNamedEntries;
	uint16_t NumberOfIdEntries;
} win_resdirectory_t;

typedef struct {
	uint32_t Name;
	uint32_t OffsetToData;
} win_resdirentry_t;

typedef struct {
	uint32_t OffsetToData;
	uint32_t Size;
	uint32_t CodePage;
	uint32_t Reserved;
} win_resdataentry_t;

typedef struct {
	uchar_t Signatur[4];
} win_signatur_t;

static uchar_t win_dosmagic[2] = {'M', 'Z'};
static uchar_t win_ntmagic[4] = {'P', 'E', '\0', '\0'};

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
	uint16_t Magic[16];
} win_versioninfo_t;

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
	uint16_t Magic[15];
} win_stringfileinfo_t;

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
	uint16_t Magic[12];
} win_varfileinfo_t;

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
	uint16_t Key[9];
} win_stringtable_t;

typedef struct {
	uint16_t Size;
	uint16_t ValueSize;
	uint16_t Type;
} win_string_t;

static uint16_t win_versioninfo_magic[16] =
	{'V', 'S', '_', 'V', 'E', 'R', 'S', 'I', 'O', 'N', '_',
	 'I', 'N', 'F', 'O', 0};

static uint16_t win_stringfileinfo_magic[15] =
	{'S', 't', 'r', 'i', 'n', 'g', 'F', 'i', 'l', 'e',
	 'I', 'n', 'f', 'o', 0};

static uint16_t win_varfileinfo_magic[12] =
	{'V', 'a', 'r', 'F', 'i', 'l', 'e',
	 'I', 'n', 'f', 'o', 0};

static names_t win_flag_names[] = {
	{0x0002, "executable"},
	{0x1000, "system file"},
	{0x2000, "dll"},
	{-1, ""}
};

static names_t win_machine_names[] = {
	{0x0000, "unknown machine"},
	{0x014c, "i386"},
	{0x0160, "MIPS R3000 big-endian"},
	{0x0166, "MIPS R4000 little-endian"},
	{0x0168, "MIPS R10000 little-endian"},
	{0x0169, "MIPS WCE v2 little-endian"},
	{0x0184, "ALPHA 32-bit"},
	{0x01f0, "PowerPC"},
	{0x0200, "IA64"},
	{0x0284, "ALPHA 64-bit"},
	{0x8664, "AMD64"},
	{-1, ""}
};

static int
is_windowsdos (char *buff, char *sz_text, int cb_text) {
	win_doshdr_t *doshdr;

	doshdr = (win_doshdr_t *) buff;
	
	if (memcmp 
	(&doshdr->e_magic, win_dosmagic, sizeof (win_dosmagic)) != 0) {
		return -1;
	}

	snprintf (sz_text, cb_text - 1, "MS DOS");
	return 0;
}

static int
is_windowspe (char *buff, char *sz_text, int cb_text) {
	win_imagefilehdr_t *winnthdr;
	win_signatur_t *signature;
	char *machine;
	names_t *ptr;
	
	signature = (win_signatur_t *) buff;
	winnthdr = (win_imagefilehdr_t *) buff;

	if (memcmp 
	(&signature->Signatur, win_ntmagic, sizeof (win_ntmagic)) != 0) {
		return -1;
	}

	machine = get_name (winnthdr->Machine, win_machine_names);
	if (machine == 0)
		return -1;
	
	snprintf (sz_text, cb_text - 1, "MS Windows");
	switch (winnthdr->Machine) {
	case 0x014c:
		/* i386 */
		snprintf (sz_text + strlen (sz_text), cb_text - 1, " 32-bit");
		break;
	case 0x0200:
		/* ia64 */
	case 0x8664:
		/* amd64 */
		snprintf (sz_text + strlen (sz_text), cb_text - 1, " 64-bit");
		break;
	}

	snprintf (sz_text + strlen (sz_text), cb_text - 1, " %s", machine);

	ptr = win_flag_names;
	while (ptr->value != -1) {
		if (ptr->value & winnthdr->Characteristics) {
			snprintf (sz_text + strlen (sz_text),
			          cb_text - 1, " %s", ptr->name);
		}
		ptr++;
	}
	return 0;
}

/*
 * JAR (java archive)
 */
typedef struct {
	uchar_t id[4];
} jar_magic_t;

static jar_magic_t jar_magic[1] = {'P', 'K', 3, 4}; 

static int
is_jar (char *buff, char *sz_text, int cb_text) {
	jar_magic_t *hdr;

	hdr = (jar_magic_t *) buff;	

	if (memcmp (hdr, jar_magic, sizeof (jar_magic_t)) != 0)
		return -1;
	
	snprintf (sz_text, cb_text - 1, "JAR or ZIP archive");
	return 0;
}

static int
get_magic (char *buff, char *sz_text, int cb_text) {
	if (is_windowsdos (buff, sz_text, cb_text) == 0) {
		return 0;
	} else if (is_windowspe (buff, sz_text, cb_text) == 0) {
		return 0;
	} else if (is_jar (buff, sz_text, cb_text) == 0) {
		return 0;
	}

	strncpy (sz_text, "unknown magic", cb_text - 1);	
	return 0;
}

typedef struct {
	int peoffset;
	struct {
		int offset;
		int size;
	} res;
	win_doshdr_t        * doshdr;
	win_imagefilehdr_t  * filehdr; 

	win_optionalhdr32_t * opthdr32; 
	win_optionalhdr64_t * opthdr64; 
	win_datadirectory_t * datadir;
	win_sectionhdr_t    * sechdr;
} win_image_t;

typedef struct session {
	struct session *next;
	void *handle;
	char *buff;
	char *magic;
	int offset;
	int size;
} session_t;

static void calc_peoffset (win_image_t *);
static void calc_resoffset (win_image_t *);
static int virtual2real (win_image_t *, int);
static int get_versionresource (char *, int, int, int *);

static session_t * sess_root = 0;

static session_t *
get_session (void * handle) {
	session_t *curr, *prev;
	
	if (sess_root == 0) {
		curr = malloc (sizeof (session_t));
		if (curr == 0)
			return 0;

		memset (curr, 0, sizeof (session_t));
		curr->handle = handle;
	
		sess_root = curr;
		return (curr);
	}

	for (curr = sess_root; curr != 0;) {
		if (curr->handle == handle)
			return (curr);

		prev = curr;
		curr = curr->next;
	}

	curr = malloc (sizeof (session_t));
	if (curr == 0)
		return 0;

	memset (curr, 0, sizeof (session_t));
	curr->handle = handle;
	
	prev->next = curr;
	return (curr);
}

static void
del_session (void *handle) {
	session_t *curr, *prev;

	if (sess_root == 0)
		return;

	for (curr = sess_root; curr != 0;) {
		if (curr->handle == handle) {
			if (curr == sess_root) {
				sess_root = curr->next;
			} else {
				prev->next = curr->next;
			}

			free (curr);
			return;
		}
		
		prev = curr;
		curr = curr->next;
	}

	return;
}

static char *
get_versioninfo (void *handle, void *func, char *resinfo, int *p_size,
                 char *magic, int *p_magicsize) {
	int got = 0;
	int total = 0;
	int offset = 0;

	char *buff = 0;
	int versioninfo = 0;

	session_t *sess;
	win_image_t *image;

	sess = get_session (handle);

	if (sess->buff != 0 || sess->magic != 0) {
		*p_size = 0;
		if (p_magicsize != 0)
			*p_magicsize = 0;

		if (sess->buff != 0) {
			if (resinfo != 0) {
				memcpy (resinfo, sess->buff, sess->size);
				*p_size = sess->size;
			}

			free (sess->buff);
			sess->buff = 0;
			sess->offset = 0;
			sess->size = 0;
		}

		if (sess->magic != 0) {
			if (magic != 0) {
				strcpy (magic, sess->magic);
				if (p_magicsize != 0)
					*p_magicsize = strlen (sess->magic) + 1;
			}

			free (sess->magic);
			sess->magic = 0;
		}

		del_session (handle);
		return (resinfo);
	}

	image = malloc (sizeof (win_image_t));
	if (image == 0)
		return 0;

	memset (image, 0, sizeof (win_image_t));

	for (;;) {
		buff = realloc (buff, total - offset + 512);

		got =
		(*(readfunc_t) func) (handle, buff + (total - offset), 512);

		if (got <= 0) break;

		total += got;

		/*
		 * looking for pe-offset from dos-header
		 */
		if (image->peoffset == 0 && image->doshdr == 0) {
			if (offset == 0) {
				char sz_magic[1024];
				int from;
				int to;

				from = 0;
				if (total <= from) {
					offset = total;
					continue;
				}

				to = from + (int) sizeof (win_doshdr_t); 
				if (total < to) continue;

				image->doshdr = malloc (sizeof (win_doshdr_t));
				if (image->doshdr == 0) break;

				memcpy (image->doshdr,
				buff + from - offset,
				sizeof (win_doshdr_t));

				calc_peoffset (image);

				sz_magic[0] = '\0';
				get_magic (buff + from - offset, sz_magic, 1024);

				if (strlen (sz_magic) != 0) {
					if (sess->magic != 0)
						free (sess->magic);

					sess->magic = malloc (strlen (sz_magic) + 1);

					strcpy (sess->magic, sz_magic);
					if (p_magicsize != 0)
						*p_magicsize = strlen (sz_magic) + 1;

					/*
					 * if this is not a least an MS DOS header,
					 * it makes no sense to look for any resources
					 */
					if (memcmp (sz_magic, "MS DOS", 6) != 0) {
						if (image != 0) {
							if (image->doshdr != 0)
								free (image->doshdr);

							if (image->filehdr != 0)
								free (image->filehdr);

							if (image->opthdr32 != 0)
								free (image->opthdr32);

							if (image->opthdr64 != 0)
								free (image->opthdr64);

							if (image->sechdr != 0)
								free (image->sechdr);

							if (image->datadir != 0)
								free (image->datadir);

							free (image);
						}

						if (buff != 0)
							free (buff);

						return 0;
					}
				}
			}
		}

		/*
		 * looking for pe-image-fileheader
		 */
		if (image->filehdr == 0) {
			int from;
			int to;
			char sz_magic[1024];

			from = image->peoffset;
			if (total <= from) {
				offset = total;
				continue;
			}

			to =
			image->peoffset + (int) sizeof (win_imagefilehdr_t); 

			if (total < to) continue;

			image->filehdr = malloc (sizeof (win_imagefilehdr_t));
			if (image->filehdr == 0) break;

			memcpy (image->filehdr,
			buff + from - offset,
			sizeof (win_imagefilehdr_t));

			sz_magic[0] = '\0';
			get_magic (buff + from - offset, sz_magic, 1024);

			if (strlen (sz_magic) != 0) {
				if (sess->magic != 0) free (sess->magic);
				sess->magic = malloc (strlen (sz_magic) + 1);

				strcpy (sess->magic, sz_magic);
				if (p_magicsize != 0)
					*p_magicsize = strlen (sz_magic) + 1;
			}
		}

		/*
		 * looking for optional-header
		 */
		if (image->opthdr32 == 0 && image->opthdr64 == 0) {
			int from;
			int to;

			from =
			image->peoffset + (int) sizeof (win_imagefilehdr_t);

			if (total <= from) {
				offset = total;
				continue;
			}

			if (image->filehdr->SizeOfOptionalHeaders == 224) {
				to = image->peoffset +
				(int) sizeof (win_imagefilehdr_t) +
				(int) sizeof (win_optionalhdr32_t);
				if (total < to) continue;

				image->opthdr32 =
				malloc (sizeof (win_optionalhdr32_t));

				if (image->opthdr32 == 0) break;

				memcpy (image->opthdr32,
				buff + from - offset,
				sizeof (win_optionalhdr32_t));
			} else {
				to = image->peoffset +
				(int) sizeof (win_imagefilehdr_t) +
				(int) sizeof (win_optionalhdr64_t);
				if (total < to) continue;

				image->opthdr64 =
				malloc (sizeof (win_optionalhdr64_t));

				if (image->opthdr64 == 0) break;

				memcpy (image->opthdr64,
				buff + from - offset,
				sizeof (win_optionalhdr64_t));
			}
		}

		/*
		 * looking for datadirectory
		 */
		if (image->datadir == 0) {
			int from;
			int to;
			int num_of_rva;

			if (image->opthdr32 != 0) {
				num_of_rva =
				image->opthdr32->NumberOfRvaAndSizes;

				from = image->peoffset +
				(int) sizeof (win_imagefilehdr_t) +
				sizeof (win_optionalhdr32_t);
			} else {
				num_of_rva =
				image->opthdr64->NumberOfRvaAndSizes;

				from = image->peoffset +
				(int) sizeof (win_imagefilehdr_t) +
				sizeof (win_optionalhdr64_t);
			}

			if (total <= from) {
				offset = total;
				continue;
			}

			to = from +
			num_of_rva * (int) sizeof (win_datadirectory_t);

			if (total < to) continue;

			image->datadir =
			malloc (num_of_rva * sizeof (win_datadirectory_t));

			if (image->datadir == 0) break;

			memcpy (image->datadir,
			buff + from - offset,
			num_of_rva  * sizeof (win_datadirectory_t));
		}

		/*
		 * looking for section headers
		 */
		if (image->sechdr == 0) {
			int from;
			int to;
			int entries;
			int num_of_rva;

			entries = image->filehdr->NumberOfSections;
			if (image->opthdr32 != 0) {
				num_of_rva =
				image->opthdr32->NumberOfRvaAndSizes;

				from = image->peoffset +
				(int) sizeof (win_imagefilehdr_t) +
				sizeof (win_optionalhdr32_t) +
				num_of_rva * (int) sizeof (win_datadirectory_t);
			} else {
				num_of_rva =
				image->opthdr64->NumberOfRvaAndSizes;

				from = image->peoffset +
				(int) sizeof (win_imagefilehdr_t) +
				sizeof (win_optionalhdr64_t) +
				num_of_rva * (int) sizeof (win_datadirectory_t);
			}

			if (total <= from) {
				offset = total;
				continue;
			}

			to = from +
			entries * (int) sizeof (win_sectionhdr_t);

			if (total < to) continue;

			image->sechdr =
			malloc (entries * sizeof (win_sectionhdr_t));

			if (image->sechdr == 0) break;

			memcpy (image->sechdr,
			buff + from - offset,
			entries  * sizeof (win_sectionhdr_t));

			calc_resoffset (image);
		}

		/*
		 * go to resource section
		 * and get versioninfo
		 */
		if (versioninfo == 0) {
			int from;
			int to;
			int ressize;

			if (image->res.offset == 0 && image->res.size == 0) {
				/*
				 * no resources found
				 */
				free (buff);
				free (image->doshdr);
				free (image->filehdr);
				free (image->opthdr32);
				free (image->opthdr64);
				free (image->sechdr);
				free (image->datadir);
				free (image);

				return 0;
			}

			from = image->res.offset;
			if (total <= from) {
				offset = total;
				continue;
			}

			to = image->res.offset + image->res.size;
			if (total < to) continue;

			ressize = 0;

			versioninfo = get_versionresource (
			buff + image->res.offset - offset,
			image->res.offset, 0, &ressize);

			sess->size = ressize;
			sess->buff = malloc (sess->size);
			sess->offset =
			virtual2real (image, versioninfo) -
			              (image->res.offset - offset);

			*p_size = sess->size;

			memcpy (sess->buff, buff + sess->offset, sess->size);

			free (buff);
			free (image->doshdr);
			free (image->filehdr);
			free (image->opthdr32);
			free (image->opthdr64);
			free (image->sechdr);
			free (image->datadir);
			free (image);

			return 0;
		}
		
		offset = total;
	}

	free (image->doshdr);
	free (image->filehdr);
	free (image->opthdr32);
	free (image->opthdr64);
	free (image->sechdr);
	free (image->datadir);
	free (image);

	free (buff);
	return 0;
}

static int
get_versionresource (char *resource,
                     int resoffset, int offset, int *p_ressize) {
	int i;
	int num_of_entries;

	win_resdirectory_t *resdir;
	win_resdirentry_t  *resentry;
	int infodata = 0;

	resdir = (win_resdirectory_t *) (resource + offset);

	num_of_entries =
	resdir->NumberOfIdEntries + resdir->NumberOfNamedEntries;

	resentry = (win_resdirentry_t *)
	(resource + offset + sizeof (win_resdirectory_t)); 

	for (i = 0; i < num_of_entries; i++) {
		if (offset == 0) {
			if (!(resentry[i].Name & 0x80000000L)) {
				/*
				 * next if it is it a versioninfo
				 */
				if ((resentry[i].Name & ~0x80000000L)  != 16) {
					continue;
				}
			}
		}

		if (resentry[i].OffsetToData & 0x80000000L) {
			infodata = get_versionresource (resource, resoffset,
			resentry[i].OffsetToData & ~0x80000000L, p_ressize);
		} else {
			win_resdataentry_t *dataentry;

			dataentry = (win_resdataentry_t *)
			            (resource + resentry[i].OffsetToData);

			dataentry->OffsetToData;
			
			*p_ressize = dataentry->Size;
			return (dataentry->OffsetToData);
		}
	}

	return (infodata);
}

void
calc_peoffset (win_image_t *image) {
	if (image->doshdr == 0)
		return;

	if (memcmp (&image->doshdr->e_magic, win_dosmagic,
	sizeof (win_dosmagic)) != 0)
		return;

	image->peoffset = image->doshdr->e_lfanew;
	return;
}

void
calc_resoffset (win_image_t *image) {
	int i;
	int va_image_dir;
	int image_dir = 2;
	int num_of_rva;

	if (image->filehdr->SizeOfOptionalHeaders == 224) {
		num_of_rva = image->opthdr32->NumberOfRvaAndSizes;
	} else {
		num_of_rva = image->opthdr64->NumberOfRvaAndSizes;
	}

	if (image_dir >= (int) (num_of_rva))
		return;

	va_image_dir = image->datadir[image_dir].VirtualAddress;

	for (i = 0; i < (int) (image->filehdr->NumberOfSections); i++) {
		int from;
		int to;

		from = (int) (image->sechdr[i].VirtualAddress);
		to = from + (int) (image->sechdr[i].SizeOfRawData);

		if (from <= va_image_dir && to > va_image_dir) break;
	}

    if (i >= image->filehdr->NumberOfSections)
        return;

    image->res.offset =
	(va_image_dir - image->sechdr[i].VirtualAddress +
	image->sechdr[i].PointerToRawData);

	image->res.size = image->sechdr[i].SizeOfRawData;

	return;
}

static int
virtual2real (win_image_t *image, int va) {
	int i;
	
	for (i = 0; i < (int) (image->filehdr->NumberOfSections); i++) {
		int from;
		int to;

		from = (int) (image->sechdr[i].VirtualAddress);
		to = from + (int) (image->sechdr[i].SizeOfRawData);

		if (from <= va && to > va)
			return (va - from);
	}

	return 0;
}

static int
equals (char *ascii, char *ucs2) {
	unsigned int i;

	for (i = 0; i < strlen (ascii); i++) {
		 if (ascii[i] != ((uint16_t *)ucs2)[i])
			return -1;
	}

	return 0;
}

static int
ascii_toupper (int c) {
	if (c >= 'a' && c <= 'z')
		return (c - ('a' - 'A'));

	return (c);
}

static int
get_string (char *raw, int rawsize, int offset,
char *desc, char **info, int *infosize) {
	win_string_t *s;
	char *key;
	char *val;

	if (offset >= rawsize)
		return 0;

	s = (win_string_t *) (raw + offset);

	key = ((char *) s) + sizeof (win_string_t);  

	if (strlen (desc) > 0 && equals (desc, key) == 0) {
		val = key + 2 * (strlen (desc) + 1);
		if ((ptr_t) val % 4 != 0) {
			val += 4 - ((ptr_t) val % 4);
		}

		*infosize = s->ValueSize;
		*info = val;
		return 0;
	}

	offset += s->Size;
	if (offset % 4 != 0) {
		offset += 4 - offset % 4;
	}

	return (get_string (raw, rawsize, offset, desc, info, infosize));
}

static int
get_stringtable (char *raw, int rawsize, int offset,
char *desc, char **info, int *infosize) {
	int string;
	int size;
	int rc;
	win_stringtable_t *st;

	if (offset >= rawsize)
		return 0;

	st = (win_stringtable_t *) (raw + offset);

	if (offset + st->Size > rawsize)
		return 0;

	string = offset + sizeof (win_stringtable_t);
	if (string % 4 != 0) {
		string += 4 - string % 4;
	}
	size = st->Size - (string - offset);

	if (strlen (desc) > 9 &&
	desc[0] == ascii_toupper (st->Key[0]) &&
	desc[1] == ascii_toupper (st->Key[1]) &&
	desc[2] == ascii_toupper (st->Key[2]) &&
	desc[3] == ascii_toupper (st->Key[3]) &&
	desc[4] == ascii_toupper (st->Key[4]) &&
	desc[5] == ascii_toupper (st->Key[5]) &&
	desc[6] == ascii_toupper (st->Key[6]) &&
	desc[7] == ascii_toupper (st->Key[7]) &&
	desc[8] == '\\') {
		desc += 9;
		rc = get_string (raw + string, size, 0, desc, info, infosize);
	}

	rc = get_stringtable
	(raw, rawsize, offset + st->Size, desc, info, infosize);

	return (rc);
}

static int
get_fileinfo (char *raw, int rawsize, int offset, char *desc,
char **info, int *infosize) {
	int rc;
	win_versioninfo_t *vi;
	win_varfileinfo_t *vfi;
	win_stringfileinfo_t *sfi;

	if (offset >= rawsize)
		return 0;

	/*
	 * VS_VERSIONINFO structure
	 */
	vi = (win_versioninfo_t *) (raw + offset);
	if (memcmp (vi->Magic, win_versioninfo_magic,
	sizeof (win_versioninfo_magic)) == 0) {
		if (offset != 0)
			return 0;

		if (vi->Size != rawsize)
			return 0;

		offset = sizeof (win_versioninfo_t);
		if (offset % 4 != 0) {
			offset += 4 - offset % 4;
		}

		offset += vi->ValueSize;
		if (offset % 4 != 0) {
			offset += 4 - offset % 4;
		}

		rc = get_fileinfo (raw, rawsize, offset, desc, info, infosize);
		return (rc);
	}

	/*
	 * VarFileInfo structure
	 */
	vfi = (win_varfileinfo_t *) (raw + offset);
	if (memcmp (vfi->Magic, win_varfileinfo_magic,
	sizeof (win_varfileinfo_magic)) == 0) {
		if (offset + vfi->Size > rawsize)
			return 0;

		offset += vfi->Size;
		
		rc = get_fileinfo (raw, rawsize, offset, desc, info, infosize);
		return (rc);
	}

	/*
	 * StringFileInfo structure 
	 */
	sfi = (win_stringfileinfo_t *) (raw + offset);
	if (memcmp (sfi->Magic, win_stringfileinfo_magic,
		sizeof (win_stringfileinfo_magic)) == 0) {
		char *inforoot = "\\StringFileInfo";
		int stringtable;
		int size;

		/*
		 * we are interested in StringFileInfo
		 */
		if (memcmp (desc, inforoot, strlen (inforoot)) == 0) {
			stringtable = offset + sizeof (win_stringfileinfo_t);
			if (stringtable % 4 != 0) {
				stringtable += 4 - stringtable % 4;
			}

			size = sfi->Size - (stringtable - offset);
			desc += strlen (inforoot) + 1;
			rc = get_stringtable
			(raw + stringtable, size, 0, desc, info, infosize);

			if (*info != 0 && *infosize != 0)
				return (rc);
		}

		if (offset + sfi->Size > rawsize)
			return 0;

		offset += sfi->Size;

		rc = get_fileinfo (raw, rawsize, offset, desc, info, infosize);
		return (rc);
	}

	return 0;
}

static int
version_query_value (char * raw, char *desc, void **info, int *infosize) {
	int rc;
	uint16_t rawsize;

	*info = 0;
	*infosize = 0;

	rawsize = * (uint16_t *) raw;
	rc = get_fileinfo (raw, rawsize, 0, desc, (char **) info, infosize);

	return (rc);
}

static char *
convert_slashes (char *filename) {
	unsigned int i;
	/*
	 * convert slashes in filename
	 */
	for (i = 0; i <= strlen (filename); i++) {
		if (filename[i] == '/') filename[i] ='\\';
	}

	return (filename);
}

static char *
get_sysversioninfo (handle_t handle, void *func) {
	int i;
	void *raw;
	int raw_size;
	void *untrans;
	int untrans_size;
	char *ascii;

	ascii = 0;

	/*
	 * look for version information
	 */
	get_versioninfo (handle, func, 0, &raw_size, 0, 0);

	raw = malloc (raw_size);
	if (raw == 0)
		return 0;

	get_versioninfo (handle, func, raw, &raw_size, 0, 0);

	/*
	 * first try us-english ascii
	 */
	untrans = 0;
	version_query_value
	(raw, "\\StringFileInfo\\040904E4\\FileVersion",
	&untrans, &untrans_size);

	/*
	 * then us-english unicode
	 */
	if (untrans_size == 0) {
		version_query_value
		(raw, "\\StringFileInfo\\040904B0\\FileVersion",
		&untrans, &untrans_size);
	}

	/*
	 * or give up
	 */
	if (untrans_size == 0) {
		free (raw);
		return 0;
	}

	ascii = malloc (untrans_size);
	if (ascii == 0) {
		free (raw);
		return 0;
	}

	for (i = 0; i < untrans_size; i++) {
		ascii[i] = (char) ((uint16_t *)untrans)[i];
	}

	free (raw);
	return (ascii);
}
#endif

#ifdef UNIX
#define convert_slashes(a) (a)

static char *
get_versioninfo (void *handle, void *func,
	char *resinfo, int *p_size, char *magic, int *p_magicsize) {

	*p_size = 0;
	*p_magicsize = 0;
	return 0;
}

static int
version_query_value (char * raw, char *desc, void **info, int *infosize) {
	*infosize = 0;
	return 0;
}

static char *
get_sysversioninfo (handle_t fd, void *func) {
	return 0;
}
#endif

MODULE = SAPDB::Install::System::Win32::VersionInfo	PACKAGE = SAPDB::Install::System::Win32::VersionInfo

PROTOTYPES: DISABLE

SV *
GetVersionInfo (...)
PREINIT:
	char *rc;
	versioninfo_param_t *param;
PPCODE:
	rc = 0;

	if (items == 1) {
		param = (versioninfo_param_t *)(SvIV(ST(0)));

		if (param != 0) {
			rc = get_versioninfo (
				param->handle, param->func,
				param->resinfo, param->p_size,
				param->magic, param->p_magicsize);
		}
	}

	XPUSHs (sv_2mortal (newSViv ((ptr_t) rc)));
	XSRETURN (1);

SV *
QueryVersionValue (...)
PREINIT:
	int rc;
	versionquery_param_t *param;
PPCODE:
	rc = 0;

	if (items == 1) {
		param = (versionquery_param_t *)(SvIV(ST(0)));

		if (param != 0) {
			rc = version_query_value (
				param->raw, param->desc,
				param->info, param->infosize);
		}
	}

	XPUSHs (sv_2mortal (newSViv (rc)));
	XSRETURN (1);

SV *
SysVersionInfo (...)
PREINIT:
	char *info;
PPCODE:
	info = 0;

	if (items == 1) {
		if ((sv_isobject (ST(0)) && (SvTYPE (SvRV (ST(0))) == SVt_PVHV))) {
			info = get_sysversioninfo (ST(0), (void *) &untgzread);
		} else {
			handle_t fd;
			char *filename;

			filename = convert_slashes ((char *) SvPV (ST (0), PL_na));
			fd = myopen (filename, O_RDONLY);
			info = get_sysversioninfo (fd, (void *) &myread);
			myclose (fd);
		}
	}

	if (info == 0) {
		XPUSHs (sv_2mortal (newSVpv ("", 0)));
	} else {
		XPUSHs (sv_2mortal (newSVpv (info, strlen (info))));
		free (info);
	}

	XSRETURN (1);
